

# Netdot Python API Environment Variables
<a id="netdot-python-api-environment-variables"></a>

> Generated using `netdot.defaults.help()`
>
> Version 0.4.0 documentation generated on Nov 10, 2023 at 07:54AM 

```
usage: __main__.py [-h] [--terse TERSE] [--server-url SERVER_URL]
                   [--truncate-min TRUNCATE_MIN_CHARS]
                   [--terse-col-width TERSE_COL_WIDTH]
                   [--terse-max-chars TERSE_MAX_CHARS] [--skip-ssl SKIP_SSL]
                   [--timeout TIMEOUT]
                   [--raise-parse-errors RAISE_PARSE_ERRORS]
                   [--warn-missing-fields WARN_MISSING_FIELDS]
                   [--threads THREADS] [--trace-downloads TRACE_DOWNLOADS]
                   [--trace-threshold TRACE_THRESHOLD]
                   [--save-as-file-on-error SAVE_AS_FILE_ON_ERROR]
                   [--error-pickle-filename ERROR_PICKLE_FILENAME]

optional arguments:
  -h, --help            show this help message and exit
  --terse TERSE         Print terse output (that generally tries to fit the
                        screen width). [env var: NETDOT_CLI_TERSE]
  --server-url SERVER_URL
                        The URL of the Netdot server. [env var:
                        NETDOT_CLI_SERVER_URL]
  --truncate-min TRUNCATE_MIN_CHARS
                        The absolute minimum number of characters to print
                        before truncating. [env var:
                        NETDOT_CLI_TRUNCATE_MIN_CHARS]
  --terse-col-width TERSE_COL_WIDTH
                        The number of characters to use for each column when
                        printing terse output. [env var:
                        NETDOT_CLI_TERSE_COL_WIDTH]
  --terse-max-chars TERSE_MAX_CHARS
                        The maximum number of characters to print before
                        truncating. [env var: NETDOT_CLI_TERSE_MAX_CHARS]
  --skip-ssl SKIP_SSL   Skip SSL verification when making API requests. [env
                        var: NETDOT_CLI_SKIP_SSL]
  --timeout TIMEOUT     The number of seconds to wait for a response from the
                        API server. Note: "timeout is not a time limit on the
                        entire response download; rather, an exception is
                        raised if the server has not issued a response for
                        timeout seconds (more precisely, if no bytes have been
                        received on the underlying socket for timeout
                        seconds). If no timeout is specified explicitly,
                        requests do not time out." (from
                        requests.readthedocs.io) [env var: NETDOT_CLI_TIMEOUT]
  --raise-parse-errors RAISE_PARSE_ERRORS
                        Raise an exception if there is an error parsing the
                        response from the API server. [env var:
                        NETDOT_CLI_RAISE_PARSE_ERRORS]
  --warn-missing-fields WARN_MISSING_FIELDS
                        Warn if a field is missing from the response from the
                        API server. [env var: NETDOT_CLI_WARN_MISSING_FIELDS]
  --threads THREADS     The number of threads to use when making API GET
                        requests. [env var: NETDOT_CLI_THREADS]
  --trace-downloads TRACE_DOWNLOADS
                        Intermittently log an "INFO" message saying how many
                        bytes have been downloaded from Netdot. Useful for
                        long-running download tasks. (Note: This *is* thread-
                        safe.) [env var: NETDOT_CLI_TRACE_DOWNLOADS]
  --trace-threshold TRACE_THRESHOLD
                        See TRACE_DOWNLOADS above. This threshold determines
                        how often messages should be logged -- the number of
                        bytes downloaded from Netdot before a log message is
                        printed. [env var: NETDOT_CLI_TRACE_THRESHOLD]
  --save-as-file-on-error SAVE_AS_FILE_ON_ERROR
                        (Try to) Save the proposed changes to a file when an
                        error occurs. [env var:
                        NETDOT_CLI_SAVE_AS_FILE_ON_ERROR]
  --error-pickle-filename ERROR_PICKLE_FILENAME
                        The filename to use when saving proposed changes to a
                        file when an error occurs. (timestamp based on when
                        the script is run) [env var:
                        NETDOT_CLI_ERROR_PICKLE_FILENAME]

 In general, command-line values override environment variables which override
defaults.


> ⚠ NOTICE: These defaults are read from Environment Variables when this `netdot.defaults` module loads.
> Look for "[env var: NETDOT_CLI_...]" above to discover the available Environment Variables.
>
> Example: `export NETDOT_CLI_TERSE=True`
>
> Alternately, override these defaults by setting `netdot.defaults.<ENV_VAR_NAME>` directly in your code.
>
> Example: `netdot.defaults.TERSE=True`

```
