<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">from dataclasses import dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">from enum import IntEnum</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">from typing import Iterable, Tuple, TypeVar, ClassVar</td></tr><tr class="noCover"><td class="line"><a name="4">4</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">import netdot</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from netdot import defaults</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from netdot.dataclasses import NetdotAPIDataclass</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="10">10</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">U &#61; TypeVar(&#39;U&#39;, bound&#61;&#39;netdot.NetdotAPIDataclass&#39;)</td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="13">13</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">class ActionTypes(IntEnum):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">    CREATE &#61; 1</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="16">16</a></td><td class="hits">1</td><td class="code">    UPDATE &#61; 2</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">    DELETE &#61; 3</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">    def __repr__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">        return f&#39;{self.__class__.__name__}.{self.name}&#39;</td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="23">23</a></td><td class="hits">1</td><td class="code">def diff_string(old: str, new: str) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Create a &#39;diff string&#39; if a pair of strings have any differences.</td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code">    The intention is to be able to provide a useful text representation of a diff that</td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code">    fits well into a CSV format.</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code">        old (str): The old string</td></tr><tr class="noCover"><td class="line"><a name="31">31</a></td><td class="hits"></td><td class="code">        new (str): The new string.</td></tr><tr class="noCover"><td class="line"><a name="32">32</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code">        str: If &#39;new&#39; and &#39;old&#39; are different, return &#34;[-old-]&#43;new&#43;&#34;. (Otherwise, return the old string).</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="36">36</a></td><td class="hits">1</td><td class="code">    if new &#61;&#61; old:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">        return old</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="38">38</a></td><td class="hits">1</td><td class="code">    elif old:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">        return f&#39;[-{old}-]&#43;{new}&#43;&#39;</td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code">    else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">        return f&#39;&#43;{new}&#43;&#39;</td></tr><tr class="noCover"><td class="line"><a name="42">42</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="44">44</a></td><td class="hits">1</td><td class="code">&#64;dataclass(frozen&#61;True)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">class NetdotAction(CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">    action_type: ActionTypes</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    id: int</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="48">48</a></td><td class="hits">1</td><td class="code">    new_data: NetdotAPIDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">    old_data: NetdotAPIDataclass</td></tr><tr class="noCover"><td class="line"><a name="50">50</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    def table_header(self) -&gt; Tuple[str, ...]:</td></tr><tr class="noCover"><td class="line"><a name="52">52</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Return a list of columns, to be used as a table header for objects of this class.</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code">        &gt; Works will with the as_table_row() method.</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="57">57</a></td><td class="hits"></td><td class="code">            Tuple[str,...]: A list of columns.</td></tr><tr class="noCover"><td class="line"><a name="58">58</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="59">59</a></td><td class="hits">0</td><td class="code">        data &#61; self.new_data if self.new_data else self.old_data</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="60">60</a></td><td class="hits">0</td><td class="code">        header &#61; [&#39;action&#39;] &#43; list(data.table_header())</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="61">61</a></td><td class="hits">0</td><td class="code">        return tuple(header)</td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">    def as_table_row(self, select_columns: Iterable[str] &#61; None, maxchars&#61;defaults.TERSE_MAX_CHARS) -&gt; Tuple[str, ...]:</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Return a representation of this action as a table row (tuple).</td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">            select_columns (Iterable[str], optional): Which attributes of this object to be returned. Defaults to &#96;table_header()&#96; if None provided.</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code">            Tuple[str, ...]: String representations of the attributes of this object.</td></tr><tr class="noCover"><td class="line"><a name="71">71</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">        return [self.action_type.name] &#43; [str(datum)[:maxchars] for datum in self._as_table_row(select_columns)]</td></tr><tr class="noCover"><td class="line"><a name="73">73</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="74">74</a></td><td class="hits">1</td><td class="code">    def generate_log_for_action(self, truncate&#61;None, completed&#61;False) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate a log message for this action.</td></tr><tr class="noCover"><td class="line"><a name="76">76</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="77">77</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="78">78</a></td><td class="hits"></td><td class="code">            truncate (int, optional): Truncate the message to this many characters. Defaults to None.</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code">            completed (bool, optional): Whether the action has been completed. Defaults to False.</td></tr><tr class="noCover"><td class="line"><a name="80">80</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="81">81</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code">            str: A log message indicating exactly what will change if this action is (was) completed.</td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">        take_action &#61; self.action_type.name</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="85">85</a></td><td class="hits">1</td><td class="code">        object_type &#61; (</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code">            self.old_data.__class__.__name__</td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code">            if self.action_type &#61;&#61; ActionTypes.DELETE</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">            else self.new_data.__class__.__name__</td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">        data &#61; (</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">            self.old_data if self.action_type &#61;&#61; ActionTypes.DELETE else self.new_data</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">        first_word &#61; &#39;Will&#39; if not completed else &#39;Finished&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="94">94</a></td><td class="hits">1</td><td class="code">        message &#61; f&#39;{first_word} {take_action} {object_type}: {data}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="95">95</a></td><td class="hits">1</td><td class="code">        if self.action_type &#61;&#61; ActionTypes.UPDATE:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="96">96</a></td><td class="hits">1</td><td class="code">            message &#43;&#61; f&#34; (replacing: {self.old_data})&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="97">97</a></td><td class="hits">1</td><td class="code">        if truncate:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="98">98</a></td><td class="hits">1</td><td class="code">            truncate &#61; max(defaults.TRUNCATE_MIN_CHARS, truncate)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="99">99</a></td><td class="hits">1</td><td class="code">            truncate &#61; truncate - len(&#39;...&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="100">100</a></td><td class="hits">1</td><td class="code">            if len(message) &lt; truncate:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="101">101</a></td><td class="hits">1</td><td class="code">                return message</td></tr><tr class="noCover"><td class="line"><a name="102">102</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">                return message[:truncate]&#43;&#39;...&#39;</td></tr><tr class="noCover"><td class="line"><a name="104">104</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="106">106</a></td><td class="hits">1</td><td class="code">            return message</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="108">108</a></td><td class="hits">1</td><td class="code">    def _as_table_row(self, fields&#61;None) -&gt; Tuple[str, ...]:</td></tr><tr class="noCover"><td class="line"><a name="109">109</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Represent this action as a table row, ordered per &#96;table_header&#96; property.</td></tr><tr class="noCover"><td class="line"><a name="110">110</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="111">111</a></td><td class="hits"></td><td class="code">        &gt; Works well with the table_header Class Property.</td></tr><tr class="noCover"><td class="line"><a name="112">112</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="113">113</a></td><td class="hits"></td><td class="code">        If there is a difference, the &#39;diff&#39; is represented according to the</td></tr><tr class="noCover"><td class="line"><a name="114">114</a></td><td class="hits"></td><td class="code">        netdot.actions.diff_string() function.&#61;</td></tr><tr class="noCover"><td class="line"><a name="115">115</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="116">116</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="117">117</a></td><td class="hits"></td><td class="code">            Tuple: Representation of this action as a row of data.</td></tr><tr class="noCover"><td class="line"><a name="118">118</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">        as_table_row_methods &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="120">120</a></td><td class="hits"></td><td class="code">            ActionTypes.CREATE: self._as_table_row_CREATE,</td></tr><tr class="noCover"><td class="line"><a name="121">121</a></td><td class="hits"></td><td class="code">            ActionTypes.DELETE: self._as_table_row_DELETE,</td></tr><tr class="noCover"><td class="line"><a name="122">122</a></td><td class="hits"></td><td class="code">            ActionTypes.UPDATE: self._as_table_row_UPDATE,</td></tr><tr class="noCover"><td class="line"><a name="123">123</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="124">124</a></td><td class="hits">1</td><td class="code">        return tuple(as_table_row_methods[self.action_type](fields))</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="126">126</a></td><td class="hits">1</td><td class="code">    def _as_table_row_DELETE(self, fields&#61;None):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="127">127</a></td><td class="hits">1</td><td class="code">        if not fields:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="128">128</a></td><td class="hits">0</td><td class="code">            fields &#61; self.old_data.table_header()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="129">129</a></td><td class="hits">1</td><td class="code">        ret &#61; [getattr(self.old_data, field) for field in fields]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="130">130</a></td><td class="hits">1</td><td class="code">        return ret</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="132">132</a></td><td class="hits">1</td><td class="code">    def _as_table_row_UPDATE(self, fields&#61;None):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="133">133</a></td><td class="hits">1</td><td class="code">        if not fields:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="134">134</a></td><td class="hits">0</td><td class="code">            fields &#61; self.old_data.table_header()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="135">135</a></td><td class="hits">1</td><td class="code">        ret &#61; [</td></tr><tr class="noCover"><td class="line"><a name="136">136</a></td><td class="hits"></td><td class="code">            diff_string(getattr(self.old_data, field), getattr(self.new_data, field))</td></tr><tr class="noCover"><td class="line"><a name="137">137</a></td><td class="hits"></td><td class="code">            for field in fields</td></tr><tr class="noCover"><td class="line"><a name="138">138</a></td><td class="hits"></td><td class="code">        ]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">        return ret</td></tr><tr class="noCover"><td class="line"><a name="140">140</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="141">141</a></td><td class="hits">1</td><td class="code">    def _as_table_row_CREATE(self, fields&#61;None):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="142">142</a></td><td class="hits">1</td><td class="code">        if not fields:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="143">143</a></td><td class="hits">0</td><td class="code">            fields &#61; self.new_data.table_header()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="144">144</a></td><td class="hits">1</td><td class="code">        ret &#61; [getattr(self.new_data, field) for field in fields]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="145">145</a></td><td class="hits">1</td><td class="code">        return ret</td></tr>