<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">from contextlib import AbstractContextManager</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">from typing import Any, Dict, List</td></tr><tr class="noCover"><td class="line"><a name="4">4</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">import urllib3</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">import requests</td></tr><tr class="noCover"><td class="line"><a name="7">7</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from . import exceptions, parse, trace, validate, utils, defaults</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="13">13</a></td><td class="hits"></td><td class="code"># TODO Eventually collapse v1 into the &#34;Client&#34; class below -- or make this into a different layer entirely</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">class Client_v1(AbstractContextManager):</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;NetDot Client_v1 (to be deprecated) -- provides access to NetDot data directly as dicts.&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">    def __init__(self, server, username, password, verify_ssl&#61;(not defaults.SKIP_SSL), timeout&#61;defaults.TIMEOUT):</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Connect to a Netdot Server to begin making API requests.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">        self.user &#61; username</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">        self.timeout &#61; timeout</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="21">21</a></td><td class="hits">1</td><td class="code">        self.http &#61; requests.session()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="22">22</a></td><td class="hits">1</td><td class="code">        self.http.verify &#61; verify_ssl</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="23">23</a></td><td class="hits">1</td><td class="code">        self.http.headers.update(</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code">            {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code">                &#39;User_Agent&#39;: &#39;Netdot::Client::REST/self.version&#39;,</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code">                &#39;Accept&#39;: &#39;text/xml; version&#61;1.0&#39;,</td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code">            }</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code">        # Setup URLs</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">        self.server &#61; server</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">        self.base_url &#61; f&#39;{server}/rest&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">        self.login_url &#61; f&#39;{server}/NetdotLogin&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">        self.logout_url &#61; f&#39;{server}/logout.html&#39;</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">        # Actually login (and load a test page)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">        self._login(username, utils.HiddenString(password))</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code">    def __exit__(self):  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code">        self.logout()</td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">    def _login(self, username, password):</td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Log into the NetDot API with provided credentials.</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">        Stores the generated cookies to be reused in future API calls.</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">        params &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="47">47</a></td><td class="hits"></td><td class="code">            &#39;destination&#39;: &#39;index.html&#39;,</td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">            &#39;credential_0&#39;: username,</td></tr><tr class="noCover"><td class="line"><a name="49">49</a></td><td class="hits"></td><td class="code">            &#39;credential_1&#39;: password,</td></tr><tr class="noCover"><td class="line"><a name="50">50</a></td><td class="hits"></td><td class="code">            &#39;permanent_session&#39;: 1,</td></tr><tr class="noCover"><td class="line"><a name="51">51</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">        response &#61; self.http.post(self.login_url, data&#61;params, timeout&#61;self.timeout)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="53">53</a></td><td class="hits">1</td><td class="code">        if response.status_code !&#61; 200:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="54">54</a></td><td class="hits">0</td><td class="code">            raise exceptions.NetdotLoginError(</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code">                f&#39;Invalid credentials for user: {username}&#39;</td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="57">57</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">    def logout(self):</td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="60">60</a></td><td class="hits"></td><td class="code">        Logout of the NetDot API (and cleanup local http session)</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="62">62</a></td><td class="hits">1</td><td class="code">        self.http.post(self.logout_url, timeout&#61;self.timeout)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">        self.http.close()</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="65">65</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="66">66</a></td><td class="hits">1</td><td class="code">    def validate_response(response):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="67">67</a></td><td class="hits">1</td><td class="code">        Client.warn_if_carp_croak(response)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="68">68</a></td><td class="hits">1</td><td class="code">        logger.debug(f&#39;HTTP Response: {response}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="69">69</a></td><td class="hits">1</td><td class="code">        response.raise_for_status()</td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">    def warn_if_carp_croak(response):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">        if response.text and &#39;Carp::croak&#39; in response.text:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="74">74</a></td><td class="hits">0</td><td class="code">            lines &#61; response.text.split(&#39;\n&#39;)</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="75">75</a></td><td class="hits">0</td><td class="code">            for line_num in range(len(lines)):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="76">76</a></td><td class="hits">0</td><td class="code">                if &#39;Carp::croak&#39; in lines[line_num]:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="77">77</a></td><td class="hits">0</td><td class="code">                    logger.warning(&#39;Response includes possible error:&#39; </td></tr><tr class="noCover"><td class="line"><a name="78">78</a></td><td class="hits"></td><td class="code">                                   &#43; &#39;\n&#39;.join(lines[line_num-3:line_num]))</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">    def get_xml(self, url):</td></tr><tr class="noCover"><td class="line"><a name="81">81</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code">        This function provides a simple interface</td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code">        into the &#34;GET&#34; function by handling the authentication</td></tr><tr class="noCover"><td class="line"><a name="84">84</a></td><td class="hits"></td><td class="code">        cookies as well as the required headers and base_url for</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code">        each request.</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">          url -- Url to append to the base url</td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="90">90</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">          response &#61; netdot.Client.get_xml(&#34;/url&#34;)</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="93">93</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="94">94</a></td><td class="hits"></td><td class="code">          XML string output from Netdot</td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="96">96</a></td><td class="hits">1</td><td class="code">        response &#61; self.http.get(self.base_url &#43; url, timeout&#61;self.timeout)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="97">97</a></td><td class="hits">1</td><td class="code">        self.validate_response(response)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="98">98</a></td><td class="hits">1</td><td class="code">        return response.content</td></tr><tr class="noCover"><td class="line"><a name="99">99</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="100">100</a></td><td class="hits">1</td><td class="code">    def get(self, url_path, **url_params):</td></tr><tr class="noCover"><td class="line"><a name="101">101</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="102">102</a></td><td class="hits"></td><td class="code">        This function delegates to get_xml() and parses the</td></tr><tr class="noCover"><td class="line"><a name="103">103</a></td><td class="hits"></td><td class="code">        response xml to return a dict</td></tr><tr class="noCover"><td class="line"><a name="104">104</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="106">106</a></td><td class="hits"></td><td class="code">          url -- Url to append to the base url</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="108">108</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="109">109</a></td><td class="hits"></td><td class="code">          dict &#61; netdot.Client.get(&#34;/url&#34;)</td></tr><tr class="noCover"><td class="line"><a name="110">110</a></td><td class="hits"></td><td class="code">          dict &#61; netdot.Client.get(&#34;/url&#34;, depth&#61;2)</td></tr><tr class="noCover"><td class="line"><a name="111">111</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="112">112</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="113">113</a></td><td class="hits"></td><td class="code">          Result as a multi-level dictionary on success.</td></tr><tr class="noCover"><td class="line"><a name="114">114</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="115">115</a></td><td class="hits">1</td><td class="code">        final_url &#61; url_path</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="116">116</a></td><td class="hits">1</td><td class="code">        if url_params:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="117">117</a></td><td class="hits">1</td><td class="code">            url_params_list &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="118">118</a></td><td class="hits">1</td><td class="code">            for field, value in url_params.items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">                url_params_list.append(f&#39;{field}&#61;{value}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="120">120</a></td><td class="hits">1</td><td class="code">            url_params_str &#61; &#39;&amp;&#39;.join(url_params_list)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="121">121</a></td><td class="hits">1</td><td class="code">            final_url &#61; f&#39;{url_path}?{url_params_str}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="122">122</a></td><td class="hits">1</td><td class="code">        return parse.RESTful_XML(self.get_xml(final_url))</td></tr><tr class="noCover"><td class="line"><a name="123">123</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="124">124</a></td><td class="hits">1</td><td class="code">    def get_objects_by_filter(self, object, field, value, **url_params):</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="126">126</a></td><td class="hits"></td><td class="code">        Returns a multi-level dict of an objects (device, interface, rr, person)</td></tr><tr class="noCover"><td class="line"><a name="127">127</a></td><td class="hits"></td><td class="code">        filtered by an object field/attribute</td></tr><tr class="noCover"><td class="line"><a name="128">128</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="129">129</a></td><td class="hits"></td><td class="code">          object -- NetDot object ID</td></tr><tr class="noCover"><td class="line"><a name="130">130</a></td><td class="hits"></td><td class="code">          field -- NetDot field/attribute of object</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code">          value -- The value to select from the field.</td></tr><tr class="noCover"><td class="line"><a name="132">132</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="133">133</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="134">134</a></td><td class="hits"></td><td class="code">          List[Dict]: List of objects that match the filter.</td></tr><tr class="noCover"><td class="line"><a name="135">135</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="136">136</a></td><td class="hits">1</td><td class="code">        url_params[field] &#61; value</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="137">137</a></td><td class="hits">1</td><td class="code">        return self.get(f&#39;/{object}&#39;, **url_params)</td></tr><tr class="noCover"><td class="line"><a name="138">138</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">    def post(self, url, data):</td></tr><tr class="noCover"><td class="line"><a name="140">140</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="141">141</a></td><td class="hits"></td><td class="code">        This function provides a simple interface</td></tr><tr class="noCover"><td class="line"><a name="142">142</a></td><td class="hits"></td><td class="code">        into the &#34;POST&#34; function by handling the authentication</td></tr><tr class="noCover"><td class="line"><a name="143">143</a></td><td class="hits"></td><td class="code">        cookies as well as the required headers and base_url for</td></tr><tr class="noCover"><td class="line"><a name="144">144</a></td><td class="hits"></td><td class="code">        each request.</td></tr><tr class="noCover"><td class="line"><a name="145">145</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="146">146</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="147">147</a></td><td class="hits"></td><td class="code">          url -- Url to append to the base url</td></tr><tr class="noCover"><td class="line"><a name="148">148</a></td><td class="hits"></td><td class="code">          data -- dict of key/value pairs that the form requires</td></tr><tr class="noCover"><td class="line"><a name="149">149</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="150">150</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="151">151</a></td><td class="hits"></td><td class="code">          response &#61; netdot.Client.post(&#34;/url&#34;, {form-data})</td></tr><tr class="noCover"><td class="line"><a name="152">152</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="153">153</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="154">154</a></td><td class="hits"></td><td class="code">          Result as a multi-level dictionary on success</td></tr><tr class="noCover"><td class="line"><a name="155">155</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="156">156</a></td><td class="hits">1</td><td class="code">        response &#61; self.http.post(self.base_url &#43; url, data&#61;data, timeout&#61;self.timeout)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="157">157</a></td><td class="hits">1</td><td class="code">        self.validate_response(response)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="158">158</a></td><td class="hits">1</td><td class="code">        validate.RESTful_XML(response.content)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="159">159</a></td><td class="hits">1</td><td class="code">        return parse.RESTful_XML(response.content)</td></tr><tr class="noCover"><td class="line"><a name="160">160</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="161">161</a></td><td class="hits">1</td><td class="code">    def delete(self, url):</td></tr><tr class="noCover"><td class="line"><a name="162">162</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="163">163</a></td><td class="hits"></td><td class="code">        This function provides a simple interface</td></tr><tr class="noCover"><td class="line"><a name="164">164</a></td><td class="hits"></td><td class="code">        into the &#34;HTTP/1.0 DELETE&#34; function by handling the authentication</td></tr><tr class="noCover"><td class="line"><a name="165">165</a></td><td class="hits"></td><td class="code">        cookies as well as the required headers and base_url for</td></tr><tr class="noCover"><td class="line"><a name="166">166</a></td><td class="hits"></td><td class="code">        each request.</td></tr><tr class="noCover"><td class="line"><a name="167">167</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="168">168</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="169">169</a></td><td class="hits"></td><td class="code">          url -- Url to append to the base url</td></tr><tr class="noCover"><td class="line"><a name="170">170</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="171">171</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="172">172</a></td><td class="hits"></td><td class="code">          response &#61; netdot.Client.delete(&#34;/url&#34;)</td></tr><tr class="noCover"><td class="line"><a name="173">173</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="174">174</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="175">175</a></td><td class="hits"></td><td class="code">          Result as an empty multi-level dictionary</td></tr><tr class="noCover"><td class="line"><a name="176">176</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="177">177</a></td><td class="hits">1</td><td class="code">        response &#61; self.http.delete(self.base_url &#43; url, timeout&#61;self.timeout)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="178">178</a></td><td class="hits">1</td><td class="code">        self.validate_response(response)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="179">179</a></td><td class="hits">1</td><td class="code">        return response.content</td></tr><tr class="noCover"><td class="line"><a name="180">180</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="181">181</a></td><td class="hits">1</td><td class="code">    def create_object(self, object, data):</td></tr><tr class="noCover"><td class="line"><a name="182">182</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="183">183</a></td><td class="hits"></td><td class="code">        Create object record when it&#39;s parameters are known.</td></tr><tr class="noCover"><td class="line"><a name="184">184</a></td><td class="hits"></td><td class="code">        Parameters are passed as key:value pairs in a dictionary</td></tr><tr class="noCover"><td class="line"><a name="185">185</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="186">186</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="187">187</a></td><td class="hits"></td><td class="code">          data -- key:value pairs applicable for an object:</td></tr><tr class="noCover"><td class="line"><a name="188">188</a></td><td class="hits"></td><td class="code">                  (e.g. a device below)</td></tr><tr class="noCover"><td class="line"><a name="189">189</a></td><td class="hits"></td><td class="code">                name:                 &#39;devicename&#39;</td></tr><tr class="noCover"><td class="line"><a name="190">190</a></td><td class="hits"></td><td class="code">                snmp_managed:         &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="191">191</a></td><td class="hits"></td><td class="code">                snmp_version:         &#39;1 or 2 or 3&#39;</td></tr><tr class="noCover"><td class="line"><a name="192">192</a></td><td class="hits"></td><td class="code">                community:            &#39;SNMP community&#39;</td></tr><tr class="noCover"><td class="line"><a name="193">193</a></td><td class="hits"></td><td class="code">                snmp_polling:         &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="194">194</a></td><td class="hits"></td><td class="code">                canautoupdate:        &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="195">195</a></td><td class="hits"></td><td class="code">                collect_arp:          &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="196">196</a></td><td class="hits"></td><td class="code">                collect_fwt:          &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="197">197</a></td><td class="hits"></td><td class="code">                collect_stp:          &#39;0 or 1&#39;</td></tr><tr class="noCover"><td class="line"><a name="198">198</a></td><td class="hits"></td><td class="code">                info:                 &#39;Description string&#39;</td></tr><tr class="noCover"><td class="line"><a name="199">199</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="200">200</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="201">201</a></td><td class="hits"></td><td class="code">          response &#61; netdot.Client.create_device(&#34;device&#34;,</td></tr><tr class="noCover"><td class="line"><a name="202">202</a></td><td class="hits"></td><td class="code">                                                 {&#39;name&#39;:&#39;my-device&#39;,</td></tr><tr class="noCover"><td class="line"><a name="203">203</a></td><td class="hits"></td><td class="code">                                                  &#39;snmp_managed&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="204">204</a></td><td class="hits"></td><td class="code">                                                  &#39;snmp_version&#39;:&#39;2&#39;,</td></tr><tr class="noCover"><td class="line"><a name="205">205</a></td><td class="hits"></td><td class="code">                                                  &#39;community&#39;:&#39;public&#39;,</td></tr><tr class="noCover"><td class="line"><a name="206">206</a></td><td class="hits"></td><td class="code">                                                  &#39;snmp_polling&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="207">207</a></td><td class="hits"></td><td class="code">                                                  &#39;canautoupdate&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="208">208</a></td><td class="hits"></td><td class="code">                                                  &#39;collect_arp&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="209">209</a></td><td class="hits"></td><td class="code">                                                  &#39;collect_fwt&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="210">210</a></td><td class="hits"></td><td class="code">                                                  &#39;collect_stp&#39;:&#39;1&#39;,</td></tr><tr class="noCover"><td class="line"><a name="211">211</a></td><td class="hits"></td><td class="code">                                                  &#39;info&#39;:&#39;My Server&#39;}</td></tr><tr class="noCover"><td class="line"><a name="212">212</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="213">213</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="214">214</a></td><td class="hits"></td><td class="code">          Created record as a multi-level dictionary.</td></tr><tr class="noCover"><td class="line"><a name="215">215</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="216">216</a></td><td class="hits">1</td><td class="code">        return self.post(&#34;/&#34; &#43; object, data)</td></tr><tr class="noCover"><td class="line"><a name="217">217</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="218">218</a></td><td class="hits">1</td><td class="code">    def delete_object_by_id(self, object, id):</td></tr><tr class="noCover"><td class="line"><a name="219">219</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="220">220</a></td><td class="hits"></td><td class="code">        This function deletes an object record by it&#39;s id</td></tr><tr class="noCover"><td class="line"><a name="221">221</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="222">222</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="223">223</a></td><td class="hits"></td><td class="code">          object -- &#39;device&#39;, &#39;vlan&#39;, etc...</td></tr><tr class="noCover"><td class="line"><a name="224">224</a></td><td class="hits"></td><td class="code">          id  -- Object ID</td></tr><tr class="noCover"><td class="line"><a name="225">225</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="226">226</a></td><td class="hits"></td><td class="code">        Usage:</td></tr><tr class="noCover"><td class="line"><a name="227">227</a></td><td class="hits"></td><td class="code">          response &#61; netdot.Client.delete_object_by_id(&#34;device&#34;, &#34;id&#34;)</td></tr><tr class="noCover"><td class="line"><a name="228">228</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="229">229</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="230">230</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="231">231</a></td><td class="hits">1</td><td class="code">        return self.delete(f&#39;/{object}/{id}&#39;)</td></tr><tr class="noCover"><td class="line"><a name="232">232</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="233">233</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="234">234</a></td><td class="hits">1</td><td class="code">class Client(Client_v1):</td></tr><tr class="noCover"><td class="line"><a name="235">235</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;NetDot Client (v2) -- provides access to NetDot data directly as dicts.&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="236">236</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="237">237</a></td><td class="hits">1</td><td class="code">    def __init__(self, *args, times_to_retry&#61;3, trace_downloads&#61;defaults.TRACE_DOWNLOADS, trace_threshold_bytes&#61;defaults.TRACE_THRESHOLD, **kwargs):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="238">238</a></td><td class="hits">1</td><td class="code">        self._retries &#61; times_to_retry</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="239">239</a></td><td class="hits">1</td><td class="code">        self._trace_downloads &#61; trace_downloads</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="240">240</a></td><td class="hits">1</td><td class="code">        self._download_tracer: trace.DownloadTracer</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="241">241</a></td><td class="hits">1</td><td class="code">        if trace_downloads:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="242">242</a></td><td class="hits">0</td><td class="code">            self.reset_trace_downloads(trace_threshold_bytes)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="243">243</a></td><td class="hits">1</td><td class="code">        super().__init__(*args, **kwargs)</td></tr><tr class="noCover"><td class="line"><a name="244">244</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="245">245</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="246">246</a></td><td class="hits">1</td><td class="code">    def netdot_url(self) -&gt; str:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="247">247</a></td><td class="hits">1</td><td class="code">        return self.server</td></tr><tr class="noCover"><td class="line"><a name="248">248</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="249">249</a></td><td class="hits">1</td><td class="code">    def disable_trace_downloads(self):</td></tr><tr class="noCover"><td class="line"><a name="250">250</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Disable download tracing.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="251">251</a></td><td class="hits">1</td><td class="code">        self._trace_downloads &#61; False</td></tr><tr class="noCover"><td class="line"><a name="252">252</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="253">253</a></td><td class="hits">1</td><td class="code">    def reset_trace_downloads(self, threshold_bytes&#61;defaults.TRACE_THRESHOLD):</td></tr><tr class="noCover"><td class="line"><a name="254">254</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Reset the DownloadTracer object associated to this Netdot Client. (effectively resetting it back to &#39;0 bytes downloaded&#39;)</td></tr><tr class="noCover"><td class="line"><a name="255">255</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="256">256</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="257">257</a></td><td class="hits"></td><td class="code">            threshold_bytes (bool, optional): How many bytes to wait between log messages. Defaults to defaults.TRACE_THRESHOLD.</td></tr><tr class="noCover"><td class="line"><a name="258">258</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="259">259</a></td><td class="hits">1</td><td class="code">        self._trace_downloads &#61; True</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="260">260</a></td><td class="hits">1</td><td class="code">        self._download_tracer &#61; trace.DownloadTracer(&#39;Netdot&#39;, threshold_bytes)</td></tr><tr class="noCover"><td class="line"><a name="261">261</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="262">262</a></td><td class="hits">1</td><td class="code">    def get_xml(self, url_path: str) -&gt; bytes:</td></tr><tr class="noCover"><td class="line"><a name="263">263</a></td><td class="hits"></td><td class="code">        #</td></tr><tr class="noCover"><td class="line"><a name="264">264</a></td><td class="hits"></td><td class="code">        # Override get_xml to decorate it with a &#39;download tracker&#39;.</td></tr><tr class="noCover"><td class="line"><a name="265">265</a></td><td class="hits"></td><td class="code">        #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="266">266</a></td><td class="hits">1</td><td class="code">        ENCODING &#61; &#39;UTF-8&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="267">267</a></td><td class="hits">1</td><td class="code">        response &#61; super().get_xml(url_path)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="268">268</a></td><td class="hits">1</td><td class="code">        if self._trace_downloads:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="269">269</a></td><td class="hits">1</td><td class="code">            self._download_tracer.trace(len(response))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="270">270</a></td><td class="hits">1</td><td class="code">        try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="271">271</a></td><td class="hits">1</td><td class="code">            return response.decode(ENCODING)</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="272">272</a></td><td class="hits">0</td><td class="code">        except UnicodeDecodeError: </td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="273">273</a></td><td class="hits">0</td><td class="code">            logger.exception(f&#39;Unable to decode {ENCODING} data: {response}&#39;)</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="274">274</a></td><td class="hits">0</td><td class="code">            return response</td></tr><tr class="noCover"><td class="line"><a name="275">275</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="276">276</a></td><td class="hits">1</td><td class="code">    def get(self, url_path: str, **url_params) -&gt; Dict:</td></tr><tr class="noCover"><td class="line"><a name="277">277</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get some data from Netdot REST API.</td></tr><tr class="noCover"><td class="line"><a name="278">278</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="279">279</a></td><td class="hits"></td><td class="code">        Arguments:</td></tr><tr class="noCover"><td class="line"><a name="280">280</a></td><td class="hits"></td><td class="code">            url_path: Path to append to the base url.</td></tr><tr class="noCover"><td class="line"><a name="281">281</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="282">282</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="283">283</a></td><td class="hits"></td><td class="code">            Dict: Result as a multi-level dictionary on success.</td></tr><tr class="noCover"><td class="line"><a name="284">284</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="285">285</a></td><td class="hits">1</td><td class="code">        return self._get_with_retries(</td></tr><tr class="noCover"><td class="line"><a name="286">286</a></td><td class="hits"></td><td class="code">            url_path, times_to_retry&#61;self._retries, **url_params</td></tr><tr class="noCover"><td class="line"><a name="287">287</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="288">288</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="289">289</a></td><td class="hits">1</td><td class="code">    def delete_object_by_id(self, object: str, id: str):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="290">290</a></td><td class="hits">1</td><td class="code">        response &#61; super().delete_object_by_id(object, id)</td></tr><tr class="noCover"><td class="line"><a name="291">291</a></td><td class="hits"></td><td class="code">        if response.strip() !&#61; b&#39;&#39;:  # pragma no cover</td></tr><tr class="noCover"><td class="line"><a name="292">292</a></td><td class="hits"></td><td class="code">            # Defensive Programming: delete will never return any data.</td></tr><tr class="noCover"><td class="line"><a name="293">293</a></td><td class="hits"></td><td class="code">            raise exceptions.NetdotDeleteError(</td></tr><tr class="noCover"><td class="line"><a name="294">294</a></td><td class="hits"></td><td class="code">                f&#34;Unable to delete {object} with id {id}. (delete returned a response)&#34;, response&#61;response</td></tr><tr class="noCover"><td class="line"><a name="295">295</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="296">296</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="297">297</a></td><td class="hits">1</td><td class="code">    def _get_with_retries(self, url_path: str, times_to_retry: int, **url_params):</td></tr><tr class="noCover"><td class="line"><a name="298">298</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Wrapper around super().get. Retry the get request if it fails.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="299">299</a></td><td class="hits">1</td><td class="code">        try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="300">300</a></td><td class="hits">1</td><td class="code">            return super().get(url_path, **url_params)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="301">301</a></td><td class="hits">1</td><td class="code">        except (requests.exceptions.RequestException, urllib3.exceptions.ProtocolError) as e:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="302">302</a></td><td class="hits">1</td><td class="code">            if hasattr(e.response, &#39;status_code&#39;) and e.response.status_code &#61;&#61; 404:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="303">303</a></td><td class="hits">1</td><td class="code">                raise e  # No need to retry for HTTP 404 responses</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="304">304</a></td><td class="hits">1</td><td class="code">            if times_to_retry &gt; 0:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="305">305</a></td><td class="hits">1</td><td class="code">                logger.exception(</td></tr><tr class="noCover"><td class="line"><a name="306">306</a></td><td class="hits"></td><td class="code">                    f&#39;Request to &#34;{url_path}&#34; failed due to: &#34;{e}&#34;. (Will retry {times_to_retry} more times)&#39;</td></tr><tr class="noCover"><td class="line"><a name="307">307</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="308">308</a></td><td class="hits">1</td><td class="code">                return self._get_with_retries(</td></tr><tr class="noCover"><td class="line"><a name="309">309</a></td><td class="hits"></td><td class="code">                    url_path, times_to_retry - 1, **url_params</td></tr><tr class="noCover"><td class="line"><a name="310">310</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="311">311</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="312">312</a></td><td class="hits">1</td><td class="code">                raise e</td></tr><tr class="noCover"><td class="line"><a name="313">313</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="314">314</a></td><td class="hits">1</td><td class="code">    def get_objects_by_filter(</td></tr><tr class="noCover"><td class="line"><a name="315">315</a></td><td class="hits"></td><td class="code">        self, table: str, column: str, search_term: Any, **url_params</td></tr><tr class="noCover"><td class="line"><a name="316">316</a></td><td class="hits"></td><td class="code">    ) -&gt; List[Dict]:</td></tr><tr class="noCover"><td class="line"><a name="317">317</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Filter records from a table. Retrieve all the records from the &#34;table&#34; that match the</td></tr><tr class="noCover"><td class="line"><a name="318">318</a></td><td class="hits"></td><td class="code">        provided &#34;search_term&#34;, for &#34;column&#34;.</td></tr><tr class="noCover"><td class="line"><a name="319">319</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="320">320</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="321">321</a></td><td class="hits"></td><td class="code">            table (str): The table name of the table to be searched (in CamelCase).</td></tr><tr class="noCover"><td class="line"><a name="322">322</a></td><td class="hits"></td><td class="code">            column (str): The column name of the column to be searched.</td></tr><tr class="noCover"><td class="line"><a name="323">323</a></td><td class="hits"></td><td class="code">            search_term (Any): The particular id/str/value you are looking for in the table.</td></tr><tr class="noCover"><td class="line"><a name="324">324</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="325">325</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="326">326</a></td><td class="hits"></td><td class="code">            HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="327">327</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="328">328</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="329">329</a></td><td class="hits"></td><td class="code">            List: A list of any objects that match &#34;search_term&#34; for &#34;column&#34; in &#34;table&#34;.</td></tr><tr class="noCover"><td class="line"><a name="330">330</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="331">331</a></td><td class="hits">1</td><td class="code">        data &#61; super().get_objects_by_filter(table, column, search_term, **url_params)</td></tr><tr class="noCover"><td class="line"><a name="332">332</a></td><td class="hits"></td><td class="code">        # API returns a 1-item dictionary with table name as &#34;the key&#34; and list of results as &#34;the value&#34;.</td></tr><tr class="noCover"><td class="line"><a name="333">333</a></td><td class="hits"></td><td class="code">        # We only want to return the list of results.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="334">334</a></td><td class="hits">1</td><td class="code">        core_data &#61; data[table]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="335">335</a></td><td class="hits">1</td><td class="code">        return list(core_data.values())</td></tr><tr class="noCover"><td class="line"><a name="336">336</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="337">337</a></td><td class="hits">1</td><td class="code">    def get_object_by_id(self, table: str, id: int, **url_params) -&gt; Dict:</td></tr><tr class="noCover"><td class="line"><a name="338">338</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Retrieve the object from &#39;table&#39; with the given &#39;id&#39;.</td></tr><tr class="noCover"><td class="line"><a name="339">339</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="340">340</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="341">341</a></td><td class="hits"></td><td class="code">            table (str): The table name of the table to be searched (in CamelCase).</td></tr><tr class="noCover"><td class="line"><a name="342">342</a></td><td class="hits"></td><td class="code">            id (int): The particular id you are looking for in the table.</td></tr><tr class="noCover"><td class="line"><a name="343">343</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="344">344</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="345">345</a></td><td class="hits"></td><td class="code">            HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="346">346</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="347">347</a></td><td class="hits">1</td><td class="code">        objects &#61; self.get_objects_by_filter(table, &#39;id&#39;, id, **url_params)</td></tr><tr class="noCover"><td class="line"><a name="348">348</a></td><td class="hits"></td><td class="code">        if len(objects) &gt; 1:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="349">349</a></td><td class="hits"></td><td class="code">            # Defensive programming: This is very unlikely to happen.</td></tr><tr class="noCover"><td class="line"><a name="350">350</a></td><td class="hits"></td><td class="code">            raise exceptions.NetdotRESTError(f&#39;Found multiple {utils.pluralize(table)} with id&#61;{id}&#39;, response&#61;objects)</td></tr><tr class="noCover"><td class="line"><a name="351">351</a></td><td class="hits"></td><td class="code">        if len(objects) &lt; 1:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="352">352</a></td><td class="hits"></td><td class="code">            # Defensive programming: This is unreachable, since a HTTP 404 occurs first.</td></tr><tr class="noCover"><td class="line"><a name="353">353</a></td><td class="hits"></td><td class="code">            # So, an HTTPError will be raised before this code can ever run.</td></tr><tr class="noCover"><td class="line"><a name="354">354</a></td><td class="hits"></td><td class="code">            raise exceptions.NetdotRESTError(f&#39;Unable to find {table} with id: {id}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="355">355</a></td><td class="hits">1</td><td class="code">        return objects[0]</td></tr><tr class="noCover"><td class="line"><a name="356">356</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="357">357</a></td><td class="hits">1</td><td class="code">    def get_all(self, table: str, **url_params) -&gt; List:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="358">358</a></td><td class="hits">1</td><td class="code">        all_data &#61; self.get(f&#39;/{table}&#39;, **url_params)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="359">359</a></td><td class="hits">1</td><td class="code">        if all_data:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="360">360</a></td><td class="hits">1</td><td class="code">            all_data &#61; all_data[table]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="361">361</a></td><td class="hits">1</td><td class="code">            all_objects &#61; list(all_data.values())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="362">362</a></td><td class="hits">1</td><td class="code">            return all_objects</td></tr><tr class="noCover"><td class="line"><a name="363">363</a></td><td class="hits"></td><td class="code">        else:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="364">364</a></td><td class="hits"></td><td class="code">            # Defensive programming: This is unreachable, since a HTTP 404 occurs first.</td></tr><tr class="noCover"><td class="line"><a name="365">365</a></td><td class="hits"></td><td class="code">            # So, an HTTPError will be raised before this code can ever run.</td></tr><tr class="noCover"><td class="line"><a name="366">366</a></td><td class="hits"></td><td class="code">            return list()</td></tr>