<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">from typing import Callable, ClassVar, Dict, List, Set</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import dataclasses</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">import ipaddress</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">import textwrap</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from typing import Tuple</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">import threading</td></tr><tr class="noCover"><td class="line"><a name="8">8</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="9">9</a></td><td class="hits">1</td><td class="code">import netdot</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">import netdot.exceptions</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">from netdot.mac_address import MACAddress</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="12">12</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">from netdot import parse, utils, defaults</td></tr><tr class="noCover"><td class="line"><a name="14">14</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="17">17</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="18">18</a></td><td class="hits">1</td><td class="code">inconsistent_and_ignorable_fields &#61; set(</td></tr><tr class="noCover"><td class="line"><a name="19">19</a></td><td class="hits"></td><td class="code">    [</td></tr><tr class="noCover"><td class="line"><a name="20">20</a></td><td class="hits"></td><td class="code">        &#39;info&#39;,</td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code">        &#39;ttl&#39;,</td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code">    ]</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code">)</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="26">26</a></td><td class="hits">1</td><td class="code">def handle_None_values(dto):</td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code">    # ! TODO Do we ever need to send an empty string when None is provided??</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="28">28</a></td><td class="hits">1</td><td class="code">    return {k: v for k, v in dto.items() if bool(v) is True}</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">def handle_bool_values(dto):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">    return {k: str(int(v)) if isinstance(v, bool) else v for k, v in dto.items()}</td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="35">35</a></td><td class="hits">1</td><td class="code">def handle_xlink_fields(dto):</td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">    # Convert _xlink fields to remove the suffix, and send ID only</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">    return {k.replace(&#39;_xlink&#39;, &#39;&#39;): v for k, v in dto.items()}</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">&#64;dataclasses.dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">class NetdotAPIDataclass(CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="42">42</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code">    # Class variables</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">    _initialized: ClassVar[bool] &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">    _logged_unused_fields: ClassVar[Set] &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    _xlink_class_map: ClassVar[Dict[str, str]] &#61; dict()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="48">48</a></td><td class="hits">1</td><td class="code">    _associative_table: ClassVar[bool] &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME: ClassVar[str]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH: ClassVar[str]  # Useful for generating web_url</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    DEFAULT_DTO_FIELD_PARSERS: ClassVar &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="52">52</a></td><td class="hits"></td><td class="code">        &#39;*_xlink&#39;: parse.ID_from_xlink,</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code">    # Default dataclass fields</td></tr><tr class="noCover"><td class="line"><a name="57">57</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">    id: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="59">59</a></td><td class="hits">1</td><td class="code">    _auto_update_lock: bool &#61; dataclasses.field(default&#61;threading.Lock(), repr&#61;False)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="60">60</a></td><td class="hits">1</td><td class="code">    _post_init: bool &#61; dataclasses.field(</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code">        # Set to true via __post_init__</td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code">        default&#61;False,</td></tr><tr class="noCover"><td class="line"><a name="63">63</a></td><td class="hits"></td><td class="code">        repr&#61;False,</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">    )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="65">65</a></td><td class="hits">1</td><td class="code">    _repository: &#39;netdot.Repository&#39; &#61; dataclasses.field(  # noqa</td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code">        default&#61;None, repr&#61;False</td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">    )</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code">    # Properties</td></tr><tr class="noCover"><td class="line"><a name="71">71</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">    def netdot_url(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="74">74</a></td><td class="hits">1</td><td class="code">        return self.repository.connection.netdot_url</td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="77">77</a></td><td class="hits">1</td><td class="code">    def repository(self) -&gt; &#39;netdot.Repository&#39;:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="78">78</a></td><td class="hits">1</td><td class="code">        return self._repository</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="80">80</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="81">81</a></td><td class="hits"></td><td class="code">    # CRUD Operations</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="83">83</a></td><td class="hits">1</td><td class="code">    def create(self):</td></tr><tr class="noCover"><td class="line"><a name="84">84</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Create this object in Netdot. (wrapper around :func:&#96;create_or_update()&#96;)</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code">            ValueError: If trying to create an object that already has an &#96;id&#96;.</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="89">89</a></td><td class="hits">1</td><td class="code">        if self.id is not None:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">            raise ValueError(</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">                f&#39;Cannot create an object that already has an &#96;id&#96; (id&#61;{self.id}). ID is assigned by database.&#39;</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">        self.create_or_update()</td></tr><tr class="noCover"><td class="line"><a name="94">94</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="95">95</a></td><td class="hits">1</td><td class="code">    def update(self):</td></tr><tr class="noCover"><td class="line"><a name="96">96</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Update this object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="97">97</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="98">98</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="99">99</a></td><td class="hits"></td><td class="code">            ValueError: If trying to update an object that has no &#96;id&#96;.</td></tr><tr class="noCover"><td class="line"><a name="100">100</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="101">101</a></td><td class="hits">1</td><td class="code">        if self.id is None:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="102">102</a></td><td class="hits">1</td><td class="code">            raise ValueError(&#39;&#96;id&#96; is required to update an object. None provided.&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">        self.create_or_update()</td></tr><tr class="noCover"><td class="line"><a name="104">104</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="105">105</a></td><td class="hits">1</td><td class="code">    def create_or_update(self: &#39;NetdotAPIDataclass&#39;):</td></tr><tr class="noCover"><td class="line"><a name="106">106</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Create or update this object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="108">108</a></td><td class="hits"></td><td class="code">        &gt; NOTE: Upon creation, this object&#39;s &#96;id&#96; will be populated.</td></tr><tr class="noCover"><td class="line"><a name="109">109</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="110">110</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="111">111</a></td><td class="hits"></td><td class="code">            HTTPError: if the object cannot be created for any reason. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="112">112</a></td><td class="hits"></td><td class="code">            As an example, expect a generic HTTP 400 when:</td></tr><tr class="noCover"><td class="line"><a name="113">113</a></td><td class="hits"></td><td class="code">              * an object breaks &#39;uniqueness&#39; rules (Ex. 2 Sites named &#34;Test&#34;),</td></tr><tr class="noCover"><td class="line"><a name="114">114</a></td><td class="hits"></td><td class="code">              * an object is missing required fields (Ex. a Person without a &#96;lastname&#96;),</td></tr><tr class="noCover"><td class="line"><a name="115">115</a></td><td class="hits"></td><td class="code">              * an object is improperly formatted (Ex. a Device with a &#96;date_installed&#96; that is not a datetime),</td></tr><tr class="noCover"><td class="line"><a name="116">116</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="117">117</a></td><td class="hits">1</td><td class="code">        self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="118">118</a></td><td class="hits">1</td><td class="code">        if self.id:  # UPDATE</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">            create_or_update_function &#61; getattr(self.repository, &#39;update&#39;)</td></tr><tr class="noCover"><td class="line"><a name="120">120</a></td><td class="hits"></td><td class="code">        else:  # CREATE</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="121">121</a></td><td class="hits">1</td><td class="code">            create_or_update_function &#61; getattr(self.repository, &#39;create_new&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="122">122</a></td><td class="hits">1</td><td class="code">        create_or_update_function(self)</td></tr><tr class="noCover"><td class="line"><a name="123">123</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="124">124</a></td><td class="hits">1</td><td class="code">    def delete(self, **kwargs):</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Delete this object.</td></tr><tr class="noCover"><td class="line"><a name="126">126</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="127">127</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="128">128</a></td><td class="hits"></td><td class="code">            See :func:&#96;netdot.Repository.delete&#96;</td></tr><tr class="noCover"><td class="line"><a name="129">129</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="130">130</a></td><td class="hits"></td><td class="code">        Requires:</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code">            Must have repository attached. Use with_repository(...)</td></tr><tr class="noCover"><td class="line"><a name="132">132</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="133">133</a></td><td class="hits">1</td><td class="code">        self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="134">134</a></td><td class="hits">1</td><td class="code">        self.repository.delete(self, **kwargs)</td></tr><tr class="noCover"><td class="line"><a name="135">135</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="136">136</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="137">137</a></td><td class="hits"></td><td class="code">    # __dunder__ methods (hooking into python functionality)</td></tr><tr class="noCover"><td class="line"><a name="138">138</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">    def __post_init__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="140">140</a></td><td class="hits">1</td><td class="code">        self._prepare_class()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="141">141</a></td><td class="hits">1</td><td class="code">        self._post_init &#61; True</td></tr><tr class="noCover"><td class="line"><a name="142">142</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="143">143</a></td><td class="hits">1</td><td class="code">    def __setattr__(self, name, value):</td></tr><tr class="noCover"><td class="line"><a name="144">144</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;We override setattr so that we can:</td></tr><tr class="noCover"><td class="line"><a name="145">145</a></td><td class="hits"></td><td class="code">        * Handle associated &#39;_xlink&#39; field if a NetdotAPIDataclass is provided, and</td></tr><tr class="noCover"><td class="line"><a name="146">146</a></td><td class="hits"></td><td class="code">        * Handle auto_update feature if enabled.</td></tr><tr class="noCover"><td class="line"><a name="147">147</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="148">148</a></td><td class="hits">1</td><td class="code">        if not self._handle_xlink_setattr(name, value):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="149">149</a></td><td class="hits">1</td><td class="code">            super().__setattr__(name, value)</td></tr><tr class="noCover"><td class="line"><a name="150">150</a></td><td class="hits"></td><td class="code">            # TODO: Figure out how to run auto-update for xlink fields (but not when setting the xlink field as part of &#96;load_*&#96; methods)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="151">151</a></td><td class="hits">1</td><td class="code">        self._attempt_auto_update_if_enabled(name, value)</td></tr><tr class="noCover"><td class="line"><a name="152">152</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="153">153</a></td><td class="hits">1</td><td class="code">    def __getstate__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="154">154</a></td><td class="hits">1</td><td class="code">        state &#61; self.__dict__.copy()</td></tr><tr class="noCover"><td class="line"><a name="155">155</a></td><td class="hits"></td><td class="code">        # Remove the unpicklable entries.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="156">156</a></td><td class="hits">1</td><td class="code">        del state[&#39;_auto_update_lock&#39;]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="157">157</a></td><td class="hits">1</td><td class="code">        del state[&#39;_repository&#39;]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="158">158</a></td><td class="hits">1</td><td class="code">        return state</td></tr><tr class="noCover"><td class="line"><a name="159">159</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="160">160</a></td><td class="hits">1</td><td class="code">    def __setstate__(self, state):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="161">161</a></td><td class="hits">1</td><td class="code">        self.__dict__.update(state)</td></tr><tr class="noCover"><td class="line"><a name="162">162</a></td><td class="hits"></td><td class="code">        # Restore the unpicklable entries.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="163">163</a></td><td class="hits">1</td><td class="code">        self._auto_update_lock &#61; threading.Lock()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="164">164</a></td><td class="hits">1</td><td class="code">        self._repository &#61; None</td></tr><tr class="noCover"><td class="line"><a name="165">165</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="166">166</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="167">167</a></td><td class="hits"></td><td class="code">    # Override CSVDataclass methods (to enable using CSVReport and tabulate)</td></tr><tr class="noCover"><td class="line"><a name="168">168</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="169">169</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="170">170</a></td><td class="hits">1</td><td class="code">    def table_header(cls) -&gt; Tuple[str, ...]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="171">171</a></td><td class="hits">1</td><td class="code">        return [&#39;id&#39;] &#43; cls._updatable_fields()</td></tr><tr class="noCover"><td class="line"><a name="172">172</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="173">173</a></td><td class="hits">1</td><td class="code">    def as_table_row(self, select_columns&#61;None) -&gt; Tuple[str, ...]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="174">174</a></td><td class="hits">1</td><td class="code">        columns &#61; select_columns or self.table_header()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="175">175</a></td><td class="hits">1</td><td class="code">        return super().as_table_row(columns)</td></tr><tr class="noCover"><td class="line"><a name="176">176</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="177">177</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="178">178</a></td><td class="hits"></td><td class="code">    # Helper functions</td></tr><tr class="noCover"><td class="line"><a name="179">179</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="180">180</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="181">181</a></td><td class="hits">1</td><td class="code">    def _prepare_class(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="182">182</a></td><td class="hits">1</td><td class="code">        if not cls._initialized:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="183">183</a></td><td class="hits">1</td><td class="code">            cls._generate_and_attach_others_getAll_methods()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="184">184</a></td><td class="hits">1</td><td class="code">            cls._generate_and_attach_my_getter_methods()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="185">185</a></td><td class="hits">1</td><td class="code">            cls._generate_and_attach_others_m2m_add_methods()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="186">186</a></td><td class="hits">1</td><td class="code">            cls._generate_and_attach_others_add_xlink_methods()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="187">187</a></td><td class="hits">1</td><td class="code">            cls._logged_unused_fields &#61; set()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="188">188</a></td><td class="hits">1</td><td class="code">            cls._initialized &#61; True</td></tr><tr class="noCover"><td class="line"><a name="189">189</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="190">190</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="191">191</a></td><td class="hits">1</td><td class="code">    def _associative_table_other_class(cls, other_cls: &#39;NetdotAPIDataclass&#39;):</td></tr><tr class="noCover"><td class="line"><a name="192">192</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the class that is different from &#39;other_cls&#39;.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="193">193</a></td><td class="hits">1</td><td class="code">        if not cls._associative_table:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="194">194</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="195">195</a></td><td class="hits"></td><td class="code">                &#39;This method is only valid for associative tables (many to many relationship only).&#39;</td></tr><tr class="noCover"><td class="line"><a name="196">196</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="197">197</a></td><td class="hits">1</td><td class="code">        cls_options &#61; list(cls._related_classes().values())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="198">198</a></td><td class="hits">1</td><td class="code">        if other_cls not in cls_options:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="199">199</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="200">200</a></td><td class="hits"></td><td class="code">                f&#39;Provided class {other_cls} is not a valid option. Valid options: {cls_options}&#39;</td></tr><tr class="noCover"><td class="line"><a name="201">201</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="202">202</a></td><td class="hits">1</td><td class="code">        cls_options.remove(other_cls)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="203">203</a></td><td class="hits">1</td><td class="code">        return cls_options[0]</td></tr><tr class="noCover"><td class="line"><a name="204">204</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="205">205</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="206">206</a></td><td class="hits">1</td><td class="code">    def _associative_table_other_class_xlink_name(cls, other_cls: &#39;NetdotAPIDataclass&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="207">207</a></td><td class="hits">1</td><td class="code">        inv_xlink_class_map &#61; {v: k for k, v in cls._xlink_class_map.items()}</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="208">208</a></td><td class="hits">1</td><td class="code">        return (</td></tr><tr class="noCover"><td class="line"><a name="209">209</a></td><td class="hits"></td><td class="code">            inv_xlink_class_map[other_cls.__name__]</td></tr><tr class="noCover"><td class="line"><a name="210">210</a></td><td class="hits"></td><td class="code">            if other_cls.__name__ in inv_xlink_class_map</td></tr><tr class="noCover"><td class="line"><a name="211">211</a></td><td class="hits"></td><td class="code">            else other_cls.__name__.lower()</td></tr><tr class="noCover"><td class="line"><a name="212">212</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="213">213</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="214">214</a></td><td class="hits">1</td><td class="code">    def _handle_xlink_setattr(self, name, value) -&gt; bool:</td></tr><tr class="noCover"><td class="line"><a name="215">215</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;__setattr__ helper function&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="216">216</a></td><td class="hits">1</td><td class="code">        if isinstance(value, NetdotAPIDataclass) and hasattr(self, f&#39;{name}_xlink&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="217">217</a></td><td class="hits">1</td><td class="code">            super().__setattr__(f&#39;{name}_xlink&#39;, value.id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="218">218</a></td><td class="hits">1</td><td class="code">            super().__setattr__(name, value)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="219">219</a></td><td class="hits">1</td><td class="code">            return True</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="220">220</a></td><td class="hits">1</td><td class="code">        elif name.endswith(&#39;_xlink&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="221">221</a></td><td class="hits">1</td><td class="code">            non_xlink_value &#61; getattr(self, name.replace(&#39;_xlink&#39;, &#39;&#39;))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="222">222</a></td><td class="hits">1</td><td class="code">            if isinstance(non_xlink_value, NetdotAPIDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="223">223</a></td><td class="hits">1</td><td class="code">                return True</td></tr><tr class="noCover"><td class="line"><a name="224">224</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="225">225</a></td><td class="hits">1</td><td class="code">            return False</td></tr><tr class="noCover"><td class="line"><a name="226">226</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="227">227</a></td><td class="hits">1</td><td class="code">    def _attempt_auto_update_if_enabled(self, name, value):</td></tr><tr class="noCover"><td class="line"><a name="228">228</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;__setattr__ helper function&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="229">229</a></td><td class="hits">1</td><td class="code">        all_updatable_fields &#61; self._updatable_fields(</td></tr><tr class="noCover"><td class="line"><a name="230">230</a></td><td class="hits"></td><td class="code">            xlink_suffix&#61;True</td></tr><tr class="noCover"><td class="line"><a name="231">231</a></td><td class="hits"></td><td class="code">        ) &#43; self._updatable_fields(xlink_suffix&#61;False)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="232">232</a></td><td class="hits">1</td><td class="code">        if (</td></tr><tr class="noCover"><td class="line"><a name="233">233</a></td><td class="hits"></td><td class="code">            self._post_init  # Do not try to run updates until after __init__ is done</td></tr><tr class="noCover"><td class="line"><a name="234">234</a></td><td class="hits"></td><td class="code">            and self.id  # Only try to run updates if this is an update-able object</td></tr><tr class="noCover"><td class="line"><a name="235">235</a></td><td class="hits"></td><td class="code">            and self.repository  # Only try to run updates if this object has a repository</td></tr><tr class="noCover"><td class="line"><a name="236">236</a></td><td class="hits"></td><td class="code">            and self.repository._dry_run  # Only try to run updates if this is a dry run</td></tr><tr class="noCover"><td class="line"><a name="237">237</a></td><td class="hits"></td><td class="code">            and self.repository._auto_update_on_dry_run  # Only try to run updates if auto_update is enabled[]</td></tr><tr class="noCover"><td class="line"><a name="238">238</a></td><td class="hits"></td><td class="code">            and name</td></tr><tr class="noCover"><td class="line"><a name="239">239</a></td><td class="hits"></td><td class="code">            in all_updatable_fields  # Only try to run updates if this is an updatable field</td></tr><tr class="noCover"><td class="line"><a name="240">240</a></td><td class="hits"></td><td class="code">        ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="241">241</a></td><td class="hits">1</td><td class="code">            if self._auto_update_lock.acquire(</td></tr><tr class="noCover"><td class="line"><a name="242">242</a></td><td class="hits"></td><td class="code">                blocking&#61;False</td></tr><tr class="noCover"><td class="line"><a name="243">243</a></td><td class="hits"></td><td class="code">            ):  # Only ever auto-run update once at a time</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="244">244</a></td><td class="hits">1</td><td class="code">                try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="245">245</a></td><td class="hits">1</td><td class="code">                    self.update()</td></tr><tr class="noCover"><td class="line"><a name="246">246</a></td><td class="hits"></td><td class="code">                finally:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="247">247</a></td><td class="hits">1</td><td class="code">                    self._auto_update_lock.release()</td></tr><tr class="noCover"><td class="line"><a name="248">248</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="249">249</a></td><td class="hits">1</td><td class="code">    def _intake_DTO(self, data: Dict):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="250">250</a></td><td class="hits">1</td><td class="code">        return self._update_my_fields(self.from_DTO(data))</td></tr><tr class="noCover"><td class="line"><a name="251">251</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="252">252</a></td><td class="hits">1</td><td class="code">    def _update_my_fields(self, response: &#39;NetdotAPIDataclass&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="253">253</a></td><td class="hits">1</td><td class="code">        if not isinstance(response, type(self)):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="254">254</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="255">255</a></td><td class="hits"></td><td class="code">                f&#39;Expected response to be of type {type(self)}, got {type(response)}&#39;</td></tr><tr class="noCover"><td class="line"><a name="256">256</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="257">257</a></td><td class="hits">1</td><td class="code">        fields_to_update &#61; (</td></tr><tr class="noCover"><td class="line"><a name="258">258</a></td><td class="hits"></td><td class="code">            self._updatable_fields()</td></tr><tr class="noCover"><td class="line"><a name="259">259</a></td><td class="hits"></td><td class="code">            &#43; [&#39;id&#39;]</td></tr><tr class="noCover"><td class="line"><a name="260">260</a></td><td class="hits"></td><td class="code">            &#43; self.foreign_key_field_names(remove_suffix&#61;True)</td></tr><tr class="noCover"><td class="line"><a name="261">261</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="262">262</a></td><td class="hits"></td><td class="code">        # NOTE: Locking here ensures that auto_update is disabled when we do &#34;_update_my_fields&#34;</td></tr><tr class="noCover"><td class="line"><a name="263">263</a></td><td class="hits"></td><td class="code">        # This might be a bit cons</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="264">264</a></td><td class="hits">1</td><td class="code">        self._auto_update_lock.acquire(blocking&#61;False)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="265">265</a></td><td class="hits">1</td><td class="code">        for field_name in fields_to_update:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="266">266</a></td><td class="hits">1</td><td class="code">            setattr(self, field_name, getattr(response, field_name))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="267">267</a></td><td class="hits">1</td><td class="code">        self._auto_update_lock.release()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="268">268</a></td><td class="hits">1</td><td class="code">        return self</td></tr><tr class="noCover"><td class="line"><a name="269">269</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="270">270</a></td><td class="hits">1</td><td class="code">    def _assert_repository_attached(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="271">271</a></td><td class="hits">1</td><td class="code">        if not self._repository:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="272">272</a></td><td class="hits">0</td><td class="code">            raise netdot.exceptions.NetdotError(</td></tr><tr class="noCover"><td class="line"><a name="273">273</a></td><td class="hits"></td><td class="code">                &#39;Must have repository attached to use methods like: create, add_*,load_*, update, delete. Use with_repository(...) to fix.&#39;</td></tr><tr class="noCover"><td class="line"><a name="274">274</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="275">275</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="276">276</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="277">277</a></td><td class="hits">1</td><td class="code">    def _attach_methods(cls, methods):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="278">278</a></td><td class="hits">1</td><td class="code">        for method in methods:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="279">279</a></td><td class="hits">1</td><td class="code">            setattr(cls, method.__name__, method)</td></tr><tr class="noCover"><td class="line"><a name="280">280</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="281">281</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="282">282</a></td><td class="hits">1</td><td class="code">    def _pep8_method_friendly_name(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="283">283</a></td><td class="hits">1</td><td class="code">        return cls.__name__.lower()</td></tr><tr class="noCover"><td class="line"><a name="284">284</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="285">285</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="286">286</a></td><td class="hits">1</td><td class="code">    def _name_pluralized(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="287">287</a></td><td class="hits">1</td><td class="code">        return utils.pluralize(cls.__name__)</td></tr><tr class="noCover"><td class="line"><a name="288">288</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="289">289</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="290">290</a></td><td class="hits">1</td><td class="code">    def _get_xlink_class_name(cls, xlink: str):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="291">291</a></td><td class="hits">1</td><td class="code">        try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="292">292</a></td><td class="hits">1</td><td class="code">            xlink_classname &#61; xlink[: -len(&#39;_xlink&#39;)]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="293">293</a></td><td class="hits">1</td><td class="code">            return cls._xlink_class_map[xlink_classname]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="294">294</a></td><td class="hits">1</td><td class="code">        except KeyError:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="295">295</a></td><td class="hits">1</td><td class="code">            return xlink</td></tr><tr class="noCover"><td class="line"><a name="296">296</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="297">297</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="298">298</a></td><td class="hits">1</td><td class="code">    def foreign_key_field_names(cls, remove_suffix&#61;False) -&gt; List[str]:</td></tr><tr class="noCover"><td class="line"><a name="299">299</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the names of all the foreign key fields for this class.</td></tr><tr class="noCover"><td class="line"><a name="300">300</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="301">301</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="302">302</a></td><td class="hits"></td><td class="code">            List[str]: List of all the foreign key fields for this class.</td></tr><tr class="noCover"><td class="line"><a name="303">303</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="304">304</a></td><td class="hits"></td><td class="code">        Examples:</td></tr><tr class="noCover"><td class="line"><a name="305">305</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="306">306</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; import netdot</td></tr><tr class="noCover"><td class="line"><a name="307">307</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; netdot.BackboneCable.foreign_key_field_names()</td></tr><tr class="noCover"><td class="line"><a name="308">308</a></td><td class="hits"></td><td class="code">        [&#39;end_closet_xlink&#39;, &#39;owner_xlink&#39;, &#39;start_closet_xlink&#39;, &#39;type_xlink&#39;]</td></tr><tr class="noCover"><td class="line"><a name="309">309</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="310">310</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; netdot.Site.foreign_key_field_names()</td></tr><tr class="noCover"><td class="line"><a name="311">311</a></td><td class="hits"></td><td class="code">        [&#39;availability_xlink&#39;, &#39;contactlist_xlink&#39;]</td></tr><tr class="noCover"><td class="line"><a name="312">312</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="313">313</a></td><td class="hits"></td><td class="code">        # Get all keys ending with the _xlink suffix. Example: asset_id_xlink</td></tr><tr class="noCover"><td class="line"><a name="314">314</a></td><td class="hits"></td><td class="code">        #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="315">315</a></td><td class="hits">1</td><td class="code">        new_keys &#61; cls.__dataclass_fields__.keys()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="316">316</a></td><td class="hits">1</td><td class="code">        foreign_keys &#61; list(</td></tr><tr class="noCover"><td class="line"><a name="317">317</a></td><td class="hits"></td><td class="code">            filter(</td></tr><tr class="noCover"><td class="line"><a name="318">318</a></td><td class="hits"></td><td class="code">                lambda field_name: field_name.endswith(&#39;_xlink&#39;),</td></tr><tr class="noCover"><td class="line"><a name="319">319</a></td><td class="hits"></td><td class="code">                new_keys,</td></tr><tr class="noCover"><td class="line"><a name="320">320</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="321">321</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="322">322</a></td><td class="hits">1</td><td class="code">        if remove_suffix:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="323">323</a></td><td class="hits">1</td><td class="code">            return [key.replace(&#39;_xlink&#39;, &#39;&#39;) for key in foreign_keys]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="324">324</a></td><td class="hits">1</td><td class="code">        return foreign_keys</td></tr><tr class="noCover"><td class="line"><a name="325">325</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="326">326</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="327">327</a></td><td class="hits">1</td><td class="code">    def _related_classes(cls) -&gt; Dict[str, &#39;NetdotAPIDataclass&#39;]:</td></tr><tr class="noCover"><td class="line"><a name="328">328</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Provide a dictionary holding all of the &#39;xlink&#39; field names and their associated dataclasses.</td></tr><tr class="noCover"><td class="line"><a name="329">329</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="330">330</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="331">331</a></td><td class="hits"></td><td class="code">            Dict[str, &#34;NetdotAPIDataclass&#34;]: All the associated fields, and their data classes.</td></tr><tr class="noCover"><td class="line"><a name="332">332</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="333">333</a></td><td class="hits"></td><td class="code">        Example:</td></tr><tr class="noCover"><td class="line"><a name="334">334</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="335">335</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; import netdot</td></tr><tr class="noCover"><td class="line"><a name="336">336</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; netdot.BackboneCable._related_classes()</td></tr><tr class="noCover"><td class="line"><a name="337">337</a></td><td class="hits"></td><td class="code">            {&#39;end_closet_xlink&#39;: , &#39;owner_xlink&#39;: , &#39;start_closet_xlink&#39;: , &#39;type_xlink&#39;: }</td></tr><tr class="noCover"><td class="line"><a name="338">338</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="339">339</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; netdot.Site._related_classes()</td></tr><tr class="noCover"><td class="line"><a name="340">340</a></td><td class="hits"></td><td class="code">            {&#39;availability_xlink&#39;: , &#39;contactlist_xlink&#39;: }</td></tr><tr class="noCover"><td class="line"><a name="341">341</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="342">342</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="343">343</a></td><td class="hits">1</td><td class="code">        related_object_types &#61; {}</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="344">344</a></td><td class="hits">1</td><td class="code">        for xlink in cls.foreign_key_field_names():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="345">345</a></td><td class="hits">1</td><td class="code">            xlink_class_name &#61; cls._get_xlink_class_name(xlink)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="346">346</a></td><td class="hits">1</td><td class="code">            xlink_class_name &#61; xlink_class_name.replace(&#39;_xlink&#39;, &#39;&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="347">347</a></td><td class="hits">1</td><td class="code">            for other_dataclass in NetdotAPIDataclass.__subclasses__():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="348">348</a></td><td class="hits">1</td><td class="code">                if xlink_class_name.lower() &#61;&#61; other_dataclass.__name__.lower():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="349">349</a></td><td class="hits">1</td><td class="code">                    related_object_types[xlink] &#61; other_dataclass</td></tr><tr class="noCover"><td class="line"><a name="350">350</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="351">351</a></td><td class="hits">1</td><td class="code">        return related_object_types</td></tr><tr class="noCover"><td class="line"><a name="352">352</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="353">353</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="354">354</a></td><td class="hits">1</td><td class="code">    def _updatable_fields(cls, xlink_suffix&#61;True) -&gt; List[str]:</td></tr><tr class="noCover"><td class="line"><a name="355">355</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Fields that can be updated via the Netdot API.</td></tr><tr class="noCover"><td class="line"><a name="356">356</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="357">357</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="358">358</a></td><td class="hits"></td><td class="code">            xlink_suffix (bool, optional): If True, will keep the &#39;_xlink&#39; suffix on the field names. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="359">359</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="360">360</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="361">361</a></td><td class="hits"></td><td class="code">            List[str]: Names of the fields of this object that can be updated.</td></tr><tr class="noCover"><td class="line"><a name="362">362</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="363">363</a></td><td class="hits"></td><td class="code">        Example:</td></tr><tr class="noCover"><td class="line"><a name="364">364</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="365">365</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; import netdot</td></tr><tr class="noCover"><td class="line"><a name="366">366</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; netdot.Site._updatable_fields()</td></tr><tr class="noCover"><td class="line"><a name="367">367</a></td><td class="hits"></td><td class="code">            [&#39;name&#39;, &#39;aliases&#39;, &#39;availability_xlink&#39;, &#39;contactlist_xlink&#39;, &#39;gsf&#39;, &#39;number&#39;, &#39;street1&#39;, &#39;street2&#39;, &#39;state&#39;, &#39;city&#39;, &#39;country&#39;, &#39;zip&#39;, &#39;pobox&#39;, &#39;info&#39;]</td></tr><tr class="noCover"><td class="line"><a name="368">368</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="369">369</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="370">370</a></td><td class="hits">1</td><td class="code">        return list(</td></tr><tr class="noCover"><td class="line"><a name="371">371</a></td><td class="hits"></td><td class="code">            filter(</td></tr><tr class="noCover"><td class="line"><a name="372">372</a></td><td class="hits"></td><td class="code">                lambda field_name:</td></tr><tr class="noCover"><td class="line"><a name="373">373</a></td><td class="hits"></td><td class="code">                # Filter &#39;private&#39; (start with _)</td></tr><tr class="noCover"><td class="line"><a name="374">374</a></td><td class="hits"></td><td class="code">                not field_name.startswith(&#39;_&#39;)</td></tr><tr class="noCover"><td class="line"><a name="375">375</a></td><td class="hits"></td><td class="code">                # Filter ALL_CAPS_FIELDS (these are constants)</td></tr><tr class="noCover"><td class="line"><a name="376">376</a></td><td class="hits"></td><td class="code">                and not field_name.upper() &#61;&#61; field_name</td></tr><tr class="noCover"><td class="line"><a name="377">377</a></td><td class="hits"></td><td class="code">                # Filter &#39;id&#39; (should only be provided via URL path)</td></tr><tr class="noCover"><td class="line"><a name="378">378</a></td><td class="hits"></td><td class="code">                and not field_name &#61;&#61; &#39;id&#39;</td></tr><tr class="noCover"><td class="line"><a name="379">379</a></td><td class="hits"></td><td class="code">                # Deduplicate the _xlink fields</td></tr><tr class="noCover"><td class="line"><a name="380">380</a></td><td class="hits"></td><td class="code">                and field_name</td></tr><tr class="noCover"><td class="line"><a name="381">381</a></td><td class="hits"></td><td class="code">                not in cls.foreign_key_field_names(remove_suffix&#61;xlink_suffix),</td></tr><tr class="noCover"><td class="line"><a name="382">382</a></td><td class="hits"></td><td class="code">                cls.__dataclass_fields__.keys(),</td></tr><tr class="noCover"><td class="line"><a name="383">383</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="384">384</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="385">385</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="386">386</a></td><td class="hits">1</td><td class="code">    def to_DTO(self) -&gt; Dict:</td></tr><tr class="noCover"><td class="line"><a name="387">387</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Convert to a Data Transfer Object (compliant with NetDot REST API).</td></tr><tr class="noCover"><td class="line"><a name="388">388</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="389">389</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="390">390</a></td><td class="hits"></td><td class="code">            Dict: Use as input to Netdot API POST calls, for creation/update operations.</td></tr><tr class="noCover"><td class="line"><a name="391">391</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="392">392</a></td><td class="hits"></td><td class="code">        Example:</td></tr><tr class="noCover"><td class="line"><a name="393">393</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="394">394</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; import netdot</td></tr><tr class="noCover"><td class="line"><a name="395">395</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; contact_list &#61; netdot.ContactList(id&#61;123, name&#61;&#39;foo&#39;)</td></tr><tr class="noCover"><td class="line"><a name="396">396</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; site &#61; netdot.Site(name&#61;&#39;foo&#39;, contactlist&#61;contact_list, city&#61;&#39;Eugene&#39;)</td></tr><tr class="noCover"><td class="line"><a name="397">397</a></td><td class="hits"></td><td class="code">            &gt;&gt;&gt; site.to_DTO()</td></tr><tr class="noCover"><td class="line"><a name="398">398</a></td><td class="hits"></td><td class="code">            {&#39;name&#39;: &#39;foo&#39;, &#39;contactlist&#39;: 123, &#39;city&#39;: &#39;Eugene&#39;}</td></tr><tr class="noCover"><td class="line"><a name="399">399</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="400">400</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="401">401</a></td><td class="hits"></td><td class="code">        # Create a dict (DTO) that represents this object</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="402">402</a></td><td class="hits">1</td><td class="code">        dto &#61; {field: getattr(self, field) for field in self._updatable_fields()}</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="403">403</a></td><td class="hits">1</td><td class="code">        return handle_bool_values(handle_None_values(handle_xlink_fields(dto)))</td></tr><tr class="noCover"><td class="line"><a name="404">404</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="405">405</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="406">406</a></td><td class="hits">1</td><td class="code">    def _is_xlink_sibling(cls, field_name):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="407">407</a></td><td class="hits">1</td><td class="code">        return f&#39;{field_name}_xlink&#39; in vars(cls).keys()</td></tr><tr class="noCover"><td class="line"><a name="408">408</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="409">409</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="410">410</a></td><td class="hits">1</td><td class="code">    def _parse_DTO_field(cls, field_name: str, data: dict, string_parser):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="411">411</a></td><td class="hits">1</td><td class="code">        dto_field_name &#61; field_name.rstrip(&#39;_&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="412">412</a></td><td class="hits">1</td><td class="code">        field_value &#61; str(data[dto_field_name])</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="413">413</a></td><td class="hits">1</td><td class="code">        if field_value.strip() &#61;&#61; &#39;&#39; and not isinstance(string_parser, str):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="414">414</a></td><td class="hits">1</td><td class="code">            return field_value  # Don&#39;t try to parse empty strings (just return them)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="415">415</a></td><td class="hits">1</td><td class="code">        if field_value.strip() &#61;&#61; &#39;0&#39; and (  # Do not try to parse &#39;0&#39; into an:</td></tr><tr class="noCover"><td class="line"><a name="416">416</a></td><td class="hits"></td><td class="code">            string_parser &#61;&#61; ipaddress.ip_address  # IP Address,</td></tr><tr class="noCover"><td class="line"><a name="417">417</a></td><td class="hits"></td><td class="code">            or string_parser &#61;&#61; MACAddress  # MACAddress, or</td></tr><tr class="noCover"><td class="line"><a name="418">418</a></td><td class="hits"></td><td class="code">            or cls._is_xlink_sibling(field_name)  # Foreign Key.</td></tr><tr class="noCover"><td class="line"><a name="419">419</a></td><td class="hits"></td><td class="code">        ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="420">420</a></td><td class="hits">1</td><td class="code">            return None  # Don&#39;t try to parse &#39;0&#39; into an IP Address or MACAddress</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="421">421</a></td><td class="hits">1</td><td class="code">        return string_parser(data[dto_field_name])</td></tr><tr class="noCover"><td class="line"><a name="422">422</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="423">423</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="424">424</a></td><td class="hits">1</td><td class="code">    def from_DTO(</td></tr><tr class="noCover"><td class="line"><a name="425">425</a></td><td class="hits"></td><td class="code">        cls,</td></tr><tr class="noCover"><td class="line"><a name="426">426</a></td><td class="hits"></td><td class="code">        DTO_data: Dict,</td></tr><tr class="noCover"><td class="line"><a name="427">427</a></td><td class="hits"></td><td class="code">        DTO_field_parsers: Dict &#61; DEFAULT_DTO_FIELD_PARSERS,</td></tr><tr class="noCover"><td class="line"><a name="428">428</a></td><td class="hits"></td><td class="code">        raise_parse_errors&#61;defaults.RAISE_PARSE_ERRORS,</td></tr><tr class="noCover"><td class="line"><a name="429">429</a></td><td class="hits"></td><td class="code">        warn_missing_fields&#61;defaults.WARN_MISSING_FIELDS,</td></tr><tr class="noCover"><td class="line"><a name="430">430</a></td><td class="hits"></td><td class="code">    ) -&gt; &#39;NetdotAPIDataclass&#39;:</td></tr><tr class="noCover"><td class="line"><a name="431">431</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Parse data retrieved from Netdot API into a NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="432">432</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="433">433</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="434">434</a></td><td class="hits"></td><td class="code">            data_transfer_object (Dict): Dictionary of raw data returned from Netdot API.</td></tr><tr class="noCover"><td class="line"><a name="435">435</a></td><td class="hits"></td><td class="code">            dto_field_parsers (Dict, optional): A dictionary holding field_name -&gt; parse_field() functions.</td></tr><tr class="noCover"><td class="line"><a name="436">436</a></td><td class="hits"></td><td class="code">                This is useful for when data returned from the NetDot API is not a string but actually some other data type.</td></tr><tr class="noCover"><td class="line"><a name="437">437</a></td><td class="hits"></td><td class="code">                Defaults to DEFAULT_STRING_PARSERS. By default, all fields are parsed as strings.</td></tr><tr class="noCover"><td class="line"><a name="438">438</a></td><td class="hits"></td><td class="code">                field_name may contain a single wildcard at the beginning, e.g. *_xlink will expand to used_by_xlink, owner_xlink, parent_xlink, etc...</td></tr><tr class="noCover"><td class="line"><a name="439">439</a></td><td class="hits"></td><td class="code">            continue_on_parse_error (bool, optional): If True, will continue parsing even if a field cannot be parsed.</td></tr><tr class="noCover"><td class="line"><a name="440">440</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="441">441</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="442">442</a></td><td class="hits"></td><td class="code">            NetdotAPIDataclass: The appropriate subclass of NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="443">443</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="444">444</a></td><td class="hits">1</td><td class="code">        if not DTO_data:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="445">445</a></td><td class="hits">0</td><td class="code">            raise ValueError(</td></tr><tr class="noCover"><td class="line"><a name="446">446</a></td><td class="hits"></td><td class="code">                f&#39;Cannot parse empty Data Transfer Object (DTO): {DTO_data}.&#39;</td></tr><tr class="noCover"><td class="line"><a name="447">447</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="448">448</a></td><td class="hits">1</td><td class="code">        data &#61; dict(DTO_data.copy())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="449">449</a></td><td class="hits">1</td><td class="code">        missing_fields &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="450">450</a></td><td class="hits">1</td><td class="code">        if DTO_field_parsers:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="451">451</a></td><td class="hits">1</td><td class="code">            field_parsers &#61; dict(DTO_field_parsers.copy())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="452">452</a></td><td class="hits">1</td><td class="code">            field_parsers.update(cls._infer_base_parsers())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="453">453</a></td><td class="hits">1</td><td class="code">            field_parsers.update(cls._expand_wildcard_parsers(field_parsers))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="454">454</a></td><td class="hits">1</td><td class="code">            for field_name, string_parser in field_parsers.items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="455">455</a></td><td class="hits">1</td><td class="code">                if field_name.startswith(&#39;_&#39;) or field_name.upper() &#61;&#61; field_name:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="456">456</a></td><td class="hits">1</td><td class="code">                    continue  # Skip &#39;_private&#39; and &#39;ALL_CAPS&#39; fields</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="457">457</a></td><td class="hits">1</td><td class="code">                try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="458">458</a></td><td class="hits">1</td><td class="code">                    data[field_name] &#61; cls._parse_DTO_field(</td></tr><tr class="noCover"><td class="line"><a name="459">459</a></td><td class="hits"></td><td class="code">                        field_name, data, string_parser</td></tr><tr class="noCover"><td class="line"><a name="460">460</a></td><td class="hits"></td><td class="code">                    )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="461">461</a></td><td class="hits">1</td><td class="code">                    if field_name.endswith(&#39;_&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="462">462</a></td><td class="hits">1</td><td class="code">                        del data[field_name.rstrip(&#39;_&#39;)]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="463">463</a></td><td class="hits">1</td><td class="code">                except KeyError:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="464">464</a></td><td class="hits">1</td><td class="code">                    if field_name.endswith(&#39;_xlink&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="465">465</a></td><td class="hits">1</td><td class="code">                        continue  # Expect _xlink to be absent if it is unset in Netdot</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="466">466</a></td><td class="hits">1</td><td class="code">                    missing_fields.append(field_name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="467">467</a></td><td class="hits">1</td><td class="code">                except Exception as parse_error:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="468">468</a></td><td class="hits">1</td><td class="code">                    logger.warning(</td></tr><tr class="noCover"><td class="line"><a name="469">469</a></td><td class="hits"></td><td class="code">                        textwrap.dedent(</td></tr><tr class="noCover"><td class="line"><a name="470">470</a></td><td class="hits"></td><td class="code">                            f&#34;&#34;&#34;\</td></tr><tr class="noCover"><td class="line"><a name="471">471</a></td><td class="hits"></td><td class="code">                            Unable to parse &#39;{field_name}&#39; for &#39;{cls.__name__}&#39;, value: {data[field_name]}</td></tr><tr class="noCover"><td class="line"><a name="472">472</a></td><td class="hits"></td><td class="code">                            (Using parser {str(string_parser)}, got error: {parse_error})&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="473">473</a></td><td class="hits"></td><td class="code">                        )</td></tr><tr class="noCover"><td class="line"><a name="474">474</a></td><td class="hits"></td><td class="code">                    )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="475">475</a></td><td class="hits">1</td><td class="code">                    if raise_parse_errors:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="476">476</a></td><td class="hits">0</td><td class="code">                        raise parse_error</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="477">477</a></td><td class="hits">1</td><td class="code">        if warn_missing_fields and set(missing_fields).difference(</td></tr><tr class="noCover"><td class="line"><a name="478">478</a></td><td class="hits"></td><td class="code">            inconsistent_and_ignorable_fields</td></tr><tr class="noCover"><td class="line"><a name="479">479</a></td><td class="hits"></td><td class="code">        ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="480">480</a></td><td class="hits">1</td><td class="code">            logger.warning(</td></tr><tr class="noCover"><td class="line"><a name="481">481</a></td><td class="hits"></td><td class="code">                f&#34;NetDot &#39;{cls.__name__}&#39; response missing field(s): {missing_fields}&#34;</td></tr><tr class="noCover"><td class="line"><a name="482">482</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="483">483</a></td><td class="hits">1</td><td class="code">        return cls._parse_data_transfer_obj(data)</td></tr><tr class="noCover"><td class="line"><a name="484">484</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="485">485</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="486">486</a></td><td class="hits">1</td><td class="code">    def _parse_data_transfer_obj(cls, data_transfer_object):</td></tr><tr class="noCover"><td class="line"><a name="487">487</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Parse some data retrieved from Netdot into a proper NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="488">488</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="489">489</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="490">490</a></td><td class="hits"></td><td class="code">            data_transfer_object (Dict): Dictionary of raw data returned from Netdot API.</td></tr><tr class="noCover"><td class="line"><a name="491">491</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="492">492</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="493">493</a></td><td class="hits"></td><td class="code">            NetdotAPIDataclass: The appropriate subclass of NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="494">494</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="495">495</a></td><td class="hits">1</td><td class="code">        cls._log_unknown_fields(data_transfer_object)</td></tr><tr class="noCover"><td class="line"><a name="496">496</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="497">497</a></td><td class="hits"></td><td class="code">        # Construct the new object!</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="498">498</a></td><td class="hits">1</td><td class="code">        fields_to_parse &#61; cls._get_known_fields(data_transfer_object)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="499">499</a></td><td class="hits">1</td><td class="code">        data_to_parse &#61; {key: data_transfer_object[key] for key in fields_to_parse}</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="500">500</a></td><td class="hits">1</td><td class="code">        return cls(**data_to_parse)</td></tr><tr class="noCover"><td class="line"><a name="501">501</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="502">502</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="503">503</a></td><td class="hits">1</td><td class="code">    def _get_known_fields(cls, data_transfer_object):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="504">504</a></td><td class="hits">1</td><td class="code">        valid_fields &#61; set(</td></tr><tr class="noCover"><td class="line"><a name="505">505</a></td><td class="hits"></td><td class="code">            [field_name.rstrip(&#39;_&#39;) for field_name in cls.__dataclass_fields__.keys()]</td></tr><tr class="noCover"><td class="line"><a name="506">506</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="507">507</a></td><td class="hits">1</td><td class="code">        valid_fields |&#61; set(cls.__dataclass_fields__.keys())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="508">508</a></td><td class="hits">1</td><td class="code">        provided_fields &#61; set(data_transfer_object.keys())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="509">509</a></td><td class="hits">1</td><td class="code">        return provided_fields.intersection(valid_fields)</td></tr><tr class="noCover"><td class="line"><a name="510">510</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="511">511</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="512">512</a></td><td class="hits">1</td><td class="code">    def _get_unknown_fields(cls, data_transfer_object):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="513">513</a></td><td class="hits">1</td><td class="code">        valid_fields &#61; set(</td></tr><tr class="noCover"><td class="line"><a name="514">514</a></td><td class="hits"></td><td class="code">            [field_name.rstrip(&#39;_&#39;) for field_name in cls.__dataclass_fields__.keys()]</td></tr><tr class="noCover"><td class="line"><a name="515">515</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="516">516</a></td><td class="hits">1</td><td class="code">        valid_fields |&#61; set(cls.__dataclass_fields__.keys())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="517">517</a></td><td class="hits">1</td><td class="code">        provided_fields &#61; set(data_transfer_object.keys())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="518">518</a></td><td class="hits">1</td><td class="code">        return provided_fields.difference(valid_fields)</td></tr><tr class="noCover"><td class="line"><a name="519">519</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="520">520</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="521">521</a></td><td class="hits">1</td><td class="code">    def _log_unknown_fields(cls, data_transfer_object):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="522">522</a></td><td class="hits">1</td><td class="code">        unused_fields &#61; cls._get_unknown_fields(data_transfer_object)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="523">523</a></td><td class="hits">1</td><td class="code">        if unused_fields:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="524">524</a></td><td class="hits">1</td><td class="code">            unused_data &#61; {key: data_transfer_object[key] for key in unused_fields}</td></tr><tr class="noCover"><td class="line"><a name="525">525</a></td><td class="hits"></td><td class="code">            # Always log a debug message with ALL the data</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="526">526</a></td><td class="hits">1</td><td class="code">            logger.debug(</td></tr><tr class="noCover"><td class="line"><a name="527">527</a></td><td class="hits"></td><td class="code">                f&#39;Unparsed data ({cls.__module__}.{cls.__name__}): {unused_data}&#39;</td></tr><tr class="noCover"><td class="line"><a name="528">528</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="529">529</a></td><td class="hits"></td><td class="code">            # If this is the first time we&#39;ve seen these &#39;unused field(s)&#39;, then log a warning!</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="530">530</a></td><td class="hits">1</td><td class="code">            if not unused_fields.issubset(cls._logged_unused_fields):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="531">531</a></td><td class="hits">1</td><td class="code">                cls._logged_unused_fields &#61; cls._logged_unused_fields.union(</td></tr><tr class="noCover"><td class="line"><a name="532">532</a></td><td class="hits"></td><td class="code">                    unused_fields</td></tr><tr class="noCover"><td class="line"><a name="533">533</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="534">534</a></td><td class="hits">1</td><td class="code">                logger.warning(</td></tr><tr class="noCover"><td class="line"><a name="535">535</a></td><td class="hits"></td><td class="code">                    f&#39;Received unknown field(s): {unused_data} &#39;</td></tr><tr class="noCover"><td class="line"><a name="536">536</a></td><td class="hits"></td><td class="code">                    &#43; f&#39;(to fix, add unknown field(s) to {cls.__module__}.{cls.__name__} )&#39;</td></tr><tr class="noCover"><td class="line"><a name="537">537</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="538">538</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="539">539</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="540">540</a></td><td class="hits">1</td><td class="code">    def _expand_wildcard_parsers(cls, DTO_field_parsers: Dict[str, Callable]) -&gt; None:</td></tr><tr class="noCover"><td class="line"><a name="541">541</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Expand any &#39;wildcard&#39; parsers.</td></tr><tr class="noCover"><td class="line"><a name="542">542</a></td><td class="hits"></td><td class="code">        NOTICE: This method updates the provided Dict in place.</td></tr><tr class="noCover"><td class="line"><a name="543">543</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="544">544</a></td><td class="hits"></td><td class="code">        If any of DTO_field_parsers starts with &#34;*&#34;, they will be expanded to match any of the fields available in DTO_data.</td></tr><tr class="noCover"><td class="line"><a name="545">545</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="546">546</a></td><td class="hits"></td><td class="code">        Example:</td></tr><tr class="noCover"><td class="line"><a name="547">547</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="548">548</a></td><td class="hits"></td><td class="code">            Assume we have NetdotAPIDataclass FooAddress.</td></tr><tr class="noCover"><td class="line"><a name="549">549</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="550">550</a></td><td class="hits"></td><td class="code">            &gt;&gt; from dataclasses import dataclass</td></tr><tr class="noCover"><td class="line"><a name="551">551</a></td><td class="hits"></td><td class="code">            &gt;&gt; &#64;dataclass</td></tr><tr class="noCover"><td class="line"><a name="552">552</a></td><td class="hits"></td><td class="code">            .. class FooAddress(NetdotAPIDataclass):</td></tr><tr class="noCover"><td class="line"><a name="553">553</a></td><td class="hits"></td><td class="code">            ..     local_addr: ipaddress.ip_address</td></tr><tr class="noCover"><td class="line"><a name="554">554</a></td><td class="hits"></td><td class="code">            ..     mgmt_addr: ipaddress.ip_address</td></tr><tr class="noCover"><td class="line"><a name="555">555</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="556">556</a></td><td class="hits"></td><td class="code">            &gt;&gt; DTO_field_parsers &#61; { &#39;*_addr&#39;: ipaddress.ip_address }</td></tr><tr class="noCover"><td class="line"><a name="557">557</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="558">558</a></td><td class="hits"></td><td class="code">            &gt;&gt; FooAddress.expand_wildcard_parsers(DTO_field_parsers)</td></tr><tr class="noCover"><td class="line"><a name="559">559</a></td><td class="hits"></td><td class="code">            {&#39;local_addr&#39;: , &#39;mgmt_addr&#39;: }</td></tr><tr class="noCover"><td class="line"><a name="560">560</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="561">561</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="562">562</a></td><td class="hits">1</td><td class="code">        def is_wildcard_pattern(field_name):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="563">563</a></td><td class="hits">1</td><td class="code">            return field_name.startswith(&#39;*&#39;) or field_name.endswith(&#39;*&#39;)</td></tr><tr class="noCover"><td class="line"><a name="564">564</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="565">565</a></td><td class="hits">1</td><td class="code">        wildcard_patterns &#61; filter(is_wildcard_pattern, DTO_field_parsers)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="566">566</a></td><td class="hits">1</td><td class="code">        wildcard_parsers &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="567">567</a></td><td class="hits"></td><td class="code">            pattern: DTO_field_parsers[pattern] for pattern in wildcard_patterns</td></tr><tr class="noCover"><td class="line"><a name="568">568</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="569">569</a></td><td class="hits">1</td><td class="code">        for wildcard_pattern, parser in wildcard_parsers.items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="570">570</a></td><td class="hits">1</td><td class="code">            del DTO_field_parsers[wildcard_pattern]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="571">571</a></td><td class="hits">1</td><td class="code">            pattern &#61; wildcard_pattern.strip(&#39;*&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="572">572</a></td><td class="hits">1</td><td class="code">            for actual_field_name in cls.__dataclass_fields__:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="573">573</a></td><td class="hits">1</td><td class="code">                if (</td></tr><tr class="noCover"><td class="line"><a name="574">574</a></td><td class="hits"></td><td class="code">                    wildcard_pattern.startswith(&#39;*&#39;)</td></tr><tr class="noCover"><td class="line"><a name="575">575</a></td><td class="hits"></td><td class="code">                    and actual_field_name.endswith(pattern)</td></tr><tr class="noCover"><td class="line"><a name="576">576</a></td><td class="hits"></td><td class="code">                ) or (</td></tr><tr class="noCover"><td class="line"><a name="577">577</a></td><td class="hits"></td><td class="code">                    wildcard_pattern.endswith(&#39;*&#39;)</td></tr><tr class="noCover"><td class="line"><a name="578">578</a></td><td class="hits"></td><td class="code">                    and actual_field_name.startswith(pattern)</td></tr><tr class="noCover"><td class="line"><a name="579">579</a></td><td class="hits"></td><td class="code">                ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="580">580</a></td><td class="hits">1</td><td class="code">                    DTO_field_parsers[actual_field_name] &#61; parser</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="581">581</a></td><td class="hits">1</td><td class="code">        return DTO_field_parsers</td></tr><tr class="noCover"><td class="line"><a name="582">582</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="583">583</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="584">584</a></td><td class="hits">1</td><td class="code">    def _infer_base_parsers(cls) -&gt; Dict[str, Callable]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="585">585</a></td><td class="hits">1</td><td class="code">        base_parsers &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="586">586</a></td><td class="hits"></td><td class="code">            field_name: dataclass_field.type</td></tr><tr class="noCover"><td class="line"><a name="587">587</a></td><td class="hits"></td><td class="code">            for field_name, dataclass_field in cls.__dataclass_fields__.items()</td></tr><tr class="noCover"><td class="line"><a name="588">588</a></td><td class="hits"></td><td class="code">            # if dataclass_field.type is not str</td></tr><tr class="noCover"><td class="line"><a name="589">589</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="590">590</a></td><td class="hits">1</td><td class="code">        for field_name, parser in base_parsers.items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="591">591</a></td><td class="hits">1</td><td class="code">            if parser is bool:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="592">592</a></td><td class="hits">1</td><td class="code">                base_parsers[field_name] &#61; parse.Boolean</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="593">593</a></td><td class="hits">1</td><td class="code">        return base_parsers</td></tr><tr class="noCover"><td class="line"><a name="594">594</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="595">595</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="596">596</a></td><td class="hits">1</td><td class="code">    def web_url(self) -&gt; str:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="597">597</a></td><td class="hits">1</td><td class="code">        submenu_web_url &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="598">598</a></td><td class="hits"></td><td class="code">            &#39;cable_plant&#39;: self._web_url2,</td></tr><tr class="noCover"><td class="line"><a name="599">599</a></td><td class="hits"></td><td class="code">            &#39;management&#39;: self._web_url1,</td></tr><tr class="noCover"><td class="line"><a name="600">600</a></td><td class="hits"></td><td class="code">            &#39;generic&#39;: self._web_url2,</td></tr><tr class="noCover"><td class="line"><a name="601">601</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="602">602</a></td><td class="hits">1</td><td class="code">        web_url_function &#61; submenu_web_url[self.NETDOT_MENU_URL_PATH]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="603">603</a></td><td class="hits">1</td><td class="code">        return web_url_function()</td></tr><tr class="noCover"><td class="line"><a name="604">604</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="605">605</a></td><td class="hits">1</td><td class="code">    def _web_url1(self) -&gt; str:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="606">606</a></td><td class="hits">1</td><td class="code">        if hasattr(self, &#39;NETDOT_URL_PATH&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="607">607</a></td><td class="hits">1</td><td class="code">            url_path &#61; (</td></tr><tr class="noCover"><td class="line"><a name="608">608</a></td><td class="hits"></td><td class="code">                f&#39;/{self.NETDOT_MENU_URL_PATH}/{self.NETDOT_URL_PATH.lower()}.html&#39;</td></tr><tr class="noCover"><td class="line"><a name="609">609</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="610">610</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="611">611</a></td><td class="hits">1</td><td class="code">            url_path &#61; (</td></tr><tr class="noCover"><td class="line"><a name="612">612</a></td><td class="hits"></td><td class="code">                f&#39;/{self.NETDOT_MENU_URL_PATH}/{self.NETDOT_TABLE_NAME.lower()}.html&#39;</td></tr><tr class="noCover"><td class="line"><a name="613">613</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="614">614</a></td><td class="hits">1</td><td class="code">        return f&#39;{self.netdot_url}{url_path}?id&#61;{self.id}&#39;</td></tr><tr class="noCover"><td class="line"><a name="615">615</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="616">616</a></td><td class="hits">1</td><td class="code">    def _web_url2(self) -&gt; str:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="617">617</a></td><td class="hits">1</td><td class="code">        url_path &#61; f&#39;/{self.NETDOT_MENU_URL_PATH}/view.html&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="618">618</a></td><td class="hits">1</td><td class="code">        params &#61; f&#39;table&#61;{self.NETDOT_TABLE_NAME}&amp;id&#61;{self.id}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="619">619</a></td><td class="hits">1</td><td class="code">        return f&#39;{self.netdot_url}{url_path}?{params}&#39;</td></tr><tr class="noCover"><td class="line"><a name="620">620</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="621">621</a></td><td class="hits">1</td><td class="code">    def with_repository(self, repository: &#39;netdot.Repository&#39;) -&gt; &#39;NetdotAPIDataclass&#39;:</td></tr><tr class="noCover"><td class="line"><a name="622">622</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Add your Netdot repository to this object (to simplify &#96;create_or_update&#96;, &#96;load_*&#96;, etc).&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="623">623</a></td><td class="hits">1</td><td class="code">        self._repository &#61; repository</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="624">624</a></td><td class="hits">1</td><td class="code">        return self</td></tr><tr class="noCover"><td class="line"><a name="625">625</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="626">626</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="627">627</a></td><td class="hits">1</td><td class="code">    def _generate_and_attach_others_m2m_add_methods(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="628">628</a></td><td class="hits">1</td><td class="code">        for xlink, xlink_dataclass in cls._related_classes().items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="629">629</a></td><td class="hits">1</td><td class="code">            if cls._associative_table:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="630">630</a></td><td class="hits">1</td><td class="code">                xlink_adder &#61; cls._generate_your_many_to_many_add_method(</td></tr><tr class="noCover"><td class="line"><a name="631">631</a></td><td class="hits"></td><td class="code">                    xlink, xlink_dataclass</td></tr><tr class="noCover"><td class="line"><a name="632">632</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="633">633</a></td><td class="hits">1</td><td class="code">                xlink_dataclass._attach_methods([xlink_adder])</td></tr><tr class="noCover"><td class="line"><a name="634">634</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="635">635</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="636">636</a></td><td class="hits">1</td><td class="code">    def _generate_and_attach_others_add_xlink_methods(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="637">637</a></td><td class="hits">1</td><td class="code">        for xlink, xlink_dataclass in cls._related_classes().items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="638">638</a></td><td class="hits">1</td><td class="code">            xlink_adder &#61; cls._generate_your_xlink_add_method(</td></tr><tr class="noCover"><td class="line"><a name="639">639</a></td><td class="hits"></td><td class="code">                xlink,</td></tr><tr class="noCover"><td class="line"><a name="640">640</a></td><td class="hits"></td><td class="code">                xlink_dataclass,</td></tr><tr class="noCover"><td class="line"><a name="641">641</a></td><td class="hits"></td><td class="code">                include_xlink_in_name&#61;cls._related_class_repeats(xlink_dataclass),</td></tr><tr class="noCover"><td class="line"><a name="642">642</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="643">643</a></td><td class="hits">1</td><td class="code">            xlink_dataclass._attach_methods([xlink_adder])</td></tr><tr class="noCover"><td class="line"><a name="644">644</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="645">645</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="646">646</a></td><td class="hits">1</td><td class="code">    def _generate_and_attach_my_getter_methods(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="647">647</a></td><td class="hits">1</td><td class="code">        for xlink, xlink_dataclass in cls._related_classes().items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="648">648</a></td><td class="hits">1</td><td class="code">            xlink_loader &#61; cls._generate_my_xlink_load_method(xlink, xlink_dataclass)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="649">649</a></td><td class="hits">1</td><td class="code">            cls._attach_methods([xlink_loader])</td></tr><tr class="noCover"><td class="line"><a name="650">650</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="651">651</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="652">652</a></td><td class="hits">1</td><td class="code">    def _related_class_repeats(cls, other_cls: &#39;NetdotAPIDataclass&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="653">653</a></td><td class="hits">1</td><td class="code">        return list(cls._related_classes().values()).count(other_cls) &gt; 1</td></tr><tr class="noCover"><td class="line"><a name="654">654</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="655">655</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="656">656</a></td><td class="hits">1</td><td class="code">    def _generate_and_attach_others_getAll_methods(cls):</td></tr><tr class="noCover"><td class="line"><a name="657">657</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate all the &#39;load_XXXs&#39; methods for classes that this class is referenced by.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="658">658</a></td><td class="hits">1</td><td class="code">        for xlink, dataclass in cls._related_classes().items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="659">659</a></td><td class="hits">1</td><td class="code">            xlink_loaders &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="660">660</a></td><td class="hits">1</td><td class="code">            if cls._associative_table:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="661">661</a></td><td class="hits">1</td><td class="code">                xlink_loaders.append(</td></tr><tr class="noCover"><td class="line"><a name="662">662</a></td><td class="hits"></td><td class="code">                    cls._generate_your_many_to_many_load_method(xlink, dataclass)</td></tr><tr class="noCover"><td class="line"><a name="663">663</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="664">664</a></td><td class="hits">1</td><td class="code">                xlink_loaders.append(</td></tr><tr class="noCover"><td class="line"><a name="665">665</a></td><td class="hits"></td><td class="code">                    cls._generate_your_xlink_load_method(xlink, dataclass)</td></tr><tr class="noCover"><td class="line"><a name="666">666</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="667">667</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="668">668</a></td><td class="hits">1</td><td class="code">                xlink_loaders.append(</td></tr><tr class="noCover"><td class="line"><a name="669">669</a></td><td class="hits"></td><td class="code">                    cls._generate_your_xlink_load_method(</td></tr><tr class="noCover"><td class="line"><a name="670">670</a></td><td class="hits"></td><td class="code">                        xlink,</td></tr><tr class="noCover"><td class="line"><a name="671">671</a></td><td class="hits"></td><td class="code">                        dataclass,</td></tr><tr class="noCover"><td class="line"><a name="672">672</a></td><td class="hits"></td><td class="code">                        include_xlink_in_name&#61;cls._related_class_repeats(dataclass),</td></tr><tr class="noCover"><td class="line"><a name="673">673</a></td><td class="hits"></td><td class="code">                    )</td></tr><tr class="noCover"><td class="line"><a name="674">674</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="675">675</a></td><td class="hits">1</td><td class="code">            dataclass._attach_methods(xlink_loaders)</td></tr><tr class="noCover"><td class="line"><a name="676">676</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="677">677</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="678">678</a></td><td class="hits">1</td><td class="code">    def _generate_my_xlink_load_method(my_cls, xlink, other_cls):</td></tr><tr class="noCover"><td class="line"><a name="679">679</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate the &#96;load_xlink()&#96; method to be attached to cls.</td></tr><tr class="noCover"><td class="line"><a name="680">680</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="681">681</a></td><td class="hits"></td><td class="code">        E.g. will generate load_site() when other_cls is netdot.Site.</td></tr><tr class="noCover"><td class="line"><a name="682">682</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="683">683</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="684">684</a></td><td class="hits">1</td><td class="code">        def xlink_loader(self) -&gt; other_cls:  # type: ignore</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="685">685</a></td><td class="hits">1</td><td class="code">            self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="686">686</a></td><td class="hits">1</td><td class="code">            xlink_id &#61; getattr(self, xlink)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="687">687</a></td><td class="hits">1</td><td class="code">            if not xlink_id:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="688">688</a></td><td class="hits">1</td><td class="code">                return None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="689">689</a></td><td class="hits">1</td><td class="code">            download_function_name &#61; f&#39;get_{other_cls._pep8_method_friendly_name()}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="690">690</a></td><td class="hits">1</td><td class="code">            download_function &#61; getattr(self.repository, download_function_name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="691">691</a></td><td class="hits">1</td><td class="code">            return download_function(xlink_id)</td></tr><tr class="noCover"><td class="line"><a name="692">692</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="693">693</a></td><td class="hits">1</td><td class="code">        xlink_loader.__doc__ &#61; f&#34;&#34;&#34;Load the {xlink.replace(&#39;_xlink&#39;, &#39;&#39;)} ({other_cls.__name__}) associated to this {my_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="694">694</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="695">695</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="696">696</a></td><td class="hits"></td><td class="code">        netdot.{other_cls.__name__}: The full {other_cls.__name__} object if available, else None.</td></tr><tr class="noCover"><td class="line"><a name="697">697</a></td><td class="hits"></td><td class="code">            &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="698">698</a></td><td class="hits">1</td><td class="code">        xlink_loader.__name__ &#61; f&#34;load_{xlink.replace(&#39;_xlink&#39;, &#39;&#39;)}&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="699">699</a></td><td class="hits">1</td><td class="code">        return xlink_loader</td></tr><tr class="noCover"><td class="line"><a name="700">700</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="701">701</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="702">702</a></td><td class="hits">1</td><td class="code">    def _generate_your_many_to_many_add_method(</td></tr><tr class="noCover"><td class="line"><a name="703">703</a></td><td class="hits"></td><td class="code">        cls, xlink: str, my_cls: &#39;NetdotAPIDataclass&#39;</td></tr><tr class="noCover"><td class="line"><a name="704">704</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="705">705</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate a &#96;add_xlinks()&#96; method to be attached to my_cls (NOT m2m_cls)</td></tr><tr class="noCover"><td class="line"><a name="706">706</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="707">707</a></td><td class="hits"></td><td class="code">        E.g. will generate add_device() when my_cls is netdot.Device</td></tr><tr class="noCover"><td class="line"><a name="708">708</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="709">709</a></td><td class="hits">1</td><td class="code">        m2m_cls &#61; cls</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="710">710</a></td><td class="hits">1</td><td class="code">        other_cls &#61; m2m_cls._associative_table_other_class(my_cls)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="711">711</a></td><td class="hits">1</td><td class="code">        other_cls_xlink_name &#61; m2m_cls._associative_table_other_class_xlink_name(</td></tr><tr class="noCover"><td class="line"><a name="712">712</a></td><td class="hits"></td><td class="code">            other_cls</td></tr><tr class="noCover"><td class="line"><a name="713">713</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="714">714</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="715">715</a></td><td class="hits">1</td><td class="code">        def xlink_adder(self, data: other_cls) -&gt; other_cls:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="716">716</a></td><td class="hits">1</td><td class="code">            self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="717">717</a></td><td class="hits">1</td><td class="code">            new_object &#61; m2m_cls(</td></tr><tr class="noCover"><td class="line"><a name="718">718</a></td><td class="hits"></td><td class="code">                **{<!-- --></td></tr><tr class="noCover"><td class="line"><a name="719">719</a></td><td class="hits"></td><td class="code">                    other_cls_xlink_name: data,</td></tr><tr class="noCover"><td class="line"><a name="720">720</a></td><td class="hits"></td><td class="code">                    my_cls._pep8_method_friendly_name(): self,</td></tr><tr class="noCover"><td class="line"><a name="721">721</a></td><td class="hits"></td><td class="code">                }</td></tr><tr class="noCover"><td class="line"><a name="722">722</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="723">723</a></td><td class="hits">1</td><td class="code">            return self.repository.create_new(new_object)</td></tr><tr class="noCover"><td class="line"><a name="724">724</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="725">725</a></td><td class="hits">1</td><td class="code">        xlink_adder.__doc__ &#61; f&#34;&#34;&#34;Add a {other_cls.__name__} to this {my_cls.__name__} (via {m2m_cls.__name__}).</td></tr><tr class="noCover"><td class="line"><a name="726">726</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="727">727</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="728">728</a></td><td class="hits"></td><td class="code">        data (netdot.{other_cls.__name__}): The {other_cls.__name__} to add to this {my_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="729">729</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="730">730</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="731">731</a></td><td class="hits"></td><td class="code">        netdot.{m2m_cls.__name__}: The newly created {m2m_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="732">732</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="733">733</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="734">734</a></td><td class="hits"></td><td class="code">        HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="735">735</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="736">736</a></td><td class="hits">1</td><td class="code">        xlink_adder.__name__ &#61; f&#39;add_{other_cls_xlink_name}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="737">737</a></td><td class="hits">1</td><td class="code">        return xlink_adder</td></tr><tr class="noCover"><td class="line"><a name="738">738</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="739">739</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="740">740</a></td><td class="hits">1</td><td class="code">    def _generate_your_many_to_many_load_method(</td></tr><tr class="noCover"><td class="line"><a name="741">741</a></td><td class="hits"></td><td class="code">        cls, xlink: str, my_cls: &#39;NetdotAPIDataclass&#39;</td></tr><tr class="noCover"><td class="line"><a name="742">742</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="743">743</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate a &#96;load_xlinks()&#96; method to be attached to my_cls (NOT m2m_cls)</td></tr><tr class="noCover"><td class="line"><a name="744">744</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="745">745</a></td><td class="hits"></td><td class="code">        E.g. will generate load_devices() when my_cls is netdot.Device.</td></tr><tr class="noCover"><td class="line"><a name="746">746</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="747">747</a></td><td class="hits">1</td><td class="code">        m2m_cls &#61; cls</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="748">748</a></td><td class="hits">1</td><td class="code">        other_cls &#61; m2m_cls._associative_table_other_class(my_cls)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="749">749</a></td><td class="hits">1</td><td class="code">        other_cls_xlink_name &#61; m2m_cls._associative_table_other_class_xlink_name(</td></tr><tr class="noCover"><td class="line"><a name="750">750</a></td><td class="hits"></td><td class="code">            other_cls</td></tr><tr class="noCover"><td class="line"><a name="751">751</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="752">752</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="753">753</a></td><td class="hits">1</td><td class="code">        def xlink_loader(self, ignore_404&#61;True) -&gt; List[other_cls]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="754">754</a></td><td class="hits">1</td><td class="code">            self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="755">755</a></td><td class="hits">1</td><td class="code">            try:</td></tr><tr class="noCover"><td class="line"><a name="756">756</a></td><td class="hits"></td><td class="code">                # Download all the many-to-many objects</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="757">757</a></td><td class="hits">1</td><td class="code">                download_m2m_function_name &#61; f&#34;get_{m2m_cls._name_pluralized().lower()}_by_{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="758">758</a></td><td class="hits">1</td><td class="code">                download_m2m_function &#61; getattr(</td></tr><tr class="noCover"><td class="line"><a name="759">759</a></td><td class="hits"></td><td class="code">                    self.repository, download_m2m_function_name</td></tr><tr class="noCover"><td class="line"><a name="760">760</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="761">761</a></td><td class="hits">1</td><td class="code">                downloaded_m2m_data &#61; download_m2m_function(self.id)</td></tr><tr class="noCover"><td class="line"><a name="762">762</a></td><td class="hits"></td><td class="code">                # Download the data itself</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="763">763</a></td><td class="hits">1</td><td class="code">                download_function_name &#61; f&#39;get_{other_cls._pep8_method_friendly_name()}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="764">764</a></td><td class="hits">1</td><td class="code">                download_function &#61; getattr(self.repository, download_function_name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="765">765</a></td><td class="hits">1</td><td class="code">                downloaded_data &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="766">766</a></td><td class="hits">1</td><td class="code">                for m2m_data in downloaded_m2m_data:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="767">767</a></td><td class="hits">1</td><td class="code">                    try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="768">768</a></td><td class="hits">1</td><td class="code">                        m2m_other_id &#61; getattr(</td></tr><tr class="noCover"><td class="line"><a name="769">769</a></td><td class="hits"></td><td class="code">                            m2m_data, f&#39;{other_cls_xlink_name}_xlink&#39;</td></tr><tr class="noCover"><td class="line"><a name="770">770</a></td><td class="hits"></td><td class="code">                        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="771">771</a></td><td class="hits">1</td><td class="code">                        downloaded_data.append(download_function(m2m_other_id))</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="772">772</a></td><td class="hits">0</td><td class="code">                    except netdot.exceptions.HTTPError as e:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="773">773</a></td><td class="hits">0</td><td class="code">                        if (</td></tr><tr class="noCover"><td class="line"><a name="774">774</a></td><td class="hits"></td><td class="code">                            ignore_404</td></tr><tr class="noCover"><td class="line"><a name="775">775</a></td><td class="hits"></td><td class="code">                            and hasattr(e.response, &#39;status_code&#39;)</td></tr><tr class="noCover"><td class="line"><a name="776">776</a></td><td class="hits"></td><td class="code">                            and e.response.status_code &#61;&#61; 404</td></tr><tr class="noCover"><td class="line"><a name="777">777</a></td><td class="hits"></td><td class="code">                        ):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="778">778</a></td><td class="hits">0</td><td class="code">                            continue</td></tr><tr class="noCover"><td class="line"><a name="779">779</a></td><td class="hits"></td><td class="code">                        else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="780">780</a></td><td class="hits">0</td><td class="code">                            raise e</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="781">781</a></td><td class="hits">1</td><td class="code">                return downloaded_data</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="782">782</a></td><td class="hits">1</td><td class="code">            except netdot.exceptions.HTTPError as e:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="783">783</a></td><td class="hits">1</td><td class="code">                if (</td></tr><tr class="noCover"><td class="line"><a name="784">784</a></td><td class="hits"></td><td class="code">                    ignore_404</td></tr><tr class="noCover"><td class="line"><a name="785">785</a></td><td class="hits"></td><td class="code">                    and hasattr(e.response, &#39;status_code&#39;)</td></tr><tr class="noCover"><td class="line"><a name="786">786</a></td><td class="hits"></td><td class="code">                    and e.response.status_code &#61;&#61; 404</td></tr><tr class="noCover"><td class="line"><a name="787">787</a></td><td class="hits"></td><td class="code">                ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="788">788</a></td><td class="hits">1</td><td class="code">                    return []</td></tr><tr class="noCover"><td class="line"><a name="789">789</a></td><td class="hits"></td><td class="code">                else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="790">790</a></td><td class="hits">1</td><td class="code">                    raise e</td></tr><tr class="noCover"><td class="line"><a name="791">791</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="792">792</a></td><td class="hits">1</td><td class="code">        xlink_loader.__doc__ &#61; f&#34;&#34;&#34;Load the {utils.pluralize(other_cls_xlink_name)} ({other_cls._name_pluralized()}) associated to this {my_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="793">793</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="794">794</a></td><td class="hits"></td><td class="code">    &gt; NOTE: This will make &#96;N&#43;1&#96; HTTP Requests (where N is the number of {other_cls._name_pluralized()} associated to this {my_cls.__name__}).</td></tr><tr class="noCover"><td class="line"><a name="795">795</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="796">796</a></td><td class="hits"></td><td class="code">    You might prefer :func:&#96;load_{m2m_cls._name_pluralized().lower()}&#96; over this method, if you want to load the many-to-many objects themselves. (and not make N&#43;1 HTTP Requests)</td></tr><tr class="noCover"><td class="line"><a name="797">797</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="798">798</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="799">799</a></td><td class="hits"></td><td class="code">        ignore_404 (bool, optional): If True, will continue upon encountering HTTP 404 errors. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="800">800</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="801">801</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="802">802</a></td><td class="hits"></td><td class="code">        List[netdot.{other_cls.__name__}]: Any/All {other_cls._name_pluralized()} related to this {my_cls.__name__}, or an empty list if none are found.</td></tr><tr class="noCover"><td class="line"><a name="803">803</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="804">804</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="805">805</a></td><td class="hits"></td><td class="code">        HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="806">806</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="807">807</a></td><td class="hits">1</td><td class="code">        xlink_loader.__name__ &#61; f&#39;load_{utils.pluralize(other_cls_xlink_name)}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="808">808</a></td><td class="hits">1</td><td class="code">        return xlink_loader</td></tr><tr class="noCover"><td class="line"><a name="809">809</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="810">810</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="811">811</a></td><td class="hits">1</td><td class="code">    def _generate_your_xlink_load_method(</td></tr><tr class="noCover"><td class="line"><a name="812">812</a></td><td class="hits"></td><td class="code">        my_cls, xlink: str, other_cls: &#39;NetdotAPIDataclass&#39;, include_xlink_in_name&#61;False</td></tr><tr class="noCover"><td class="line"><a name="813">813</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="814">814</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate the &#96;load_xlinks()&#96; method to be attached to other_cls.</td></tr><tr class="noCover"><td class="line"><a name="815">815</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="816">816</a></td><td class="hits"></td><td class="code">        E.g. will generate load_devices() when my_cls is netdot.Device.&#61;T</td></tr><tr class="noCover"><td class="line"><a name="817">817</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="818">818</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="819">819</a></td><td class="hits">1</td><td class="code">        def xlink_loader(self, ignore_404&#61;True) -&gt; List[my_cls]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="820">820</a></td><td class="hits">1</td><td class="code">            self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="821">821</a></td><td class="hits">1</td><td class="code">            download_function_name &#61; f&#34;get_{my_cls._name_pluralized().lower()}_by_{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="822">822</a></td><td class="hits">1</td><td class="code">            download_function &#61; getattr(self.repository, download_function_name)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="823">823</a></td><td class="hits">1</td><td class="code">            try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="824">824</a></td><td class="hits">1</td><td class="code">                return download_function(self.id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="825">825</a></td><td class="hits">1</td><td class="code">            except netdot.exceptions.HTTPError as e:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="826">826</a></td><td class="hits">1</td><td class="code">                    if (</td></tr><tr class="noCover"><td class="line"><a name="827">827</a></td><td class="hits"></td><td class="code">                        ignore_404</td></tr><tr class="noCover"><td class="line"><a name="828">828</a></td><td class="hits"></td><td class="code">                        and hasattr(e.response, &#39;status_code&#39;)</td></tr><tr class="noCover"><td class="line"><a name="829">829</a></td><td class="hits"></td><td class="code">                        and e.response.status_code &#61;&#61; 404</td></tr><tr class="noCover"><td class="line"><a name="830">830</a></td><td class="hits"></td><td class="code">                    ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="831">831</a></td><td class="hits">1</td><td class="code">                        return []</td></tr><tr class="noCover"><td class="line"><a name="832">832</a></td><td class="hits"></td><td class="code">                    else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="833">833</a></td><td class="hits">0</td><td class="code">                        raise e</td></tr><tr class="noCover"><td class="line"><a name="834">834</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="835">835</a></td><td class="hits">1</td><td class="code">        docstring &#61; f&#39;Load the {my_cls._name_pluralized()} associated to this {other_cls.__name__}.&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="836">836</a></td><td class="hits">1</td><td class="code">        if other_cls.__name__.lower() !&#61; xlink.replace(&#39;_xlink&#39;, &#39;&#39;):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="837">837</a></td><td class="hits">1</td><td class="code">            docstring &#43;&#61; (</td></tr><tr class="noCover"><td class="line"><a name="838">838</a></td><td class="hits"></td><td class="code">                f&#34; (Via the &#96;{my_cls.__name__}.{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#96; attribute)&#34;</td></tr><tr class="noCover"><td class="line"><a name="839">839</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="840">840</a></td><td class="hits">1</td><td class="code">        xlink_loader.__doc__ &#61; f&#34;&#34;&#34;{docstring}</td></tr><tr class="noCover"><td class="line"><a name="841">841</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="842">842</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="843">843</a></td><td class="hits"></td><td class="code">        ignore_404 (bool, optional): If True, will continue upon encountering HTTP 404 errors. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="844">844</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="845">845</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="846">846</a></td><td class="hits"></td><td class="code">        List[netdot.{my_cls.__name__}]: All/Any {my_cls._name_pluralized()} related to this {other_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="847">847</a></td><td class="hits"></td><td class="code">        </td></tr><tr class="noCover"><td class="line"><a name="848">848</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="849">849</a></td><td class="hits"></td><td class="code">        HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="850">850</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="851">851</a></td><td class="hits">1</td><td class="code">        method_name &#61; &#39;load&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="852">852</a></td><td class="hits">1</td><td class="code">        if include_xlink_in_name:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="853">853</a></td><td class="hits">1</td><td class="code">            method_name &#43;&#61; f&#34;_{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="854">854</a></td><td class="hits">1</td><td class="code">        method_name &#43;&#61; f&#39;_{my_cls._name_pluralized().lower()}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="855">855</a></td><td class="hits">1</td><td class="code">        xlink_loader.__name__ &#61; method_name</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="856">856</a></td><td class="hits">1</td><td class="code">        return xlink_loader</td></tr><tr class="noCover"><td class="line"><a name="857">857</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="858">858</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="859">859</a></td><td class="hits">1</td><td class="code">    def _generate_your_xlink_add_method(</td></tr><tr class="noCover"><td class="line"><a name="860">860</a></td><td class="hits"></td><td class="code">        my_cls, xlink: str, other_cls: &#39;NetdotAPIDataclass&#39;, include_xlink_in_name&#61;False</td></tr><tr class="noCover"><td class="line"><a name="861">861</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="862">862</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Generate the &#96;add_xlink()&#96; method to be attached to other_cls.</td></tr><tr class="noCover"><td class="line"><a name="863">863</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="864">864</a></td><td class="hits"></td><td class="code">        E.g. will generate add_device() when my_cls is netdot.Device.</td></tr><tr class="noCover"><td class="line"><a name="865">865</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="866">866</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="867">867</a></td><td class="hits">1</td><td class="code">        def xlink_adder(self, data: my_cls) -&gt; my_cls:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="868">868</a></td><td class="hits">1</td><td class="code">            self._assert_repository_attached()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="869">869</a></td><td class="hits">1</td><td class="code">            setattr(data, xlink.replace(&#39;_xlink&#39;, &#39;&#39;), self)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="870">870</a></td><td class="hits">1</td><td class="code">            return self.repository.create_new(data)</td></tr><tr class="noCover"><td class="line"><a name="871">871</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="872">872</a></td><td class="hits">1</td><td class="code">        xlink_adder.__doc__ &#61; f&#34;&#34;&#34;Add a {my_cls.__name__} to this {other_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="873">873</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="874">874</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="875">875</a></td><td class="hits"></td><td class="code">        netdot.{my_cls.__name__}: The created {my_cls.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="876">876</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="877">877</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="878">878</a></td><td class="hits"></td><td class="code">        HTTPError: For any HTTP errors. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="879">879</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="880">880</a></td><td class="hits">1</td><td class="code">        method_name &#61; &#39;add&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="881">881</a></td><td class="hits">1</td><td class="code">        method_name &#43;&#61; f&#39;_{my_cls.__name__.lower()}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="882">882</a></td><td class="hits">1</td><td class="code">        if include_xlink_in_name:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="883">883</a></td><td class="hits">1</td><td class="code">            method_name &#43;&#61; f&#34;_as_{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#34;</td></tr><tr class="noCover"><td class="line"><a name="884">884</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="885">885</a></td><td class="hits">1</td><td class="code">        xlink_adder.__name__ &#61; method_name</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="886">886</a></td><td class="hits">1</td><td class="code">        return xlink_adder</td></tr>