<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">from dataclasses import dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">from typing import List</td></tr><tr class="noCover"><td class="line"><a name="4">4</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">from netdot import parse</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">from netdot.dataclasses.base import NetdotAPIDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from netdot.mac_address import MACAddress</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">def is_up(up_str: str):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">    return up_str.lower().strip() &#61;&#61; &#34;up&#34;</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="18">18</a></td><td class="hits">1</td><td class="code">class Interface(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Interface&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="21">21</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code">        &#39;jack&#39;: &#39;HorizontalCable&#39;,</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code">        &#39;neighbor&#39;: &#39;Interface&#39;,</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="25">25</a></td><td class="hits">1</td><td class="code">    id: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="26">26</a></td><td class="hits">1</td><td class="code">    physaddr: MACAddress &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">    physaddr_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="28">28</a></td><td class="hits">1</td><td class="code">    oper_status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="29">29</a></td><td class="hits">1</td><td class="code">    admin_status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">    neighbor: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">    admin_duplex: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">    admin_status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">    bpdu_filter_enabled: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">    bpdu_guard_enabled: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="35">35</a></td><td class="hits">1</td><td class="code">    contactlist: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="36">36</a></td><td class="hits">1</td><td class="code">    contactlist_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">    description: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="38">38</a></td><td class="hits">1</td><td class="code">    device: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">    device_xlink: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">    doc_status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">    down_from: parse.DateTime &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">    down_until: parse.DateTime &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="43">43</a></td><td class="hits">1</td><td class="code">    dp_remote_id: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="44">44</a></td><td class="hits">1</td><td class="code">    dp_remote_ip: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">    dp_remote_port: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">    dp_remote_type: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="48">48</a></td><td class="hits">1</td><td class="code">    jack: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">    jack_xlink: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">    jack_char: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    loop_guard_enabled: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">    monitored: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="53">53</a></td><td class="hits">1</td><td class="code">    monitorstatus: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="54">54</a></td><td class="hits">1</td><td class="code">    monitorstatus_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="55">55</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">    neighbor: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">    neighbor_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">    neighbor_fixed: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="59">59</a></td><td class="hits">1</td><td class="code">    neighbor_missed: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="60">60</a></td><td class="hits">1</td><td class="code">    number: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="61">61</a></td><td class="hits">1</td><td class="code">    oper_duplex: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="62">62</a></td><td class="hits">1</td><td class="code">    oper_status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">    overwrite_descr: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="64">64</a></td><td class="hits">1</td><td class="code">    room_char: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="65">65</a></td><td class="hits">1</td><td class="code">    root_guard_enabled: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="66">66</a></td><td class="hits">1</td><td class="code">    snmp_managed: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="67">67</a></td><td class="hits">1</td><td class="code">    speed: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="68">68</a></td><td class="hits">1</td><td class="code">    stp_id: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="69">69</a></td><td class="hits">1</td><td class="code">    type: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">    ignore_ip: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">    auto_dns: bool &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">    circuit: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">    dlci: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="74">74</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="75">75</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">    def oper_up(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="77">77</a></td><td class="hits">1</td><td class="code">        return is_up(self.oper_status)</td></tr><tr class="noCover"><td class="line"><a name="78">78</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="79">79</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">    def admin_up(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="81">81</a></td><td class="hits">1</td><td class="code">        return is_up(self.admin_status)</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="83">83</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">    def is_up(self):</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;An interface is &#39;up&#39; if both the &#39;admin&#39; and &#39;oper&#39; status are &#39;up&#39;&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="86">86</a></td><td class="hits">1</td><td class="code">        return self.oper_up and self.admin_up</td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">    # def _is_access_port(self):</td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code">    #     &#34;&#34;&#34;TODO Is this an access port? (best-effort, may also include non-access ports)</td></tr><tr class="noCover"><td class="line"><a name="90">90</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">    #     An Access Port is one that is used by the actual access layer, e.g. desktops, servers, laptops.</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="93">93</a></td><td class="hits"></td><td class="code">    #     We determine whether this interface may be an access first by checking for the following:</td></tr><tr class="noCover"><td class="line"><a name="94">94</a></td><td class="hits"></td><td class="code">    #     * a single VLAN,</td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code">    #     * named like a physical interface...* TODO</td></tr><tr class="noCover"><td class="line"><a name="96">96</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="97">97</a></td><td class="hits"></td><td class="code">    #     Then, we can look for any signs any signs it is NOT an access port:</td></tr><tr class="noCover"><td class="line"><a name="98">98</a></td><td class="hits"></td><td class="code">    #     * has a &#39;neighboring interface&#39;,</td></tr><tr class="noCover"><td class="line"><a name="99">99</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="100">100</a></td><td class="hits"></td><td class="code">    #     TODO: Is this valid we have LLDP-MED access ports?</td></tr><tr class="noCover"><td class="line"><a name="101">101</a></td><td class="hits"></td><td class="code">    #     &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="102">102</a></td><td class="hits"></td><td class="code">    #     if self.neighbor is None:</td></tr><tr class="noCover"><td class="line"><a name="103">103</a></td><td class="hits"></td><td class="code">    #         return False</td></tr><tr class="noCover"><td class="line"><a name="104">104</a></td><td class="hits"></td><td class="code">    #     vlans &#61; self.get_vlans()</td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code">    #     if len(vlans) !&#61; 1:</td></tr><tr class="noCover"><td class="line"><a name="106">106</a></td><td class="hits"></td><td class="code">    #         return False</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code">    #     return True</td></tr><tr class="noCover"><td class="line"><a name="108">108</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="109">109</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="110">110</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="111">111</a></td><td class="hits">1</td><td class="code">class InterfaceVLAN(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="112">112</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="113">113</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;InterfaceVlan&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="114">114</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="115">115</a></td><td class="hits"></td><td class="code">        &#34;stp_instance&#34;: &#34;STPInstance&#34;,</td></tr><tr class="noCover"><td class="line"><a name="116">116</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="117">117</a></td><td class="hits">1</td><td class="code">    interface: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="118">118</a></td><td class="hits">1</td><td class="code">    interface_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">    stp_des_bridge: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="120">120</a></td><td class="hits">1</td><td class="code">    stp_des_port: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="121">121</a></td><td class="hits">1</td><td class="code">    stp_instance: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="122">122</a></td><td class="hits">1</td><td class="code">    stp_instance_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="123">123</a></td><td class="hits">1</td><td class="code">    stp_state: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="124">124</a></td><td class="hits">1</td><td class="code">    vlan: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="125">125</a></td><td class="hits">1</td><td class="code">    vlan_xlink: int &#61; None</td></tr>