<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import ipaddress</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">from dataclasses import dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">from typing import List</td></tr><tr class="noCover"><td class="line"><a name="5">5</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">from netdot.dataclasses.base import NetdotAPIDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from netdot import parse</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">class IPBlock(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Represents either a subnet or an individual address.</td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="17">17</a></td><td class="hits"></td><td class="code">    # TODO: consider making aliases for this class: IPContainer IPAddress, IPSubnet</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Ipblock&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="21">21</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code">        &#34;parent_xlink&#34;: &#34;IPBlock&#34;,</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code">        &#34;owner&#34;: &#34;Entity&#34;,</td></tr><tr class="noCover"><td class="line"><a name="24">24</a></td><td class="hits"></td><td class="code">        &#34;used_by&#34;: &#34;Entity&#34;,</td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code">        &#34;status&#34;: &#34;IPBlockStatus&#34;,</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="28">28</a></td><td class="hits">1</td><td class="code">    address: ipaddress.ip_address &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="29">29</a></td><td class="hits">1</td><td class="code">    description: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">    first_seen: parse.DateTime &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">    interface: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">    interface_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">    last_seen: parse.DateTime &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="35">35</a></td><td class="hits">1</td><td class="code">    owner: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="36">36</a></td><td class="hits">1</td><td class="code">    owner_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">    parent: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="38">38</a></td><td class="hits">1</td><td class="code">    parent_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">    prefix: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">    status: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">    status_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">    used_by: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="43">43</a></td><td class="hits">1</td><td class="code">    used_by_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="44">44</a></td><td class="hits">1</td><td class="code">    version: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">    vlan: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">    vlan_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    use_network_broadcast: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="48">48</a></td><td class="hits">1</td><td class="code">    monitored: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">    rir: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">    asn: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    asn_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">    _parent: List[&#34;IPBlock&#34;] &#61; None</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="54">54</a></td><td class="hits">1</td><td class="code">    def load_parent(self) -&gt; &#34;IPBlock&#34;:</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the parent of this IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="57">57</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="58">58</a></td><td class="hits"></td><td class="code">            IPBlock: The parent of this IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="60">60</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code">            HTTPError: If no results found. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">        if self._parent is None:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="64">64</a></td><td class="hits">1</td><td class="code">            self._parent &#61; self.repository.get_ipblock(self.parent_xlink)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="65">65</a></td><td class="hits">1</td><td class="code">        return self._parent</td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="67">67</a></td><td class="hits">1</td><td class="code">    def load_children(self) -&gt; List[&#34;IPBlock&#34;]:</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the children of this IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="70">70</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="71">71</a></td><td class="hits"></td><td class="code">            List[IPBlock]: The children of this IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="72">72</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="73">73</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="74">74</a></td><td class="hits"></td><td class="code">            HTTPError: If no results found. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">        return self.repository.get_ipblock_children(self.id)</td></tr><tr class="noCover"><td class="line"><a name="77">77</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="78">78</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="79">79</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">class IPBlockAttrName(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="81">81</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="82">82</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;IpblockAttrName&#34;</td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="85">85</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="87">87</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="88">88</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="89">89</a></td><td class="hits">1</td><td class="code">class IPBlockStatus(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="91">91</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;IpblockStatus&#34;</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="94">94</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="96">96</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="97">97</a></td><td class="hits">1</td><td class="code">class Service(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="98">98</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Network services, such as: NTP, POP3, RADIUS, SMTP, SSH, TELNET...&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="99">99</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="100">100</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="101">101</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Service&#34;</td></tr><tr class="noCover"><td class="line"><a name="102">102</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="104">104</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="106">106</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="107">107</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="108">108</a></td><td class="hits">1</td><td class="code">class IPBlockAttr(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="109">109</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="110">110</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;IpblockAttr&#34;</td></tr><tr class="noCover"><td class="line"><a name="111">111</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="112">112</a></td><td class="hits">1</td><td class="code">    ipblock: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="113">113</a></td><td class="hits">1</td><td class="code">    ipblock_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="114">114</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="115">115</a></td><td class="hits">1</td><td class="code">    name_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="116">116</a></td><td class="hits">1</td><td class="code">    value: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="117">117</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="118">118</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="120">120</a></td><td class="hits">1</td><td class="code">class IPService(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="121">121</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="122">122</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;IpService&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="123">123</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="124">124</a></td><td class="hits"></td><td class="code">        &#34;ip&#34;: &#34;Ipblock&#34;,</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="126">126</a></td><td class="hits">1</td><td class="code">    contactlist: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="127">127</a></td><td class="hits">1</td><td class="code">    contactlist_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="128">128</a></td><td class="hits">1</td><td class="code">    ip: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="129">129</a></td><td class="hits">1</td><td class="code">    ip_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="130">130</a></td><td class="hits">1</td><td class="code">    monitored: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="131">131</a></td><td class="hits">1</td><td class="code">    monitorstatus: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="132">132</a></td><td class="hits">1</td><td class="code">    monitorstatus_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="133">133</a></td><td class="hits">1</td><td class="code">    service: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="134">134</a></td><td class="hits">1</td><td class="code">    service_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="135">135</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="136">136</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="137">137</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="138">138</a></td><td class="hits">1</td><td class="code">class SubnetZone(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="140">140</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;SubnetZone&#34;</td></tr><tr class="noCover"><td class="line"><a name="141">141</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="142">142</a></td><td class="hits">1</td><td class="code">    subnet: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="143">143</a></td><td class="hits">1</td><td class="code">    subnet_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="144">144</a></td><td class="hits">1</td><td class="code">    zone: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="145">145</a></td><td class="hits">1</td><td class="code">    zone_xlink: int &#61; None</td></tr>