<tr class="noCover"><td class="line"><a name="1">1</a></td><td class="hits"></td><td class="code"># type: ignore</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">from dataclasses import dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">from typing import List</td></tr><tr class="noCover"><td class="line"><a name="5">5</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from netdot.exceptions import HTTPError</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from netdot.dataclasses.base import NetdotAPIDataclass</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">class Site(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;cable_plant&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="16">16</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Site&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="18">18</a></td><td class="hits">1</td><td class="code">    aliases: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">    availability: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">    availability_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="21">21</a></td><td class="hits">1</td><td class="code">    contactlist: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="22">22</a></td><td class="hits">1</td><td class="code">    contactlist_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="23">23</a></td><td class="hits">1</td><td class="code">    gsf: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">    number: str &#61; None  # maps to GISSite &#96;building_number&#96; property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="25">25</a></td><td class="hits">1</td><td class="code">    street1: str &#61; None  # First line of &#39;civic address&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="26">26</a></td><td class="hits">1</td><td class="code">    street2: str &#61; None  # Optional second line of &#39;civic address&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">    state: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="28">28</a></td><td class="hits">1</td><td class="code">    city: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="29">29</a></td><td class="hits">1</td><td class="code">    country: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">    zip: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">    pobox: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">    def load_rooms(self) -&gt; List[&#39;Room&#39;]:</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Load all rooms for this site.</td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">        </td></tr><tr class="noCover"><td class="line"><a name="37">37</a></td><td class="hits"></td><td class="code">        &gt; NOTE: This will make N&#43;1 HTTP Requests (where N is the number of **floors** in this site).</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">        rooms &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">        for floor in self.load_floors():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">            rooms.extend(floor.load_rooms())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">        return rooms</td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="44">44</a></td><td class="hits">1</td><td class="code">    def load_closets(self) -&gt; List[&#39;Closet&#39;]:</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Load all closets for this site.</td></tr><tr class="noCover"><td class="line"><a name="46">46</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="47">47</a></td><td class="hits"></td><td class="code">        &gt; NOTE: This will make approximately N&#43;1 HTTP Requests (where N is the number of **rooms** in this site).</td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">        closets &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">        for room in self.load_rooms():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">            try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">                closets.extend(room.load_closets())</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="53">53</a></td><td class="hits">0</td><td class="code">            except HTTPError as e:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="54">54</a></td><td class="hits">0</td><td class="code">                if hasattr(e.response, &#39;status_code&#39;) and e.response.status_code &#61;&#61; 404:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="55">55</a></td><td class="hits">0</td><td class="code">                    logger.info(f&#34;Room {room.name} does not have any closets.&#34;)</td></tr><tr class="noCover"><td class="line"><a name="56">56</a></td><td class="hits"></td><td class="code">                else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="57">57</a></td><td class="hits">0</td><td class="code">                    raise e</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">        return closets</td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="60">60</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="61">61</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="62">62</a></td><td class="hits">1</td><td class="code">class SiteSubnet(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="63">63</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="64">64</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;SiteSubnet&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="65">65</a></td><td class="hits">1</td><td class="code">    _associative_table &#61; True</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="66">66</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">        &#39;subnet&#39;: &#39;IPBlock&#39;,</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">    site: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">    site_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">    subnet: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">    subnet_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="74">74</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="77">77</a></td><td class="hits">1</td><td class="code">class Floor(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="78">78</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="79">79</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Floor&#34;</td></tr><tr class="noCover"><td class="line"><a name="80">80</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="81">81</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="82">82</a></td><td class="hits">1</td><td class="code">    level: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="83">83</a></td><td class="hits">1</td><td class="code">    site: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">    site_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="87">87</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="88">88</a></td><td class="hits">1</td><td class="code">class Room(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="89">89</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Room&#34;</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="92">92</a></td><td class="hits">1</td><td class="code">    floor: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">    floor_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="94">94</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="96">96</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="97">97</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="98">98</a></td><td class="hits">1</td><td class="code">class Closet(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="99">99</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="100">100</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;Closet&#34;</td></tr><tr class="noCover"><td class="line"><a name="101">101</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="102">102</a></td><td class="hits">1</td><td class="code">    access_key_type: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">    asbestos_tiles: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="104">104</a></td><td class="hits">1</td><td class="code">    catv_taps: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="105">105</a></td><td class="hits">1</td><td class="code">    converted_patch_panels: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="106">106</a></td><td class="hits">1</td><td class="code">    dimensions: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="107">107</a></td><td class="hits">1</td><td class="code">    ground_buss: bool &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="108">108</a></td><td class="hits">1</td><td class="code">    hvac_type: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="109">109</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="110">110</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="111">111</a></td><td class="hits">1</td><td class="code">    room: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="112">112</a></td><td class="hits">1</td><td class="code">    room_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="113">113</a></td><td class="hits">1</td><td class="code">    ot_blocks: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="114">114</a></td><td class="hits">1</td><td class="code">    outlets: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="115">115</a></td><td class="hits">1</td><td class="code">    pair_count: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="116">116</a></td><td class="hits">1</td><td class="code">    patch_panels: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="117">117</a></td><td class="hits">1</td><td class="code">    rack_type: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="118">118</a></td><td class="hits">1</td><td class="code">    racks: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">    ru_avail: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="120">120</a></td><td class="hits">1</td><td class="code">    shared_with: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="121">121</a></td><td class="hits">1</td><td class="code">    ss_blocks: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="122">122</a></td><td class="hits">1</td><td class="code">    work_needed: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="123">123</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="124">124</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="125">125</a></td><td class="hits">1</td><td class="code">&#64;dataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="126">126</a></td><td class="hits">1</td><td class="code">class SiteLink(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="127">127</a></td><td class="hits">1</td><td class="code">    NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="128">128</a></td><td class="hits">1</td><td class="code">    NETDOT_TABLE_NAME &#61; &#34;SiteLink&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="129">129</a></td><td class="hits">1</td><td class="code">    _xlink_class_map &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="130">130</a></td><td class="hits"></td><td class="code">        &#34;farend&#34;: &#34;Site&#34;,</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code">        &#34;nearend&#34;: &#34;Site&#34;,</td></tr><tr class="noCover"><td class="line"><a name="132">132</a></td><td class="hits"></td><td class="code">    }</td></tr><tr class="noCover"><td class="line"><a name="133">133</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="134">134</a></td><td class="hits">1</td><td class="code">    entity: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="135">135</a></td><td class="hits">1</td><td class="code">    entity_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="136">136</a></td><td class="hits">1</td><td class="code">    farend: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="137">137</a></td><td class="hits">1</td><td class="code">    farend_xlink: int &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="138">138</a></td><td class="hits">1</td><td class="code">    info: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">    name: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="140">140</a></td><td class="hits">1</td><td class="code">    nearend: str &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="141">141</a></td><td class="hits">1</td><td class="code">    nearend_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="142">142</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="143">143</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="144">144</a></td><td class="hits"></td><td class="code"># TODO Netdot REST API seems to not return blob data</td></tr><tr class="noCover"><td class="line"><a name="145">145</a></td><td class="hits"></td><td class="code"># &#64;dataclass</td></tr><tr class="noCover"><td class="line"><a name="146">146</a></td><td class="hits"></td><td class="code"># class SitePicture(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="147">147</a></td><td class="hits"></td><td class="code">#     NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="noCover"><td class="line"><a name="148">148</a></td><td class="hits"></td><td class="code">#     NETDOT_TABLE_NAME &#61; &#34;SitePicture&#34;</td></tr><tr class="noCover"><td class="line"><a name="149">149</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="150">150</a></td><td class="hits"></td><td class="code">#     bindata: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="151">151</a></td><td class="hits"></td><td class="code">#     filename: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="152">152</a></td><td class="hits"></td><td class="code">#     filesize: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="153">153</a></td><td class="hits"></td><td class="code">#     filetype: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="154">154</a></td><td class="hits"></td><td class="code">#     info: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="155">155</a></td><td class="hits"></td><td class="code">#     site: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="156">156</a></td><td class="hits"></td><td class="code">#     site_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="157">157</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="158">158</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="159">159</a></td><td class="hits"></td><td class="code"># TODO Netdot REST API seems to not return blob data</td></tr><tr class="noCover"><td class="line"><a name="160">160</a></td><td class="hits"></td><td class="code"># &#64;dataclass</td></tr><tr class="noCover"><td class="line"><a name="161">161</a></td><td class="hits"></td><td class="code"># class FloorPicture(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="162">162</a></td><td class="hits"></td><td class="code">#     NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="noCover"><td class="line"><a name="163">163</a></td><td class="hits"></td><td class="code">#     NETDOT_TABLE_NAME &#61; &#34;FloorPicture&#34;</td></tr><tr class="noCover"><td class="line"><a name="164">164</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="165">165</a></td><td class="hits"></td><td class="code">#     bindata: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="166">166</a></td><td class="hits"></td><td class="code">#     filename: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="167">167</a></td><td class="hits"></td><td class="code">#     filesize: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="168">168</a></td><td class="hits"></td><td class="code">#     filetype: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="169">169</a></td><td class="hits"></td><td class="code">#     floor: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="170">170</a></td><td class="hits"></td><td class="code">#     floor_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="171">171</a></td><td class="hits"></td><td class="code">#     info: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="172">172</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="173">173</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="174">174</a></td><td class="hits"></td><td class="code"># TODO Netdot REST API seems to not return blob data</td></tr><tr class="noCover"><td class="line"><a name="175">175</a></td><td class="hits"></td><td class="code"># &#64;dataclass</td></tr><tr class="noCover"><td class="line"><a name="176">176</a></td><td class="hits"></td><td class="code"># class ClosetPicture(NetdotAPIDataclass, CSVDataclass):</td></tr><tr class="noCover"><td class="line"><a name="177">177</a></td><td class="hits"></td><td class="code">#     NETDOT_MENU_URL_PATH &#61; &#34;management&#34;</td></tr><tr class="noCover"><td class="line"><a name="178">178</a></td><td class="hits"></td><td class="code">#     NETDOT_TABLE_NAME &#61; &#34;ClosetPicture&#34;</td></tr><tr class="noCover"><td class="line"><a name="179">179</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="180">180</a></td><td class="hits"></td><td class="code">#     bindata: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="181">181</a></td><td class="hits"></td><td class="code">#     closet: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="182">182</a></td><td class="hits"></td><td class="code">#     closet_xlink: int &#61; None</td></tr><tr class="noCover"><td class="line"><a name="183">183</a></td><td class="hits"></td><td class="code">#     filename: str &#61; None</td></tr><tr class="noCover"><td class="line"><a name="184">184</a></td><td class="hits"></td><td class="code">#     filesize: str &#61; None</td></tr>