<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import re</td></tr><tr class="noCover"><td class="line"><a name="2">2</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">MAC_ADDRESS_BYTE_COUNT &#61; 12</td></tr><tr class="noCover"><td class="line"><a name="4">4</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="5">5</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">class MACAddress:</td></tr><tr class="noCover"><td class="line"><a name="7">7</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Represent a MAC Address, consistently.&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="8">8</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="9">9</a></td><td class="hits">1</td><td class="code">    def __init__(self, raw):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">        self._address &#61; self._strip_tokens(raw)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">        self._validate(self._address)</td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">    def __str__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">        return self.format()</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="16">16</a></td><td class="hits">1</td><td class="code">    def __repr__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">        return f&#34;MACAddress(&#39;{self._address}&#39;)&#34;</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">    def __eq__(self, other):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">        if not isinstance(other, MACAddress):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="21">21</a></td><td class="hits">0</td><td class="code">            return False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="22">22</a></td><td class="hits">1</td><td class="code">        return self._address.lower() &#61;&#61; other._address.lower()</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">    def __hash__(self):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="25">25</a></td><td class="hits">0</td><td class="code">        return hash(self._address)</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">    def format(self, *, delimiter&#61;&#39;&#39;, lowercase&#61;True) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a representation of this MACAddress, formatted according to arguments.</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="31">31</a></td><td class="hits"></td><td class="code">            delimiter (str, optional): The delimiter to be used between each byte-pair in the MAC Address.</td></tr><tr class="noCover"><td class="line"><a name="32">32</a></td><td class="hits"></td><td class="code">                E.g. &#39;-&#39; &#61;&gt; aa-bb-cc-dd-ee-ff. Defaults to no delimiter.</td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code">            lowercase (bool, optional): Ensure all alpha characters are lowercase.</td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code">                Pass &#96;False&#96; to ensure alpha characters are uppercase instead.</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="37">37</a></td><td class="hits"></td><td class="code">            str: The MACAddress, as a pretty string.</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">        if lowercase:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">            mac_address &#61; self._address.lower()</td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="42">42</a></td><td class="hits">0</td><td class="code">            mac_address &#61; self._address.upper()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="43">43</a></td><td class="hits">1</td><td class="code">        mac_address &#61; MACAddress._reassemble_mac(mac_address, delimiter)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="44">44</a></td><td class="hits">1</td><td class="code">        return mac_address</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    def _strip_tokens(raw_mac):</td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">        # Remove any whitespaces &amp; delimiters</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">        return re.sub(r&#39;[\s.:-]&#39;, &#39;&#39;, raw_mac)</td></tr><tr class="noCover"><td class="line"><a name="50">50</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">    def _reassemble_mac(mac_bytes, delimiter):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="53">53</a></td><td class="hits">1</td><td class="code">        two_char_chunks &#61; [str(mac_bytes[i : i &#43; 2]) for i in range(0, 12, 2)]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="54">54</a></td><td class="hits">1</td><td class="code">        return delimiter.join(two_char_chunks)</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">    def _validate(mac_bytes):</td></tr><tr class="noCover"><td class="line"><a name="58">58</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Validate a MAC Address.</td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="60">60</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code">            mac_bytes (str): The MAC Address, without ANY extra delimiters/characters.</td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="63">63</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">            ValueError: If not a valid MAC Address.</td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="66">66</a></td><td class="hits">1</td><td class="code">        if not mac_bytes.isalnum():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="67">67</a></td><td class="hits">1</td><td class="code">            raise ValueError(</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">                f&#39;Unable to parse MAC Address, invalid characters: {mac_bytes}&#39;</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">        if len(mac_bytes) !&#61; MAC_ADDRESS_BYTE_COUNT:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="71">71</a></td><td class="hits">0</td><td class="code">            raise ValueError(</td></tr><tr class="noCover"><td class="line"><a name="72">72</a></td><td class="hits"></td><td class="code">                f&#39;Unable to parse MAC Address, invalid length (expect {MAC_ADDRESS_BYTE_COUNT}, was {len(mac_bytes)}): {mac_bytes}&#39;</td></tr><tr class="noCover"><td class="line"><a name="73">73</a></td><td class="hits"></td><td class="code">            )</td></tr>