<tr class="noCover"><td class="line"><a name="1">1</a></td><td class="hits"></td><td class="code">&#34;&#34;&#34;Functions for parsing strings.</td></tr><tr class="noCover"><td class="line"><a name="2">2</a></td><td class="hits"></td><td class="code">&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">import xml.etree.ElementTree as ET</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">from datetime import datetime</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from typing import List</td></tr><tr class="noCover"><td class="line"><a name="7">7</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from netdot import validate</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="9">9</a></td><td class="hits">1</td><td class="code">from netdot.mac_address import MACAddress</td></tr><tr class="noCover"><td class="line"><a name="10">10</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">NETDOT_TIME_FORMAT_STRINGS &#61; [</td></tr><tr class="noCover"><td class="line"><a name="12">12</a></td><td class="hits"></td><td class="code">    &#39;%Y-%m-%d %H:%M:%S&#39;,</td></tr><tr class="noCover"><td class="line"><a name="13">13</a></td><td class="hits"></td><td class="code">    &#39;%Y-%m-%d&#39;,</td></tr><tr class="noCover"><td class="line"><a name="14">14</a></td><td class="hits"></td><td class="code">]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">NETDOT_START_OF_TIME_STRINGS &#61; [</td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code">    &#39;0&#39;,</td></tr><tr class="noCover"><td class="line"><a name="17">17</a></td><td class="hits"></td><td class="code">    &#39;0000-00-00&#39;,</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code">    &#39;0000-00-00 00:00:00&#39;,</td></tr><tr class="noCover"><td class="line"><a name="19">19</a></td><td class="hits"></td><td class="code">]</td></tr><tr class="noCover"><td class="line"><a name="20">20</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="21">21</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">def RESTful_XML(xml):</td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;This is a VERY simple parser specifically built to parse the NetDot-XML Objects.</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="27">27</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">      Multi-level dictionary.</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">    validate.RESTful_XML(xml)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">    data &#61; {}</td></tr><tr class="noCover"><td class="line"><a name="32">32</a></td><td class="hits"></td><td class="code">    # TODO Sanitize the xml before trying to parse! E.g. b&#39;C3KX\\x04\\xc3\\xb6\\xc2\\xb6L1G&#39; does not parse correctly!</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">    xml_root &#61; ET.fromstring(xml)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">    if xml_root.attrib:</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code">        # root has attributes, so we&#39;re likely</td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">        # receiving a single object</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">        data &#61; xml_root.attrib</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">    else:</td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code">        # No root attributes means that we&#39;re</td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code">        # receiving a list of objects</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="41">41</a></td><td class="hits">1</td><td class="code">        for child in xml_root:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">            if child.tag in data:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="43">43</a></td><td class="hits">1</td><td class="code">                data[child.tag][child.attrib[&#34;id&#34;]] &#61; child.attrib</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">            else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">                data[child.tag] &#61; {}</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="46">46</a></td><td class="hits">1</td><td class="code">                data[child.tag][child.attrib[&#34;id&#34;]] &#61; child.attrib</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    return data</td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="49">49</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">def split_combined_entities_str(combined_entities: str) -&gt; List[str]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    entities &#61; combined_entities.split(&#39;, &#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">    entities &#61; list(map(str.strip, entities))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="53">53</a></td><td class="hits">1</td><td class="code">    return entities</td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">def MACAddress_from_asset(asset: str) -&gt; MACAddress:</td></tr><tr class="noCover"><td class="line"><a name="57">57</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Parse a MACAddress out of Netdot &#39;asset string&#39;.</td></tr><tr class="noCover"><td class="line"><a name="58">58</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="59">59</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="60">60</a></td><td class="hits"></td><td class="code">        asset (str): The asset string, of form &#34;, <s>, &#34;</s></td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code">    Example:</td></tr><tr class="noCover"><td class="line"><a name="63">63</a></td><td class="hits"></td><td class="code">        &gt;&gt;&gt; MACAddress_from_asset(&#34;Cisco Systems (Airspace) AIR-AP1815W-B-K9, FJC25101LUN, AABBCCDDEEFF&#34;)</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">        MACAddress(&#39;AABBCCDDEEFF&#39;)</td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">        MACAddress: The Base MAC Address from the asset string.</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="69">69</a></td><td class="hits">1</td><td class="code">    try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">        raw_mac_address &#61; split_combined_entities_str(asset)[2]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">        return MACAddress(raw_mac_address)</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="72">72</a></td><td class="hits">0</td><td class="code">    except IndexError:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="73">73</a></td><td class="hits">0</td><td class="code">        raise ValueError(f&#39;Unable to parse MACAddress from asset string: {asset}&#39;)</td></tr><tr class="noCover"><td class="line"><a name="74">74</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">def DateTime(time: str) -&gt; datetime:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="77">77</a></td><td class="hits">1</td><td class="code">    if time in NETDOT_START_OF_TIME_STRINGS:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="78">78</a></td><td class="hits">1</td><td class="code">        return datetime.fromtimestamp(0)</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">    for time_fmt in NETDOT_TIME_FORMAT_STRINGS:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="81">81</a></td><td class="hits">1</td><td class="code">        try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="82">82</a></td><td class="hits">1</td><td class="code">            return datetime.strptime(time, time_fmt)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="83">83</a></td><td class="hits">1</td><td class="code">        except ValueError:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">            continue</td></tr><tr class="noCover"><td class="line"><a name="85">85</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="86">86</a></td><td class="hits">1</td><td class="code">    EXPECTED_FORMATTING &#61; f&#39;datetime should be formatted as one of: {NETDOT_TIME_FORMAT_STRINGS &#43; NETDOT_START_OF_TIME_STRINGS}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="87">87</a></td><td class="hits">1</td><td class="code">    raise ValueError(f&#39;Unable to parse DateTime from: {time} -- {EXPECTED_FORMATTING}&#39;)</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="90">90</a></td><td class="hits">1</td><td class="code">def Boolean(data: str) -&gt; bool:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="91">91</a></td><td class="hits">1</td><td class="code">    if data.strip() &#61;&#61; &#39;0&#39;:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="92">92</a></td><td class="hits">1</td><td class="code">        return False</td></tr><tr class="noCover"><td class="line"><a name="93">93</a></td><td class="hits"></td><td class="code">    else:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="94">94</a></td><td class="hits">1</td><td class="code">        return bool(data)</td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="96">96</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="97">97</a></td><td class="hits">1</td><td class="code">def ID_from_xlink(xlink_str):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="98">98</a></td><td class="hits">1</td><td class="code">    EXPECTED_FORMATTING &#61; &#34;xlink is formatted: /. E.g. &#39;Site/41&#39;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="99">99</a></td><td class="hits">1</td><td class="code">    try:</td></tr><tr class="noCover"><td class="line"><a name="100">100</a></td><td class="hits"></td><td class="code">        # xlink_str is formatted: /</td></tr><tr class="noCover"><td class="line"><a name="101">101</a></td><td class="hits"></td><td class="code">        # E.g. &#39;Site/41&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="102">102</a></td><td class="hits">1</td><td class="code">        int_str &#61; xlink_str.split(&#39;/&#39;)[1]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">        return int(int_str)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="104">104</a></td><td class="hits">1</td><td class="code">    except IndexError:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="105">105</a></td><td class="hits">0</td><td class="code">        raise ValueError(</td></tr><tr class="noCover"><td class="line"><a name="106">106</a></td><td class="hits"></td><td class="code">            f&#39;Unable to parse id out of xlink value: {xlink_str} -- {EXPECTED_FORMATTING}&#39;</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="108">108</a></td><td class="hits"></td><td class="code"></td></tr>