<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">from contextlib import AbstractContextManager</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">import threading</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">import inspect</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">import textwrap</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">from concurrent.futures import ThreadPoolExecutor</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="7">7</a></td><td class="hits">1</td><td class="code">from getpass import getpass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from typing import Callable, ClassVar, List, Union</td></tr><tr class="noCover"><td class="line"><a name="9">9</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="10">10</a></td><td class="hits">1</td><td class="code">import uologging</td></tr><tr class="noCover"><td class="line"><a name="11">11</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="12">12</a></td><td class="hits">1</td><td class="code">import netdot.dataclasses</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">from netdot.actions import ActionTypes, NetdotAction</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">from netdot.dataclasses.base import NetdotAPIDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="15">15</a></td><td class="hits">1</td><td class="code">from netdot.unitofwork import UnitOfWork</td></tr><tr class="noCover"><td class="line"><a name="16">16</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="17">17</a></td><td class="hits">1</td><td class="code">from . import client, exceptions, utils, defaults</td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="20">20</a></td><td class="hits">1</td><td class="code">trace &#61; uologging.trace(logger)</td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="22">22</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="23">23</a></td><td class="hits">1</td><td class="code">class Repository(AbstractContextManager):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">    _initialized: ClassVar[bool] &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="25">25</a></td><td class="hits">1</td><td class="code">    _existing_connection: ClassVar &#61; None</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">    def __init__(</td></tr><tr class="noCover"><td class="line"><a name="28">28</a></td><td class="hits"></td><td class="code">        self,</td></tr><tr class="noCover"><td class="line"><a name="29">29</a></td><td class="hits"></td><td class="code">        netdot_url,</td></tr><tr class="noCover"><td class="line"><a name="30">30</a></td><td class="hits"></td><td class="code">        user,</td></tr><tr class="noCover"><td class="line"><a name="31">31</a></td><td class="hits"></td><td class="code">        password,</td></tr><tr class="noCover"><td class="line"><a name="32">32</a></td><td class="hits"></td><td class="code">        dry_run&#61;False,</td></tr><tr class="noCover"><td class="line"><a name="33">33</a></td><td class="hits"></td><td class="code">        print_changes&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="34">34</a></td><td class="hits"></td><td class="code">        auto_update&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code">        threads&#61;defaults.THREADS,</td></tr><tr class="noCover"><td class="line"><a name="36">36</a></td><td class="hits"></td><td class="code">        **kwargs,</td></tr><tr class="noCover"><td class="line"><a name="37">37</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Work with Netdot API using Python objects.</td></tr><tr class="noCover"><td class="line"><a name="39">39</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="40">40</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code">            netdot_url (str): The URL of the Netdot server, e.g. &#34;https://nsdb.uoregon.edu&#34;</td></tr><tr class="noCover"><td class="line"><a name="42">42</a></td><td class="hits"></td><td class="code">            user (str): The Netdot username to use for authentication.</td></tr><tr class="noCover"><td class="line"><a name="43">43</a></td><td class="hits"></td><td class="code">            password (str): The Netdot password to use for authentication.</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">            dry_run (bool, optional): Only **&#39;propose changes&#39;** until user calls &#96;save_changes&#96;. Defaults to False.</td></tr><tr class="noCover"><td class="line"><a name="45">45</a></td><td class="hits"></td><td class="code">            print_changes (bool, optional): (When dry_run&#61;True) Print any &#39;proposed changes&#39; as they occur. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="46">46</a></td><td class="hits"></td><td class="code">            auto_update (bool, optional): (When dry_run&#61;True) Automatically &#39;propose changes&#39; on Netdot objects. Defaults to True. (if an attribute is updated on any Netdot object, that update will be immediately reflected in this repositories &#39;proposed changes&#39;) </td></tr><tr class="noCover"><td class="line"><a name="47">47</a></td><td class="hits"></td><td class="code">            threads (int, optional): How many threads can be used when making GET requests? Defaults to &#96;defaults.THREADS&#96;.</td></tr><tr class="noCover"><td class="line"><a name="48">48</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="49">49</a></td><td class="hits">1</td><td class="code">        Repository.prepare_class()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">        self.netdot_url &#61; netdot_url</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">        self.user &#61; user</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">        self._connection &#61; client.Client(</td></tr><tr class="noCover"><td class="line"><a name="53">53</a></td><td class="hits"></td><td class="code">            netdot_url, user, utils.HiddenString(password), **kwargs</td></tr><tr class="noCover"><td class="line"><a name="54">54</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="55">55</a></td><td class="hits">1</td><td class="code">        self._thread_count &#61; threads</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">        self._dry_run &#61; dry_run</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">        self._auto_update_on_dry_run &#61; auto_update</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">        self._print_dry_run_changes &#61; print_changes</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="59">59</a></td><td class="hits">1</td><td class="code">        self.proposed_changes &#61; UnitOfWork()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="60">60</a></td><td class="hits">1</td><td class="code">        self._lock &#61; threading.Lock()</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="62">62</a></td><td class="hits"></td><td class="code">    def disconnect(self):  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="63">63</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Disconnect from Netdot.</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code">        self.connection.logout()</td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">    def __exit__(self):  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">        self.disconnect()</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">    def _create_thread_pool(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">        return ThreadPoolExecutor(self._thread_count)</td></tr><tr class="noCover"><td class="line"><a name="72">72</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="73">73</a></td><td class="hits">1</td><td class="code">    def __str__(self):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="74">74</a></td><td class="hits">0</td><td class="code">        return f&#34;Repository(&#39;{self.connection.netdot_url}&#39;, &#39;{self.user}&#39;)&#34;</td></tr><tr class="noCover"><td class="line"><a name="75">75</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="76">76</a></td><td class="hits">1</td><td class="code">    def clear_proposed_changes(self):</td></tr><tr class="noCover"><td class="line"><a name="77">77</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Reset the proposed changes (dry run) for this Netdot Repository.&#34;&#34;&#34;</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="78">78</a></td><td class="hits">0</td><td class="code">        self.proposed_changes &#61; UnitOfWork()</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="80">80</a></td><td class="hits">1</td><td class="code">    def disable_propose_changes(self):</td></tr><tr class="noCover"><td class="line"><a name="81">81</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Disable the &#39;propose changes&#39; or DRY RUN feature on this Netdot Repository.</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code">        After this, all changes will be applied immediately to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="84">84</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="85">85</a></td><td class="hits">0</td><td class="code">        self._dry_run &#61; False</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="87">87</a></td><td class="hits">1</td><td class="code">    def enable_propose_changes(self, print_changes&#61;True, auto_update&#61;True):</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Enable the &#39;propose changes&#39; or DRY RUN feature on this Netdot Repository.</td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="90">90</a></td><td class="hits"></td><td class="code">        After this, all changes will be queued, only to be applied when &#96;save_changes&#96; is called.</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="92">92</a></td><td class="hits">1</td><td class="code">        self._dry_run &#61; True</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">        self._print_dry_run_changes &#61; print_changes</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="94">94</a></td><td class="hits">1</td><td class="code">        self._auto_update_on_dry_run &#61; auto_update</td></tr><tr class="noCover"><td class="line"><a name="95">95</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="96">96</a></td><td class="hits">1</td><td class="code">    def reset_trace_downloads(self, threshold_bytes: defaults.TRACE_THRESHOLD):</td></tr><tr class="noCover"><td class="line"><a name="97">97</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Reset the trace downloads feature.</td></tr><tr class="noCover"><td class="line"><a name="98">98</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="99">99</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="100">100</a></td><td class="hits"></td><td class="code">            threshold_bytes (defaults.TRACE_THRESHOLD): How many bytes to downloaded before logging an INFO message.</td></tr><tr class="noCover"><td class="line"><a name="101">101</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="102">102</a></td><td class="hits">1</td><td class="code">        self.connection.reset_trace_downloads(threshold_bytes)</td></tr><tr class="noCover"><td class="line"><a name="103">103</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="104">104</a></td><td class="hits">1</td><td class="code">    enable_trace_downloads &#61; reset_trace_downloads</td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="106">106</a></td><td class="hits">1</td><td class="code">    def disable_trace_downloads(self):</td></tr><tr class="noCover"><td class="line"><a name="107">107</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Disable the trace downloads feature.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="108">108</a></td><td class="hits">1</td><td class="code">        self.connection.disable_trace_downloads()</td></tr><tr class="noCover"><td class="line"><a name="109">109</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="110">110</a></td><td class="hits">1</td><td class="code">    def show_all_changes(self, one_line&#61;defaults.TERSE):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="111">111</a></td><td class="hits">0</td><td class="code">        print(self.proposed_changes.status_report(one_line))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="112">112</a></td><td class="hits">1</td><td class="code">    show_all_changes.__doc__ &#61; UnitOfWork.status_report.__doc__</td></tr><tr class="noCover"><td class="line"><a name="113">113</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="114">114</a></td><td class="hits"></td><td class="code">    def show_changes(self, terse&#61;defaults.TERSE):  # pragma: no cover  (wrapper method)</td></tr><tr class="noCover"><td class="line"><a name="115">115</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Show a &#39;dry run&#39; of all changes to be made (but don&#39;t actually make the changes).</td></tr><tr class="noCover"><td class="line"><a name="116">116</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="117">117</a></td><td class="hits"></td><td class="code">        &gt; See :func:&#96;netdot.UnitOfWork.show_dry_run&#96; for more details.</td></tr><tr class="noCover"><td class="line"><a name="118">118</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="119">119</a></td><td class="hits"></td><td class="code">        print(self.proposed_changes.dry_run(terse))</td></tr><tr class="noCover"><td class="line"><a name="120">120</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="121">121</a></td><td class="hits"></td><td class="code">    def show_changes_as_tables(</td></tr><tr class="noCover"><td class="line"><a name="122">122</a></td><td class="hits"></td><td class="code">        self, terse&#61;defaults.TERSE, select_cols&#61;None</td></tr><tr class="noCover"><td class="line"><a name="123">123</a></td><td class="hits"></td><td class="code">    ):  # pragma: no cover  (wrapper method)</td></tr><tr class="noCover"><td class="line"><a name="124">124</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Print ASCII table(s) representing all of the changes to be made (grouped into tables based on Netdot Data Types).</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="126">126</a></td><td class="hits"></td><td class="code">        &gt; See :func:&#96;netdot.UnitOfWork.show_changes_as_tables&#96; for more details.</td></tr><tr class="noCover"><td class="line"><a name="127">127</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="128">128</a></td><td class="hits"></td><td class="code">        print(self.proposed_changes.changes_as_tables(terse, select_cols))</td></tr><tr class="noCover"><td class="line"><a name="129">129</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="130">130</a></td><td class="hits">1</td><td class="code">    def save_changes(self, confirm&#61;True):</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Save all proposed changes to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="132">132</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="133">133</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="134">134</a></td><td class="hits"></td><td class="code">            confirm (bool, optional): If any delete actions are planned, confirm them with the user first. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="135">135</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="136">136</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="137">137</a></td><td class="hits"></td><td class="code">            RuntimeError: If this Repository&#39;s multithreading lock cannot be acquired.</td></tr><tr class="noCover"><td class="line"><a name="138">138</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="139">139</a></td><td class="hits">1</td><td class="code">        proposed_deletions &#61; self.proposed_changes.with_action_types(</td></tr><tr class="noCover"><td class="line"><a name="140">140</a></td><td class="hits"></td><td class="code">            [ActionTypes.DELETE]</td></tr><tr class="noCover"><td class="line"><a name="141">141</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="142">142</a></td><td class="hits"></td><td class="code">        if (</td></tr><tr class="noCover"><td class="line"><a name="143">143</a></td><td class="hits"></td><td class="code">            proposed_deletions and confirm</td></tr><tr class="noCover"><td class="line"><a name="144">144</a></td><td class="hits"></td><td class="code">        ):  # pragma: no cover (manually tested on Oct 30, 2023)</td></tr><tr class="noCover"><td class="line"><a name="145">145</a></td><td class="hits"></td><td class="code">            print(proposed_deletions.dry_run())</td></tr><tr class="noCover"><td class="line"><a name="146">146</a></td><td class="hits"></td><td class="code">            if not utils.user_confirmation(&#39;Deleting is irreversible. Proceed?&#39;):</td></tr><tr class="noCover"><td class="line"><a name="147">147</a></td><td class="hits"></td><td class="code">                print(</td></tr><tr class="noCover"><td class="line"><a name="148">148</a></td><td class="hits"></td><td class="code">                    &#39;Nothing done. Review changes using &#96;show_changes&#96; Type &#34;yes&#34; to proceed next time (or use confirm&#61;False)&#39;</td></tr><tr class="noCover"><td class="line"><a name="149">149</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="150">150</a></td><td class="hits"></td><td class="code">                return</td></tr><tr class="noCover"><td class="line"><a name="151">151</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="152">152</a></td><td class="hits">1</td><td class="code">        if self._lock.acquire(blocking&#61;False):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="153">153</a></td><td class="hits">1</td><td class="code">            try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="154">154</a></td><td class="hits">1</td><td class="code">                prior_dry_run_state &#61; self._dry_run</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="155">155</a></td><td class="hits">1</td><td class="code">                self._dry_run &#61; False</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="156">156</a></td><td class="hits">1</td><td class="code">                self.proposed_changes.save_changes(self)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="157">157</a></td><td class="hits">1</td><td class="code">                print(&#39;Changes saved!&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="158">158</a></td><td class="hits">1</td><td class="code">            except Exception:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="159">159</a></td><td class="hits">1</td><td class="code">                if defaults.SAVE_AS_FILE_ON_ERROR:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="160">160</a></td><td class="hits">1</td><td class="code">                    try:</td></tr><tr class="noCover"><td class="line"><a name="161">161</a></td><td class="hits"></td><td class="code">                        # Save proposed changes to file for recovery</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="162">162</a></td><td class="hits">1</td><td class="code">                        self.proposed_changes.save_as_pickle(defaults.ERROR_PICKLE_FILENAME)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="163">163</a></td><td class="hits">1</td><td class="code">                        logger.exception(f&#39;Saved proposed changes to file &#34;{defaults.ERROR_PICKLE_FILENAME}&#34; for recovery.&#39;)</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="164">164</a></td><td class="hits">0</td><td class="code">                    except Exception:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="165">165</a></td><td class="hits">0</td><td class="code">                        logger.exception(f&#39;Unable to save changes to file &#34;{defaults.ERROR_PICKLE_FILENAME}&#34;&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="166">166</a></td><td class="hits">1</td><td class="code">                raise exceptions.NetdotError(f&#39;&#39;&#39;Unable to complete changes.</td></tr><tr class="noCover"><td class="line"><a name="167">167</a></td><td class="hits"></td><td class="code">Failed to: {self.proposed_changes.failed_action_msg()}.&#39;&#39;&#39;)</td></tr><tr class="noCover"><td class="line"><a name="168">168</a></td><td class="hits"></td><td class="code">            finally:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="169">169</a></td><td class="hits">1</td><td class="code">                self._dry_run &#61; prior_dry_run_state</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="170">170</a></td><td class="hits">1</td><td class="code">                self._lock.release()</td></tr><tr class="noCover"><td class="line"><a name="171">171</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="172">172</a></td><td class="hits">0</td><td class="code">            raise RuntimeError(</td></tr><tr class="noCover"><td class="line"><a name="173">173</a></td><td class="hits"></td><td class="code">                &#39;Unable to acquire lock for save_changes(). Is another thread using this repository at this moment?&#39;</td></tr><tr class="noCover"><td class="line"><a name="174">174</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="175">175</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="176">176</a></td><td class="hits">1</td><td class="code">    def create_new(self, new_data: NetdotAPIDataclass) -&gt; NetdotAPIDataclass:</td></tr><tr class="noCover"><td class="line"><a name="177">177</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Create some new object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="178">178</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="179">179</a></td><td class="hits"></td><td class="code">        &gt; NOTE: Upon creation, the &#96;id&#96; field of new_data will be populated.</td></tr><tr class="noCover"><td class="line"><a name="180">180</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="181">181</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="182">182</a></td><td class="hits"></td><td class="code">            new_data (netdot.NetdotAPIDataclass): The new data to use for the new Netdot object.</td></tr><tr class="noCover"><td class="line"><a name="183">183</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="184">184</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="185">185</a></td><td class="hits"></td><td class="code">            netdot.NetdotAPIDataclass: The new object (with &#96;id&#96; populated).</td></tr><tr class="noCover"><td class="line"><a name="186">186</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="187">187</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="188">188</a></td><td class="hits"></td><td class="code">            HTTPError: if the object cannot be created for any reason. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="189">189</a></td><td class="hits"></td><td class="code">            As an example, expect a generic HTTP 400 when:</td></tr><tr class="noCover"><td class="line"><a name="190">190</a></td><td class="hits"></td><td class="code">              * an object breaks &#39;uniqueness&#39; rules (Ex. 2 Sites named &#34;Test&#34;),</td></tr><tr class="noCover"><td class="line"><a name="191">191</a></td><td class="hits"></td><td class="code">              * an object is missing required fields (Ex. a Person without a &#96;lastname&#96;),</td></tr><tr class="noCover"><td class="line"><a name="192">192</a></td><td class="hits"></td><td class="code">              * an object is improperly formatted (Ex. a Device with a &#96;date_installed&#96; that is not a datetime),</td></tr><tr class="noCover"><td class="line"><a name="193">193</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="194">194</a></td><td class="hits">1</td><td class="code">        if self._dry_run:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="195">195</a></td><td class="hits">1</td><td class="code">            self.proposed_changes.create(</td></tr><tr class="noCover"><td class="line"><a name="196">196</a></td><td class="hits"></td><td class="code">                new_data, print_changes&#61;self._print_dry_run_changes</td></tr><tr class="noCover"><td class="line"><a name="197">197</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="198">198</a></td><td class="hits">1</td><td class="code">            return new_data.with_repository(self)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="199">199</a></td><td class="hits">1</td><td class="code">        response &#61; self.connection.create_object(</td></tr><tr class="noCover"><td class="line"><a name="200">200</a></td><td class="hits"></td><td class="code">            new_data.NETDOT_TABLE_NAME, new_data.to_DTO()</td></tr><tr class="noCover"><td class="line"><a name="201">201</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="202">202</a></td><td class="hits">1</td><td class="code">        return new_data._intake_DTO(response).with_repository(self)</td></tr><tr class="noCover"><td class="line"><a name="203">203</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="204">204</a></td><td class="hits">1</td><td class="code">    def update(self, new_data: NetdotAPIDataclass) -&gt; NetdotAPIDataclass:</td></tr><tr class="noCover"><td class="line"><a name="205">205</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Update an existing object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="206">206</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="207">207</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="208">208</a></td><td class="hits"></td><td class="code">            id (int): The ID of the object to update.</td></tr><tr class="noCover"><td class="line"><a name="209">209</a></td><td class="hits"></td><td class="code">            new_data (netdot.NetdotAPIDataclass): The new data to use when updating the object.</td></tr><tr class="noCover"><td class="line"><a name="210">210</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="211">211</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="212">212</a></td><td class="hits"></td><td class="code">            netdot.NetdotAPIDataclass: The object provided by Netdot in response to this HTTP POST.</td></tr><tr class="noCover"><td class="line"><a name="213">213</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="214">214</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="215">215</a></td><td class="hits"></td><td class="code">            HTTPError: if the object cannot be updated for some reason. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="216">216</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="217">217</a></td><td class="hits">1</td><td class="code">        if self._dry_run:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="218">218</a></td><td class="hits">1</td><td class="code">            getter_function &#61; getattr(</td></tr><tr class="noCover"><td class="line"><a name="219">219</a></td><td class="hits"></td><td class="code">                self, f&#39;get_{new_data._pep8_method_friendly_name()}&#39;</td></tr><tr class="noCover"><td class="line"><a name="220">220</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="221">221</a></td><td class="hits">1</td><td class="code">            old_data &#61; getter_function(new_data.id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="222">222</a></td><td class="hits">1</td><td class="code">            self.proposed_changes.update(</td></tr><tr class="noCover"><td class="line"><a name="223">223</a></td><td class="hits"></td><td class="code">                old_data, new_data, print_changes&#61;self._print_dry_run_changes</td></tr><tr class="noCover"><td class="line"><a name="224">224</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="225">225</a></td><td class="hits">1</td><td class="code">            return new_data.with_repository(self)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="226">226</a></td><td class="hits">1</td><td class="code">        return self.update_by_id(new_data.id, new_data).with_repository(self)</td></tr><tr class="noCover"><td class="line"><a name="227">227</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="228">228</a></td><td class="hits">1</td><td class="code">    def delete(</td></tr><tr class="noCover"><td class="line"><a name="229">229</a></td><td class="hits"></td><td class="code">        self,</td></tr><tr class="noCover"><td class="line"><a name="230">230</a></td><td class="hits"></td><td class="code">        data: NetdotAPIDataclass,</td></tr><tr class="noCover"><td class="line"><a name="231">231</a></td><td class="hits"></td><td class="code">        confirm&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="232">232</a></td><td class="hits"></td><td class="code">        ignore_404&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="233">233</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="234">234</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Delete an existing object from Netdot.</td></tr><tr class="noCover"><td class="line"><a name="235">235</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="236">236</a></td><td class="hits"></td><td class="code">        &gt; ⚠ WARNING: This is irreversible. Use with caution.</td></tr><tr class="noCover"><td class="line"><a name="237">237</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="238">238</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="239">239</a></td><td class="hits"></td><td class="code">            data (NetdotAPIDataclass): The object to be deleted.</td></tr><tr class="noCover"><td class="line"><a name="240">240</a></td><td class="hits"></td><td class="code">            confirm (bool): Assume interactive and ask user &#39;Proceed? ...&#39; before deleting. Default True.</td></tr><tr class="noCover"><td class="line"><a name="241">241</a></td><td class="hits"></td><td class="code">            ignore_404 (bool): Default True. Ignore HTTP 404 errors. (Why? no need to delete an object if it doesn&#39;t exist!)</td></tr><tr class="noCover"><td class="line"><a name="242">242</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="243">243</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="244">244</a></td><td class="hits"></td><td class="code">            HTTPError: Could occur for various reasons. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="245">245</a></td><td class="hits"></td><td class="code">            NetdotDeleteError: If the object cannot be deleted for some other reason.</td></tr><tr class="noCover"><td class="line"><a name="246">246</a></td><td class="hits"></td><td class="code">            TypeError: If data is not a subclass of NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="247">247</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="248">248</a></td><td class="hits">1</td><td class="code">        if self._dry_run:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="249">249</a></td><td class="hits">1</td><td class="code">            self.proposed_changes.delete(</td></tr><tr class="noCover"><td class="line"><a name="250">250</a></td><td class="hits"></td><td class="code">                data, print_changes&#61;self._print_dry_run_changes</td></tr><tr class="noCover"><td class="line"><a name="251">251</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="252">252</a></td><td class="hits">1</td><td class="code">            return</td></tr><tr class="noCover"><td class="line"><a name="253">253</a></td><td class="hits"></td><td class="code">        if confirm:  # pragma: no cover (manually tested on Oct 30, 2023)</td></tr><tr class="noCover"><td class="line"><a name="254">254</a></td><td class="hits"></td><td class="code">            if not utils.user_confirmation(&#39;Deleting is irreversible. Proceed?&#39;):</td></tr><tr class="noCover"><td class="line"><a name="255">255</a></td><td class="hits"></td><td class="code">                print(</td></tr><tr class="noCover"><td class="line"><a name="256">256</a></td><td class="hits"></td><td class="code">                    &#39;Nothing done. Type &#34;yes&#34; to proceed next time (or use confirm&#61;False)&#39;</td></tr><tr class="noCover"><td class="line"><a name="257">257</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="258">258</a></td><td class="hits"></td><td class="code">                return</td></tr><tr class="noCover"><td class="line"><a name="259">259</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="260">260</a></td><td class="hits">1</td><td class="code">        id &#61; data.id</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="261">261</a></td><td class="hits">1</td><td class="code">        try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="262">262</a></td><td class="hits">1</td><td class="code">            self.connection.delete_object_by_id(data.NETDOT_TABLE_NAME, id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="263">263</a></td><td class="hits">1</td><td class="code">        except exceptions.HTTPError as e:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="264">264</a></td><td class="hits">1</td><td class="code">            if (</td></tr><tr class="noCover"><td class="line"><a name="265">265</a></td><td class="hits"></td><td class="code">                ignore_404</td></tr><tr class="noCover"><td class="line"><a name="266">266</a></td><td class="hits"></td><td class="code">                and hasattr(e.response, &#39;status_code&#39;)</td></tr><tr class="noCover"><td class="line"><a name="267">267</a></td><td class="hits"></td><td class="code">                and e.response.status_code &#61;&#61; 404</td></tr><tr class="noCover"><td class="line"><a name="268">268</a></td><td class="hits"></td><td class="code">            ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="269">269</a></td><td class="hits">1</td><td class="code">                return</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="270">270</a></td><td class="hits">1</td><td class="code">            raise exceptions.NetdotDeleteError(</td></tr><tr class="noCover"><td class="line"><a name="271">271</a></td><td class="hits"></td><td class="code">                f&#39;Unable to delete {data.__class__.__name__} with id {id}&#39;,</td></tr><tr class="noCover"><td class="line"><a name="272">272</a></td><td class="hits"></td><td class="code">                status_code&#61;e.response.status_code,</td></tr><tr class="noCover"><td class="line"><a name="273">273</a></td><td class="hits"></td><td class="code">                response&#61;e.response.content,</td></tr><tr class="noCover"><td class="line"><a name="274">274</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="275">275</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="276">276</a></td><td class="hits">1</td><td class="code">    def update_by_id(self, id: int, new_data: NetdotAPIDataclass) -&gt; NetdotAPIDataclass:</td></tr><tr class="noCover"><td class="line"><a name="277">277</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Update an existing object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="278">278</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="279">279</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="280">280</a></td><td class="hits"></td><td class="code">            id (int): The ID of the object to update.</td></tr><tr class="noCover"><td class="line"><a name="281">281</a></td><td class="hits"></td><td class="code">            new_data (netdot.NetdotAPIDataclass): The new data to use when updating the object.</td></tr><tr class="noCover"><td class="line"><a name="282">282</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="283">283</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="284">284</a></td><td class="hits"></td><td class="code">            netdot.NetdotAPIDataclass: The object provided by Netdot in response to this HTTP POST.</td></tr><tr class="noCover"><td class="line"><a name="285">285</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="286">286</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="287">287</a></td><td class="hits"></td><td class="code">            HTTPError: if the object cannot be updated for some reason. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="288">288</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="289">289</a></td><td class="hits">1</td><td class="code">        obj_url_path &#61; f&#39;/{new_data.NETDOT_TABLE_NAME}/{id}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="290">290</a></td><td class="hits">1</td><td class="code">        response &#61; self.connection.post(obj_url_path, new_data.to_DTO())</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="291">291</a></td><td class="hits">1</td><td class="code">        return new_data._intake_DTO(response)</td></tr><tr class="noCover"><td class="line"><a name="292">292</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="293">293</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="294">294</a></td><td class="hits">1</td><td class="code">    def _attach_methods(cls, methods):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="295">295</a></td><td class="hits">1</td><td class="code">        for method in methods:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="296">296</a></td><td class="hits">1</td><td class="code">            setattr(cls, method.__name__, method)</td></tr><tr class="noCover"><td class="line"><a name="297">297</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="298">298</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="299">299</a></td><td class="hits">1</td><td class="code">    def prepare_class(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="300">300</a></td><td class="hits">1</td><td class="code">        if not cls._initialized:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="301">301</a></td><td class="hits">1</td><td class="code">            netdot.initialize()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="302">302</a></td><td class="hits">1</td><td class="code">            dataclasses &#61; netdot.NetdotAPIDataclass.__subclasses__()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="303">303</a></td><td class="hits">1</td><td class="code">            cls._attach_methods(generate_CRUD_for_all_dataclasses(dataclasses))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="304">304</a></td><td class="hits">1</td><td class="code">            cls._initialized &#61; True</td></tr><tr class="noCover"><td class="line"><a name="305">305</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="306">306</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="noCover"><td class="line"><a name="307">307</a></td><td class="hits"></td><td class="code">    def connect(</td></tr><tr class="noCover"><td class="line"><a name="308">308</a></td><td class="hits"></td><td class="code">        cls, _input&#61;input, _getpass&#61;getpass, propose_changes&#61;True, **kwargs</td></tr><tr class="noCover"><td class="line"><a name="309">309</a></td><td class="hits"></td><td class="code">    ):  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="310">310</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Connect to NetDot for interactive use.</td></tr><tr class="noCover"><td class="line"><a name="311">311</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="312">312</a></td><td class="hits"></td><td class="code">        Example:</td></tr><tr class="noCover"><td class="line"><a name="313">313</a></td><td class="hits"></td><td class="code">        This method is interactive, and requires you to provide your credentials</td></tr><tr class="noCover"><td class="line"><a name="314">314</a></td><td class="hits"></td><td class="code">             &gt;&gt; repo &#61; Repository.connect()</td></tr><tr class="noCover"><td class="line"><a name="315">315</a></td><td class="hits"></td><td class="code">            What is the URL of the NetDot server? [https://nsdb.uoregon.edu]: (&#39;enter&#39; to use default)</td></tr><tr class="noCover"><td class="line"><a name="316">316</a></td><td class="hits"></td><td class="code">            NetDot username: netdot_user</td></tr><tr class="noCover"><td class="line"><a name="317">317</a></td><td class="hits"></td><td class="code">            NetDot password: (uses getpass module, to securely collect your password)</td></tr><tr class="noCover"><td class="line"><a name="318">318</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="319">319</a></td><td class="hits"></td><td class="code">        With &#96;repo&#96;, you can now retrieve data and better understand the capabilities of this API.</td></tr><tr class="noCover"><td class="line"><a name="320">320</a></td><td class="hits"></td><td class="code">        As an example, you may retrieve ipblock information about a particular IP address.</td></tr><tr class="noCover"><td class="line"><a name="321">321</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="322">322</a></td><td class="hits"></td><td class="code">             &gt;&gt; repo.get_ipblock_by_address(&#39;10.0.0.0&#39;)</td></tr><tr class="noCover"><td class="line"><a name="323">323</a></td><td class="hits"></td><td class="code">            [IPBlock(id&#61;5065, address&#61;IPv4Address(&#39;10.0.0.0&#39;), description&#61;&#39;RFC1918 Addresses&#39;, ... omitted for brevity...</td></tr><tr class="noCover"><td class="line"><a name="324">324</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="325">325</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="326">326</a></td><td class="hits"></td><td class="code">            netdot.Repository: A repository. Use &#96;help(netdot.Repository)&#96; to learn more.</td></tr><tr class="noCover"><td class="line"><a name="327">327</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="328">328</a></td><td class="hits"></td><td class="code">        # Offer to return an existing connection that has been established before</td></tr><tr class="noCover"><td class="line"><a name="329">329</a></td><td class="hits"></td><td class="code">        if cls._existing_connection:</td></tr><tr class="noCover"><td class="line"><a name="330">330</a></td><td class="hits"></td><td class="code">            use_existing_connection &#61; _input(</td></tr><tr class="noCover"><td class="line"><a name="331">331</a></td><td class="hits"></td><td class="code">                textwrap.dedent(</td></tr><tr class="noCover"><td class="line"><a name="332">332</a></td><td class="hits"></td><td class="code">                    f&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="333">333</a></td><td class="hits"></td><td class="code">                Noticed an existing connection: </td></tr><tr class="noCover"><td class="line"><a name="334">334</a></td><td class="hits"></td><td class="code">                    {cls._existing_connection}</td></tr><tr class="noCover"><td class="line"><a name="335">335</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="336">336</a></td><td class="hits"></td><td class="code">                Would you like to retrieve it instead of setting up a new connection? </td></tr><tr class="noCover"><td class="line"><a name="337">337</a></td><td class="hits"></td><td class="code">                Reply &#39;yes&#39;, or &#39;no&#39; [yes]: &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="338">338</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="noCover"><td class="line"><a name="339">339</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="340">340</a></td><td class="hits"></td><td class="code">            if not use_existing_connection.lower().startswith(&#39;n&#39;):</td></tr><tr class="noCover"><td class="line"><a name="341">341</a></td><td class="hits"></td><td class="code">                return cls._existing_connection</td></tr><tr class="noCover"><td class="line"><a name="342">342</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="343">343</a></td><td class="hits"></td><td class="code">        connection &#61; cls._connect(_input, _getpass, dry_run&#61;propose_changes, **kwargs)</td></tr><tr class="noCover"><td class="line"><a name="344">344</a></td><td class="hits"></td><td class="code">        cls._existing_connection &#61; connection</td></tr><tr class="noCover"><td class="line"><a name="345">345</a></td><td class="hits"></td><td class="code">        if propose_changes:</td></tr><tr class="noCover"><td class="line"><a name="346">346</a></td><td class="hits"></td><td class="code">            msg &#61; &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="347">347</a></td><td class="hits"></td><td class="code">                NOTICE: Proposing changes (this is a DRY RUN).</td></tr><tr class="noCover"><td class="line"><a name="348">348</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="349">349</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="350">350</a></td><td class="hits"></td><td class="code">                Call &#96;save_changes&#96; to actually create, update, and delete NetDot data.</td></tr><tr class="noCover"><td class="line"><a name="351">351</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="352">352</a></td><td class="hits"></td><td class="code">                How do I use this feature?</td></tr><tr class="noCover"><td class="line"><a name="353">353</a></td><td class="hits"></td><td class="code">                1. Retrieve data using &#96;get_*&#96; methods (and &#96;load_*&#96; methods on those objects).</td></tr><tr class="noCover"><td class="line"><a name="354">354</a></td><td class="hits"></td><td class="code">                2. Update the objects you retrieved directly in code, then either:</td></tr><tr class="noCover"><td class="line"><a name="355">355</a></td><td class="hits"></td><td class="code">                   a) call &#96;create_or_update&#96;, &#96;add_*&#96;, or &#96;delete&#96; directly the object, or</td></tr><tr class="noCover"><td class="line"><a name="356">356</a></td><td class="hits"></td><td class="code">                   b) call &#96;update&#96;, create_new&#96;, or &#96;delete&#96;  on this repository.</td></tr><tr class="noCover"><td class="line"><a name="357">357</a></td><td class="hits"></td><td class="code">                3. [Optional] Call &#96;show_changes&#96; to review what changes have been proposed.</td></tr><tr class="noCover"><td class="line"><a name="358">358</a></td><td class="hits"></td><td class="code">                4. Call &#96;save_changes&#96; to actually create, update, and delete NetDot data!</td></tr><tr class="noCover"><td class="line"><a name="359">359</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="360">360</a></td><td class="hits"></td><td class="code">                &gt; Call &#96;disable_propose_changes&#96; anytime to disable this feature and directly modify NetDot.</td></tr><tr class="noCover"><td class="line"><a name="361">361</a></td><td class="hits"></td><td class="code">                &gt;</td></tr><tr class="noCover"><td class="line"><a name="362">362</a></td><td class="hits"></td><td class="code">                &gt; Alternately, use &#96;connect(propose_changes&#61;False)&#96;.</td></tr><tr class="noCover"><td class="line"><a name="363">363</a></td><td class="hits"></td><td class="code">                &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="364">364</a></td><td class="hits"></td><td class="code">            print(textwrap.dedent(msg))</td></tr><tr class="noCover"><td class="line"><a name="365">365</a></td><td class="hits"></td><td class="code">        return connection</td></tr><tr class="noCover"><td class="line"><a name="366">366</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="367">367</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="noCover"><td class="line"><a name="368">368</a></td><td class="hits"></td><td class="code">    def _connect(cls, _input&#61;input, _getpass&#61;getpass, **kwargs):  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="369">369</a></td><td class="hits"></td><td class="code">        netdot_url &#61; (</td></tr><tr class="noCover"><td class="line"><a name="370">370</a></td><td class="hits"></td><td class="code">            _input(f&#39;What is the URL of the NetDot server? [{defaults.SERVER_URL}]: &#39;)</td></tr><tr class="noCover"><td class="line"><a name="371">371</a></td><td class="hits"></td><td class="code">            or defaults.SERVER_URL</td></tr><tr class="noCover"><td class="line"><a name="372">372</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="373">373</a></td><td class="hits"></td><td class="code">        user &#61; _input(&#39;NetDot username: &#39;)</td></tr><tr class="noCover"><td class="line"><a name="374">374</a></td><td class="hits"></td><td class="code">        password &#61; utils.HiddenString(_getpass(&#39;NetDot password: &#39;))</td></tr><tr class="noCover"><td class="line"><a name="375">375</a></td><td class="hits"></td><td class="code">        return cls(netdot_url, user, password, **kwargs)</td></tr><tr class="noCover"><td class="line"><a name="376">376</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="377">377</a></td><td class="hits">1</td><td class="code">    &#64;property</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="378">378</a></td><td class="hits">1</td><td class="code">    def connection(self) -&gt; &#39;client.Client&#39;:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="379">379</a></td><td class="hits">1</td><td class="code">        if not self._connection:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="380">380</a></td><td class="hits">0</td><td class="code">            raise exceptions.NetdotError(</td></tr><tr class="noCover"><td class="line"><a name="381">381</a></td><td class="hits"></td><td class="code">                &#39;Must establish a connection before using this repository.&#39;</td></tr><tr class="noCover"><td class="line"><a name="382">382</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="383">383</a></td><td class="hits">1</td><td class="code">        return self._connection</td></tr><tr class="noCover"><td class="line"><a name="384">384</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="385">385</a></td><td class="hits">1</td><td class="code">    def get_ipblock_children(self, id: int, **url_params) -&gt; List[&#39;netdot.IPBlock&#39;]:</td></tr><tr class="noCover"><td class="line"><a name="386">386</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the children of some parent IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="387">387</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="388">388</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="389">389</a></td><td class="hits"></td><td class="code">            id (int): The ID of the parent IPBlock.</td></tr><tr class="noCover"><td class="line"><a name="390">390</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="391">391</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="392">392</a></td><td class="hits"></td><td class="code">            List[netdot.IPBlock]: The children IPBlocks</td></tr><tr class="noCover"><td class="line"><a name="393">393</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="394">394</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="395">395</a></td><td class="hits"></td><td class="code">            HTTPError: If no such IPBlocks are found. (error details can be found in Netdot&#39;s apache server logs)  </td></tr><tr class="noCover"><td class="line"><a name="396">396</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="397">397</a></td><td class="hits">1</td><td class="code">        data &#61; self.connection.get_objects_by_filter(</td></tr><tr class="noCover"><td class="line"><a name="398">398</a></td><td class="hits"></td><td class="code">            netdot.IPBlock.NETDOT_TABLE_NAME,</td></tr><tr class="noCover"><td class="line"><a name="399">399</a></td><td class="hits"></td><td class="code">            &#39;parent&#39;,</td></tr><tr class="noCover"><td class="line"><a name="400">400</a></td><td class="hits"></td><td class="code">            str(id),</td></tr><tr class="noCover"><td class="line"><a name="401">401</a></td><td class="hits"></td><td class="code">            **url_params,</td></tr><tr class="noCover"><td class="line"><a name="402">402</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="403">403</a></td><td class="hits">1</td><td class="code">        return [</td></tr><tr class="noCover"><td class="line"><a name="404">404</a></td><td class="hits"></td><td class="code">            netdot.IPBlock.from_DTO(ipblock).with_repository(self) for ipblock in data</td></tr><tr class="noCover"><td class="line"><a name="405">405</a></td><td class="hits"></td><td class="code">        ]</td></tr><tr class="noCover"><td class="line"><a name="406">406</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="407">407</a></td><td class="hits">1</td><td class="code">    def _get_entity_by_address(self, address: str, cls, **url_params):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="408">408</a></td><td class="hits">1</td><td class="code">        return self._get_unique_by_filter(cls, &#39;address&#39;, address, **url_params)</td></tr><tr class="noCover"><td class="line"><a name="409">409</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="410">410</a></td><td class="hits">1</td><td class="code">    def _get_unique_by_filter(</td></tr><tr class="noCover"><td class="line"><a name="411">411</a></td><td class="hits"></td><td class="code">        self, cls: NetdotAPIDataclass, search_field: str, search_term: str, **url_params</td></tr><tr class="noCover"><td class="line"><a name="412">412</a></td><td class="hits"></td><td class="code">    ) -&gt; NetdotAPIDataclass:</td></tr><tr class="noCover"><td class="line"><a name="413">413</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Try to retrieve a SINGLE object from netdot.</td></tr><tr class="noCover"><td class="line"><a name="414">414</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="415">415</a></td><td class="hits"></td><td class="code">        Logs a WARNING to the console if multiple objects from netdot match this search.</td></tr><tr class="noCover"><td class="line"><a name="416">416</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="417">417</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="418">418</a></td><td class="hits"></td><td class="code">            cls (NetdotAPIDataclass): The type of object to retrieve.</td></tr><tr class="noCover"><td class="line"><a name="419">419</a></td><td class="hits"></td><td class="code">            search_field (str): Which field of &#39;cls&#39; should we be filtering by?</td></tr><tr class="noCover"><td class="line"><a name="420">420</a></td><td class="hits"></td><td class="code">            search_term (str): The unique search term.</td></tr><tr class="noCover"><td class="line"><a name="421">421</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="422">422</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="423">423</a></td><td class="hits"></td><td class="code">            NetdotAPIDataclass: The parsed object that matches the provided search_field and search_term.</td></tr><tr class="noCover"><td class="line"><a name="424">424</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="425">425</a></td><td class="hits">1</td><td class="code">        data &#61; self.connection.get_objects_by_filter(</td></tr><tr class="noCover"><td class="line"><a name="426">426</a></td><td class="hits"></td><td class="code">            cls.NETDOT_TABLE_NAME, search_field, search_term, **url_params</td></tr><tr class="noCover"><td class="line"><a name="427">427</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="428">428</a></td><td class="hits">1</td><td class="code">        matching_entities &#61; [</td></tr><tr class="noCover"><td class="line"><a name="429">429</a></td><td class="hits"></td><td class="code">            cls.from_DTO(entity_data).with_repository(self) for entity_data in data</td></tr><tr class="noCover"><td class="line"><a name="430">430</a></td><td class="hits"></td><td class="code">        ]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="431">431</a></td><td class="hits">1</td><td class="code">        if len(matching_entities) &gt; 1:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="432">432</a></td><td class="hits">0</td><td class="code">            logger.warning(</td></tr><tr class="noCover"><td class="line"><a name="433">433</a></td><td class="hits"></td><td class="code">                f&#39;Found more than one matching address for {search_term} ({cls.__name__}): {matching_entities}&#39;</td></tr><tr class="noCover"><td class="line"><a name="434">434</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="435">435</a></td><td class="hits">1</td><td class="code">        elif len(matching_entities) &lt; 1:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="436">436</a></td><td class="hits">0</td><td class="code">            return None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="437">437</a></td><td class="hits">1</td><td class="code">        return matching_entities[0]</td></tr><tr class="noCover"><td class="line"><a name="438">438</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="439">439</a></td><td class="hits">1</td><td class="code">    def get_physaddr_by_MACAddress(self, address: str) -&gt; &#39;netdot.PhysAddr&#39;:</td></tr><tr class="noCover"><td class="line"><a name="440">440</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get some Physical Address from Netdot Address Space.</td></tr><tr class="noCover"><td class="line"><a name="441">441</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="442">442</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="443">443</a></td><td class="hits"></td><td class="code">            address (str): The MAC Address to lookup, e.g. &#34;00:00:00:00:00:00&#34;</td></tr><tr class="noCover"><td class="line"><a name="444">444</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="445">445</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="446">446</a></td><td class="hits"></td><td class="code">            netdot.PhysAddr: The Physical Address object that matched the provided address, or None.</td></tr><tr class="noCover"><td class="line"><a name="447">447</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="448">448</a></td><td class="hits">1</td><td class="code">        return self._get_entity_by_address(address, netdot.PhysAddr)</td></tr><tr class="noCover"><td class="line"><a name="449">449</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="450">450</a></td><td class="hits">1</td><td class="code">    def find_edge_port(self, mac_address: str) -&gt; &#39;netdot.Interface&#39;:</td></tr><tr class="noCover"><td class="line"><a name="451">451</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the Edge Port (Interface) associated to some MAC Address.</td></tr><tr class="noCover"><td class="line"><a name="452">452</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="453">453</a></td><td class="hits"></td><td class="code">        &gt; NOTE: This will make &#96;N&#43;M&#96; HTTP Requests (where N ).</td></tr><tr class="noCover"><td class="line"><a name="454">454</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="455">455</a></td><td class="hits"></td><td class="code">        The idea is to get all device ports whose latest forwarding tables included this address.</td></tr><tr class="noCover"><td class="line"><a name="456">456</a></td><td class="hits"></td><td class="code">        If we get more than one, select the one whose forwarding table had the least entries.</td></tr><tr class="noCover"><td class="line"><a name="457">457</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="458">458</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="459">459</a></td><td class="hits"></td><td class="code">            mac_address (str): A MAC Address to lookup.</td></tr><tr class="noCover"><td class="line"><a name="460">460</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="461">461</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="462">462</a></td><td class="hits"></td><td class="code">            netdot.Interface: The edge port associated to the provided MAC Address.</td></tr><tr class="noCover"><td class="line"><a name="463">463</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="464">464</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="465">465</a></td><td class="hits"></td><td class="code">            HTTPError: If the MAC Address cannot be found, or if any subsequent HTTP requests fail. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="466">466</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="467">467</a></td><td class="hits">1</td><td class="code">        physaddr &#61; self.get_physaddr_by_MACAddress(mac_address)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="468">468</a></td><td class="hits">1</td><td class="code">        entries &#61; self.get_fwtableentries_by_physaddr(physaddr)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="469">469</a></td><td class="hits">1</td><td class="code">        if len(entries) &#61;&#61; 1:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="470">470</a></td><td class="hits">0</td><td class="code">            return entries[0].load_interface()</td></tr><tr class="noCover"><td class="line"><a name="471">471</a></td><td class="hits"></td><td class="code">        elif len(entries) &#61;&#61; 0:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="472">472</a></td><td class="hits"></td><td class="code">            # Defensive programming: HTTPError will be raised before this could occur.</td></tr><tr class="noCover"><td class="line"><a name="473">473</a></td><td class="hits"></td><td class="code">            return</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="474">474</a></td><td class="hits">1</td><td class="code">        timestamps &#61; [entry.infer_timestamp() for entry in entries]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="475">475</a></td><td class="hits">1</td><td class="code">        most_recent_scan_time &#61; max(timestamps)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="476">476</a></td><td class="hits">1</td><td class="code">        most_recent_entries &#61; list(</td></tr><tr class="noCover"><td class="line"><a name="477">477</a></td><td class="hits"></td><td class="code">            filter(</td></tr><tr class="noCover"><td class="line"><a name="478">478</a></td><td class="hits"></td><td class="code">                lambda entry: entry.infer_timestamp() &#61;&#61; most_recent_scan_time, entries</td></tr><tr class="noCover"><td class="line"><a name="479">479</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="480">480</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="481">481</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="482">482</a></td><td class="hits"></td><td class="code">        # TODO can we omit the calls to get_fwtableentries_by_interface? Perhaps the &#34;entries&#34; already loaded is sufficient to lookup interface_counts.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="483">483</a></td><td class="hits">1</td><td class="code">        def get_related_fwtableentries(entry: netdot.FWTableEntry):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="484">484</a></td><td class="hits">1</td><td class="code">            interface &#61; entry.load_interface()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="485">485</a></td><td class="hits">1</td><td class="code">            return self.get_fwtableentries_by_interface(</td></tr><tr class="noCover"><td class="line"><a name="486">486</a></td><td class="hits"></td><td class="code">                interface, fwtable&#61;entry.fwtable_xlink</td></tr><tr class="noCover"><td class="line"><a name="487">487</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="488">488</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="489">489</a></td><td class="hits">1</td><td class="code">        with self._create_thread_pool() as executor:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="490">490</a></td><td class="hits">1</td><td class="code">            related_fwtableentries &#61; executor.map(</td></tr><tr class="noCover"><td class="line"><a name="491">491</a></td><td class="hits"></td><td class="code">                get_related_fwtableentries, most_recent_entries</td></tr><tr class="noCover"><td class="line"><a name="492">492</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="493">493</a></td><td class="hits">1</td><td class="code">            least_fwtableentries &#61; min(related_fwtableentries, key&#61;len)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="494">494</a></td><td class="hits">1</td><td class="code">            most_recent_entry &#61; max(least_fwtableentries, key&#61;id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="495">495</a></td><td class="hits">1</td><td class="code">            return most_recent_entry.load_interface()</td></tr><tr class="noCover"><td class="line"><a name="496">496</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="497">497</a></td><td class="hits">1</td><td class="code">    def get_rr_by_address(self, address: str) -&gt; &#39;netdot.RR&#39;:</td></tr><tr class="noCover"><td class="line"><a name="498">498</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a Resource Record from Netdot Address Space, by IP Address.</td></tr><tr class="noCover"><td class="line"><a name="499">499</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="500">500</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="501">501</a></td><td class="hits"></td><td class="code">            address (str): The IP Address to lookup, e.g. &#34;10.0.0.123&#34;</td></tr><tr class="noCover"><td class="line"><a name="502">502</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="503">503</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="504">504</a></td><td class="hits"></td><td class="code">            netdot.RR: The Resource Record that matched the provided address.</td></tr><tr class="noCover"><td class="line"><a name="505">505</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="506">506</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="507">507</a></td><td class="hits"></td><td class="code">            HTTPError: If the Resource Record cannot be found. (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="508">508</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="509">509</a></td><td class="hits">1</td><td class="code">        ipblock &#61; self.get_ipblock_by_address(address)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="510">510</a></td><td class="hits">1</td><td class="code">        rraddr &#61; self._get_unique_by_filter(netdot.RRADDR, &#39;ipblock&#39;, ipblock.id)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="511">511</a></td><td class="hits">1</td><td class="code">        return self.get_rr(rraddr.rr_xlink)</td></tr><tr class="noCover"><td class="line"><a name="512">512</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="513">513</a></td><td class="hits">1</td><td class="code">    def get_ipblock_by_address(self, address: str) -&gt; &#39;netdot.IPBlock&#39;:</td></tr><tr class="noCover"><td class="line"><a name="514">514</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get some IP Block from Netdot Address Space.</td></tr><tr class="noCover"><td class="line"><a name="515">515</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="516">516</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="517">517</a></td><td class="hits"></td><td class="code">            address (str): The IP Address to lookup, e.g. &#34;10.0.0.0&#34;</td></tr><tr class="noCover"><td class="line"><a name="518">518</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="519">519</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="520">520</a></td><td class="hits"></td><td class="code">            IPBlock: The IPBlock object that matched the provided address, or None.</td></tr><tr class="noCover"><td class="line"><a name="521">521</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="522">522</a></td><td class="hits">1</td><td class="code">        return self._get_entity_by_address(address, netdot.IPBlock)</td></tr><tr class="noCover"><td class="line"><a name="523">523</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="524">524</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="525">525</a></td><td class="hits">1</td><td class="code">def generate_CRUD_for_all_dataclasses(dataclasses) -&gt; List:</td></tr><tr class="noCover"><td class="line"><a name="526">526</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Generate the &#39;CRUD&#39; operations for this repository for all Netdot dataclasses.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="527">527</a></td><td class="hits">1</td><td class="code">    CRUD_methods &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="528">528</a></td><td class="hits">1</td><td class="code">    for dataclass in dataclasses:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="529">529</a></td><td class="hits">1</td><td class="code">        CRUD_methods.extend(generate_getters_for_dataclass(dataclass))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="530">530</a></td><td class="hits">1</td><td class="code">    return CRUD_methods</td></tr><tr class="noCover"><td class="line"><a name="531">531</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="532">532</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="533">533</a></td><td class="hits">1</td><td class="code">def generate_getters_for_dataclass(dataclass: NetdotAPIDataclass) -&gt; List:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="534">534</a></td><td class="hits">1</td><td class="code">    methods_for_dataclass &#61; generate_xlink_getters(dataclass) &#43; [</td></tr><tr class="noCover"><td class="line"><a name="535">535</a></td><td class="hits"></td><td class="code">        generate_all_getter(dataclass),</td></tr><tr class="noCover"><td class="line"><a name="536">536</a></td><td class="hits"></td><td class="code">        generate_by_id_getter(dataclass),</td></tr><tr class="noCover"><td class="line"><a name="537">537</a></td><td class="hits"></td><td class="code">    ]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="538">538</a></td><td class="hits">1</td><td class="code">    return methods_for_dataclass</td></tr><tr class="noCover"><td class="line"><a name="539">539</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="540">540</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="541">541</a></td><td class="hits">1</td><td class="code">def generate_by_id_getter(dataclass: NetdotAPIDataclass):</td></tr><tr class="noCover"><td class="line"><a name="542">542</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="noCover"><td class="line"><a name="543">543</a></td><td class="hits"></td><td class="code">    # Generate a custom &#96;get_by_id&#96; method for dataclass</td></tr><tr class="noCover"><td class="line"><a name="544">544</a></td><td class="hits"></td><td class="code">    #</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="545">545</a></td><td class="hits">1</td><td class="code">    def get_by_id(self, id: int) -&gt; dataclass:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="546">546</a></td><td class="hits">1</td><td class="code">        data &#61; self.connection.get_object_by_id(dataclass.NETDOT_TABLE_NAME, str(id))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="547">547</a></td><td class="hits">1</td><td class="code">        return dataclass.from_DTO(data).with_repository(self)</td></tr><tr class="noCover"><td class="line"><a name="548">548</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="549">549</a></td><td class="hits">1</td><td class="code">    get_by_id.__doc__ &#61; f&#34;&#34;&#34;Get info about a {dataclass.__name__} from Netdot.</td></tr><tr class="noCover"><td class="line"><a name="550">550</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="551">551</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="552">552</a></td><td class="hits"></td><td class="code">        id (int): The ID of the {dataclass.__name__} to retrieve.</td></tr><tr class="noCover"><td class="line"><a name="553">553</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="554">554</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="555">555</a></td><td class="hits"></td><td class="code">        netdot.{dataclass.__name__}: The {dataclass.__name__} with &#96;id&#96;. (raises ValueError if &#96;id&#96; is not found)</td></tr><tr class="noCover"><td class="line"><a name="556">556</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="557">557</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="558">558</a></td><td class="hits"></td><td class="code">        ValueError: if the {dataclass.__name__} cannot be retrieved for some reason.</td></tr><tr class="noCover"><td class="line"><a name="559">559</a></td><td class="hits"></td><td class="code">        NetdotError: if some internal error happens (in this Python Netdot API wrapper, or on the Netdot Server itself).</td></tr><tr class="noCover"><td class="line"><a name="560">560</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="561">561</a></td><td class="hits">1</td><td class="code">    get_by_id.__name__ &#61; f&#39;get_{dataclass._pep8_method_friendly_name()}&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="562">562</a></td><td class="hits">1</td><td class="code">    return get_by_id</td></tr><tr class="noCover"><td class="line"><a name="563">563</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="564">564</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="565">565</a></td><td class="hits">1</td><td class="code">def generate_all_getter(dataclass) -&gt; Callable:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="566">566</a></td><td class="hits">1</td><td class="code">    def get_all(self, **url_params) -&gt; List[dataclass]:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="567">567</a></td><td class="hits">1</td><td class="code">        data_list &#61; self.connection.get_all(dataclass.NETDOT_TABLE_NAME, **url_params)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="568">568</a></td><td class="hits">1</td><td class="code">        return [dataclass.from_DTO(data).with_repository(self) for data in data_list]</td></tr><tr class="noCover"><td class="line"><a name="569">569</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="570">570</a></td><td class="hits">1</td><td class="code">    get_all.__doc__ &#61; f&#34;&#34;&#34;Get info about {dataclass._name_pluralized()} from Netdot.</td></tr><tr class="noCover"><td class="line"><a name="571">571</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="572">572</a></td><td class="hits"></td><td class="code">    &gt; NOTE: This will return ALL {dataclass._name_pluralized()} from Netdot if no kwargs are provided.</td></tr><tr class="noCover"><td class="line"><a name="573">573</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="574">574</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="575">575</a></td><td class="hits"></td><td class="code">        **kwargs: URL Parameters - Any keyword args will be used as URL Parameters. Ex. (id&#61;1) will be translated to &#96;?id&#61;1&#96; in the URL.</td></tr><tr class="noCover"><td class="line"><a name="576">576</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="577">577</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="578">578</a></td><td class="hits"></td><td class="code">        List[netdot.{dataclass.__name__}]: {dataclass._name_pluralized()} from Netdot (that match provided URL Parameters).</td></tr><tr class="noCover"><td class="line"><a name="579">579</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="580">580</a></td><td class="hits"></td><td class="code">    Raises:</td></tr><tr class="noCover"><td class="line"><a name="581">581</a></td><td class="hits"></td><td class="code">        HTTPError: For any HTTP errors (including HTTP 404 if no matches are found). (error details can be found in Netdot&#39;s apache server logs)</td></tr><tr class="noCover"><td class="line"><a name="582">582</a></td><td class="hits"></td><td class="code">        NetdotError: if some internal error happens (in this Python Netdot API wrapper, or on the Netdot Server itself).</td></tr><tr class="noCover"><td class="line"><a name="583">583</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="584">584</a></td><td class="hits">1</td><td class="code">    get_all.__name__ &#61; f&#39;get_{dataclass._name_pluralized().lower()}_where&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="585">585</a></td><td class="hits">1</td><td class="code">    return get_all</td></tr><tr class="noCover"><td class="line"><a name="586">586</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="587">587</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="588">588</a></td><td class="hits">1</td><td class="code">def _generate_xlink_by_id_getter(dataclass, xlink, xlink_class):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="589">589</a></td><td class="hits">1</td><td class="code">    def xlink_by_id_getter(self, other: Union[int, NetdotAPIDataclass], **url_params):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="590">590</a></td><td class="hits">1</td><td class="code">        if isinstance(other, NetdotAPIDataclass):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="591">591</a></td><td class="hits">1</td><td class="code">            other &#61; other.id</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="592">592</a></td><td class="hits">1</td><td class="code">        data_list &#61; self.connection.get_objects_by_filter(</td></tr><tr class="noCover"><td class="line"><a name="593">593</a></td><td class="hits"></td><td class="code">            dataclass.NETDOT_TABLE_NAME,</td></tr><tr class="noCover"><td class="line"><a name="594">594</a></td><td class="hits"></td><td class="code">            xlink.replace(</td></tr><tr class="noCover"><td class="line"><a name="595">595</a></td><td class="hits"></td><td class="code">                &#39;_xlink&#39;, &#39;&#39;</td></tr><tr class="noCover"><td class="line"><a name="596">596</a></td><td class="hits"></td><td class="code">            ),  # Should this instead be xlink_class.NETDOT_TABLE_NAME?</td></tr><tr class="noCover"><td class="line"><a name="597">597</a></td><td class="hits"></td><td class="code">            other,</td></tr><tr class="noCover"><td class="line"><a name="598">598</a></td><td class="hits"></td><td class="code">            **url_params,</td></tr><tr class="noCover"><td class="line"><a name="599">599</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="600">600</a></td><td class="hits">1</td><td class="code">        return [dataclass.from_DTO(data).with_repository(self) for data in data_list]</td></tr><tr class="noCover"><td class="line"><a name="601">601</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="602">602</a></td><td class="hits">1</td><td class="code">    xlink_by_id_getter.__doc__ &#61; f&#34;&#34;&#34;Get the list of {dataclass._name_pluralized()} associated to a particular {xlink_class.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="603">603</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="604">604</a></td><td class="hits"></td><td class="code">    Args:</td></tr><tr class="noCover"><td class="line"><a name="605">605</a></td><td class="hits"></td><td class="code">        other (int,NetdotAPIDataclass): The particular {xlink_class.__name__} or its &#96;id&#96;.</td></tr><tr class="noCover"><td class="line"><a name="606">606</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="607">607</a></td><td class="hits"></td><td class="code">    Returns:</td></tr><tr class="noCover"><td class="line"><a name="608">608</a></td><td class="hits"></td><td class="code">        List[netdot.{dataclass.__name__}]: The list of {dataclass._name_pluralized()} associated to the {xlink_class.__name__}.</td></tr><tr class="noCover"><td class="line"><a name="609">609</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="610">610</a></td><td class="hits">1</td><td class="code">    xlink_by_id_getter.__name__ &#61; (</td></tr><tr class="noCover"><td class="line"><a name="611">611</a></td><td class="hits"></td><td class="code">        f&#34;get_{dataclass._name_pluralized().lower()}_by_{xlink.replace(&#39;_xlink&#39;,&#39;&#39;)}&#34;</td></tr><tr class="noCover"><td class="line"><a name="612">612</a></td><td class="hits"></td><td class="code">    )</td></tr><tr class="noCover"><td class="line"><a name="613">613</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="614">614</a></td><td class="hits">1</td><td class="code">    return xlink_by_id_getter</td></tr><tr class="noCover"><td class="line"><a name="615">615</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="616">616</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="617">617</a></td><td class="hits">1</td><td class="code">def generate_xlink_getters(my_cls) -&gt; List:</td></tr><tr class="noCover"><td class="line"><a name="618">618</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Generate custom &#96;get_A[s]_by_B&#96; methods for dataclass, based on its foreign_key_field_names.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="619">619</a></td><td class="hits">1</td><td class="code">    xlink_getters &#61; []</td></tr><tr class="noCover"><td class="line"><a name="620">620</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="621">621</a></td><td class="hits">1</td><td class="code">    for xlink, other_cls in my_cls._related_classes().items():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="622">622</a></td><td class="hits">1</td><td class="code">        xlink_by_id_getter &#61; _generate_xlink_by_id_getter(my_cls, xlink, other_cls)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="623">623</a></td><td class="hits">1</td><td class="code">        xlink_getters.append(xlink_by_id_getter)</td></tr><tr class="noCover"><td class="line"><a name="624">624</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="625">625</a></td><td class="hits">1</td><td class="code">    return xlink_getters</td></tr>