<tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="1">1</a></td><td class="hits">1</td><td class="code">import logging</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="2">2</a></td><td class="hits">1</td><td class="code">from typing import List</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="3">3</a></td><td class="hits">1</td><td class="code">import threading</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="4">4</a></td><td class="hits">1</td><td class="code">import shutil</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="5">5</a></td><td class="hits">1</td><td class="code">from copy import copy</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="6">6</a></td><td class="hits">1</td><td class="code">import pickle</td></tr><tr class="noCover"><td class="line"><a name="7">7</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="8">8</a></td><td class="hits">1</td><td class="code">from tqdm import tqdm</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="9">9</a></td><td class="hits">1</td><td class="code">from tabulate import tabulate</td></tr><tr class="noCover"><td class="line"><a name="10">10</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="11">11</a></td><td class="hits">1</td><td class="code">import netdot</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="12">12</a></td><td class="hits">1</td><td class="code">from netdot import actions, defaults, utils</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="13">13</a></td><td class="hits">1</td><td class="code">from netdot import NetdotAPIDataclass</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="14">14</a></td><td class="hits">1</td><td class="code">from netdot.csv_util import CSVDataclass</td></tr><tr class="noCover"><td class="line"><a name="15">15</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="16">16</a></td><td class="hits">1</td><td class="code">logger &#61; logging.getLogger(__name__)</td></tr><tr class="noCover"><td class="line"><a name="17">17</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="18">18</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="19">19</a></td><td class="hits">1</td><td class="code">class UnitOfWork:</td></tr><tr class="noCover"><td class="line"><a name="20">20</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;Prepare some set of changes to be made in Netdot. Submit these changes using save_changes().&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="21">21</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="22">22</a></td><td class="hits">1</td><td class="code">    _initialized &#61; False</td></tr><tr class="noCover"><td class="line"><a name="23">23</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="24">24</a></td><td class="hits">1</td><td class="code">    def __init__(</td></tr><tr class="noCover"><td class="line"><a name="25">25</a></td><td class="hits"></td><td class="code">        self,</td></tr><tr class="noCover"><td class="line"><a name="26">26</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="27">27</a></td><td class="hits">1</td><td class="code">        UnitOfWork.prepare_class()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="28">28</a></td><td class="hits">1</td><td class="code">        self._actions: List[actions.NetdotAction] &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="29">29</a></td><td class="hits">1</td><td class="code">        self._completed_actions &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="30">30</a></td><td class="hits">1</td><td class="code">        self._responses &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="31">31</a></td><td class="hits">1</td><td class="code">        self._action_in_progress: actions.NetdotAction &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="32">32</a></td><td class="hits">1</td><td class="code">        self._failed_actions: List[actions.NetdotAction] &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="33">33</a></td><td class="hits">1</td><td class="code">        self._failed_actions_exceptions: List[Exception] &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="34">34</a></td><td class="hits">1</td><td class="code">        self._lock &#61; threading.Lock()</td></tr><tr class="noCover"><td class="line"><a name="35">35</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="36">36</a></td><td class="hits">1</td><td class="code">    def __getstate__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="37">37</a></td><td class="hits">1</td><td class="code">        state &#61; self.__dict__.copy()</td></tr><tr class="noCover"><td class="line"><a name="38">38</a></td><td class="hits"></td><td class="code">        # Remove the unpicklable entries.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="39">39</a></td><td class="hits">1</td><td class="code">        del state[&#39;_lock&#39;]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="40">40</a></td><td class="hits">1</td><td class="code">        return state</td></tr><tr class="noCover"><td class="line"><a name="41">41</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="42">42</a></td><td class="hits">1</td><td class="code">    def __setstate__(self, state):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="43">43</a></td><td class="hits">1</td><td class="code">        self.__dict__.update(state)</td></tr><tr class="noCover"><td class="line"><a name="44">44</a></td><td class="hits"></td><td class="code">        # Restore the unpicklable entries.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="45">45</a></td><td class="hits">1</td><td class="code">        self._lock &#61; threading.Lock()</td></tr><tr class="noCover"><td class="line"><a name="46">46</a></td><td class="hits"></td><td class="code">    </td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="47">47</a></td><td class="hits">1</td><td class="code">    def __len__(self):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="48">48</a></td><td class="hits">1</td><td class="code">        return len(self._actions)</td></tr><tr class="noCover"><td class="line"><a name="49">49</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="50">50</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="51">51</a></td><td class="hits">1</td><td class="code">    def prepare_class(cls):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="52">52</a></td><td class="hits">1</td><td class="code">        if not cls._initialized:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="53">53</a></td><td class="hits">1</td><td class="code">            netdot.initialize()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="54">54</a></td><td class="hits">1</td><td class="code">            cls._initialized &#61; True</td></tr><tr class="noCover"><td class="line"><a name="55">55</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="56">56</a></td><td class="hits">1</td><td class="code">    &#64;classmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="57">57</a></td><td class="hits">1</td><td class="code">    def from_action_list(cls, action_list: List[&#34;actions.NetdotAction&#34;], **kwargs):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="58">58</a></td><td class="hits">1</td><td class="code">        new_unit_of_work &#61; cls(**kwargs)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="59">59</a></td><td class="hits">1</td><td class="code">        new_unit_of_work._actions &#61; action_list</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="60">60</a></td><td class="hits">1</td><td class="code">        return new_unit_of_work</td></tr><tr class="noCover"><td class="line"><a name="61">61</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="62">62</a></td><td class="hits">1</td><td class="code">    def save_as_pickle(self, filename: str &#61; defaults.ERROR_PICKLE_FILENAME) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="63">63</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Save this Unit of Work to a file.</td></tr><tr class="noCover"><td class="line"><a name="64">64</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="65">65</a></td><td class="hits"></td><td class="code">        To be loaded in the future using :func:&#96;load()&#96;.</td></tr><tr class="noCover"><td class="line"><a name="66">66</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="67">67</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="68">68</a></td><td class="hits"></td><td class="code">            filename (str, optional): The file to save to. Defaults to a dynamic &#34;defaults.ERROR_PICKLE_FILENAME&#34; (which includes version and timestamp).</td></tr><tr class="noCover"><td class="line"><a name="69">69</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="70">70</a></td><td class="hits">1</td><td class="code">        with open(filename, &#39;wb&#39;) as f:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="71">71</a></td><td class="hits">1</td><td class="code">            pickle.dump(self, f, pickle.HIGHEST_PROTOCOL)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="72">72</a></td><td class="hits">1</td><td class="code">        return filename</td></tr><tr class="noCover"><td class="line"><a name="73">73</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="74">74</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="75">75</a></td><td class="hits">1</td><td class="code">    def load(filename):</td></tr><tr class="noCover"><td class="line"><a name="76">76</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Load a Unit of Work from a pickle file.</td></tr><tr class="noCover"><td class="line"><a name="77">77</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="78">78</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="79">79</a></td><td class="hits"></td><td class="code">            filename (str): The file to load from.</td></tr><tr class="noCover"><td class="line"><a name="80">80</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="81">81</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="82">82</a></td><td class="hits"></td><td class="code">            UnitOfWork: The Unit of Work that was loaded.</td></tr><tr class="noCover"><td class="line"><a name="83">83</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="84">84</a></td><td class="hits">1</td><td class="code">        with open(filename, &#39;rb&#39;) as f:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="85">85</a></td><td class="hits">1</td><td class="code">            return pickle.load(f)</td></tr><tr class="noCover"><td class="line"><a name="86">86</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="87">87</a></td><td class="hits">1</td><td class="code">    def as_list(self):</td></tr><tr class="noCover"><td class="line"><a name="88">88</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a copy of to-be-completed actions in this Unit of Work.</td></tr><tr class="noCover"><td class="line"><a name="89">89</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="90">90</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="91">91</a></td><td class="hits"></td><td class="code">            List[NetdotAction]: The list of to-be-completed actions.</td></tr><tr class="noCover"><td class="line"><a name="92">92</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="93">93</a></td><td class="hits">1</td><td class="code">        return list(self._actions)</td></tr><tr class="noCover"><td class="line"><a name="94">94</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="95">95</a></td><td class="hits">1</td><td class="code">    def _append_deduplicated_update(self, new_action: actions.NetdotAction):</td></tr><tr class="noCover"><td class="line"><a name="96">96</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Add an UPDATE action to this Unit of Work, ensuring that any prior updates to that same object are removed (since the latest update will contain all changes)&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="97">97</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="98">98</a></td><td class="hits">1</td><td class="code">        for action in self._actions:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="99">99</a></td><td class="hits">1</td><td class="code">            if action.action_type !&#61; actions.ActionTypes.UPDATE:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="100">100</a></td><td class="hits">1</td><td class="code">                continue</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="101">101</a></td><td class="hits">1</td><td class="code">            if not isinstance(new_action.new_data, type(action.new_data)):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="102">102</a></td><td class="hits">0</td><td class="code">                continue</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="103">103</a></td><td class="hits">1</td><td class="code">            if action.id !&#61; new_action.id:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="104">104</a></td><td class="hits">0</td><td class="code">                continue</td></tr><tr class="noCover"><td class="line"><a name="105">105</a></td><td class="hits"></td><td class="code">            # Cleanup any action that is updating the same object</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="106">106</a></td><td class="hits">1</td><td class="code">            self._actions.remove(action)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="107">107</a></td><td class="hits">1</td><td class="code">        self._actions.append(new_action)</td></tr><tr class="noCover"><td class="line"><a name="108">108</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="109">109</a></td><td class="hits">1</td><td class="code">    def create(self, new_data: NetdotAPIDataclass, print_changes&#61;False, one_line&#61;True):</td></tr><tr class="noCover"><td class="line"><a name="110">110</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Create a new object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="111">111</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="112">112</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="113">113</a></td><td class="hits"></td><td class="code">            new_data (netdot.NetdotAPIDataclass): The new data to use when creating the object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="114">114</a></td><td class="hits"></td><td class="code">            truncate (int): Truncate the message to this many characters. Defaults to None.</td></tr><tr class="noCover"><td class="line"><a name="115">115</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="116">116</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="117">117</a></td><td class="hits"></td><td class="code">            TypeError: If new_data is not a subclass of NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="118">118</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="119">119</a></td><td class="hits">1</td><td class="code">        if not isinstance(new_data, NetdotAPIDataclass):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="120">120</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="121">121</a></td><td class="hits"></td><td class="code">                f&#34;Expect new_data to be subclass of NetdotAPIDataclass, instead got: {type(new_data)}&#34;</td></tr><tr class="noCover"><td class="line"><a name="122">122</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="123">123</a></td><td class="hits">1</td><td class="code">        action &#61; actions.NetdotAction(</td></tr><tr class="noCover"><td class="line"><a name="124">124</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.CREATE,</td></tr><tr class="noCover"><td class="line"><a name="125">125</a></td><td class="hits"></td><td class="code">            id&#61;None,</td></tr><tr class="noCover"><td class="line"><a name="126">126</a></td><td class="hits"></td><td class="code">            new_data&#61;new_data,</td></tr><tr class="noCover"><td class="line"><a name="127">127</a></td><td class="hits"></td><td class="code">            old_data&#61;None,</td></tr><tr class="noCover"><td class="line"><a name="128">128</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="129">129</a></td><td class="hits"></td><td class="code">        if print_changes:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="130">130</a></td><td class="hits"></td><td class="code">            max_chars &#61; None</td></tr><tr class="noCover"><td class="line"><a name="131">131</a></td><td class="hits"></td><td class="code">            if one_line:</td></tr><tr class="noCover"><td class="line"><a name="132">132</a></td><td class="hits"></td><td class="code">                max_chars &#61; shutil.get_terminal_size().columns</td></tr><tr class="noCover"><td class="line"><a name="133">133</a></td><td class="hits"></td><td class="code">            print(action.generate_log_for_action(truncate&#61;max_chars))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="134">134</a></td><td class="hits">1</td><td class="code">        self._actions.append(action)</td></tr><tr class="noCover"><td class="line"><a name="135">135</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="136">136</a></td><td class="hits">1</td><td class="code">    def update(</td></tr><tr class="noCover"><td class="line"><a name="137">137</a></td><td class="hits"></td><td class="code">        self,</td></tr><tr class="noCover"><td class="line"><a name="138">138</a></td><td class="hits"></td><td class="code">        old_data: NetdotAPIDataclass,</td></tr><tr class="noCover"><td class="line"><a name="139">139</a></td><td class="hits"></td><td class="code">        new_data: NetdotAPIDataclass,</td></tr><tr class="noCover"><td class="line"><a name="140">140</a></td><td class="hits"></td><td class="code">        print_changes&#61;False,</td></tr><tr class="noCover"><td class="line"><a name="141">141</a></td><td class="hits"></td><td class="code">        one_line&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="142">142</a></td><td class="hits"></td><td class="code">        deduplicate&#61;True,</td></tr><tr class="noCover"><td class="line"><a name="143">143</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="noCover"><td class="line"><a name="144">144</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Update an existing object in Netdot.</td></tr><tr class="noCover"><td class="line"><a name="145">145</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="146">146</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="147">147</a></td><td class="hits"></td><td class="code">            new_data (netdot.NetdotAPIDataclass): The new data to use when updating.</td></tr><tr class="noCover"><td class="line"><a name="148">148</a></td><td class="hits"></td><td class="code">            old_data (netdot.NetdotAPIDataclass): The old data that is going to be replaced.</td></tr><tr class="noCover"><td class="line"><a name="149">149</a></td><td class="hits"></td><td class="code">            deduplicate (bool): If True, consolidate duplicate UPDATE actions that are added to this Unit of Work.</td></tr><tr class="noCover"><td class="line"><a name="150">150</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="151">151</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="152">152</a></td><td class="hits"></td><td class="code">            TypeError: If new_data and old_data are not the same type (or not a subclass of NetdotAPIDataclass).</td></tr><tr class="noCover"><td class="line"><a name="153">153</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="154">154</a></td><td class="hits">1</td><td class="code">        if (</td></tr><tr class="noCover"><td class="line"><a name="155">155</a></td><td class="hits"></td><td class="code">            # fmt: off</td></tr><tr class="noCover"><td class="line"><a name="156">156</a></td><td class="hits"></td><td class="code">            not isinstance(old_data, type(new_data))</td></tr><tr class="noCover"><td class="line"><a name="157">157</a></td><td class="hits"></td><td class="code">            or not isinstance(new_data, NetdotAPIDataclass)</td></tr><tr class="noCover"><td class="line"><a name="158">158</a></td><td class="hits"></td><td class="code">            # fmt: on</td></tr><tr class="noCover"><td class="line"><a name="159">159</a></td><td class="hits"></td><td class="code">        ):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="160">160</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="161">161</a></td><td class="hits"></td><td class="code">                f&#34;&#34;&#34;Invalid argument, expecting both new_data and old_data to be the same subclass of NetdotAPIDataclass, but got: </td></tr><tr class="noCover"><td class="line"><a name="162">162</a></td><td class="hits"></td><td class="code">    new_data: {new_data}  </td></tr><tr class="noCover"><td class="line"><a name="163">163</a></td><td class="hits"></td><td class="code">    old_data: {old_data}</td></tr><tr class="noCover"><td class="line"><a name="164">164</a></td><td class="hits"></td><td class="code">    &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="165">165</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="166">166</a></td><td class="hits">1</td><td class="code">        action &#61; actions.NetdotAction(</td></tr><tr class="noCover"><td class="line"><a name="167">167</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.UPDATE,</td></tr><tr class="noCover"><td class="line"><a name="168">168</a></td><td class="hits"></td><td class="code">            id&#61;old_data.id,</td></tr><tr class="noCover"><td class="line"><a name="169">169</a></td><td class="hits"></td><td class="code">            new_data&#61;new_data,</td></tr><tr class="noCover"><td class="line"><a name="170">170</a></td><td class="hits"></td><td class="code">            old_data&#61;old_data,</td></tr><tr class="noCover"><td class="line"><a name="171">171</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="172">172</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="173">173</a></td><td class="hits"></td><td class="code">        if print_changes:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="174">174</a></td><td class="hits"></td><td class="code">            max_chars &#61; None</td></tr><tr class="noCover"><td class="line"><a name="175">175</a></td><td class="hits"></td><td class="code">            if one_line:</td></tr><tr class="noCover"><td class="line"><a name="176">176</a></td><td class="hits"></td><td class="code">                max_chars &#61; shutil.get_terminal_size().columns</td></tr><tr class="noCover"><td class="line"><a name="177">177</a></td><td class="hits"></td><td class="code">            print(action.generate_log_for_action(truncate&#61;max_chars))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="178">178</a></td><td class="hits">1</td><td class="code">        if deduplicate:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="179">179</a></td><td class="hits">1</td><td class="code">            self._append_deduplicated_update(action)</td></tr><tr class="noCover"><td class="line"><a name="180">180</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="181">181</a></td><td class="hits">0</td><td class="code">            self._actions.append(action)</td></tr><tr class="noCover"><td class="line"><a name="182">182</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="183">183</a></td><td class="hits">1</td><td class="code">    def delete(self, old_data: NetdotAPIDataclass, print_changes&#61;False, one_line&#61;True):</td></tr><tr class="noCover"><td class="line"><a name="184">184</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Delete an existing object from Netdot.</td></tr><tr class="noCover"><td class="line"><a name="185">185</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="186">186</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="187">187</a></td><td class="hits"></td><td class="code">            old_data (netdot.NetdotAPIDataclass): The object that will be deleted (must include an &#39;id&#39;).</td></tr><tr class="noCover"><td class="line"><a name="188">188</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="189">189</a></td><td class="hits"></td><td class="code">        Raises:</td></tr><tr class="noCover"><td class="line"><a name="190">190</a></td><td class="hits"></td><td class="code">            TypeError: If old_data is not a subclass of NetdotAPIDataclass.</td></tr><tr class="noCover"><td class="line"><a name="191">191</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="192">192</a></td><td class="hits">1</td><td class="code">        if not isinstance(old_data, NetdotAPIDataclass):</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="193">193</a></td><td class="hits">0</td><td class="code">            raise TypeError(</td></tr><tr class="noCover"><td class="line"><a name="194">194</a></td><td class="hits"></td><td class="code">                f&#34;Expect old_data to be subclass of NetdotAPIDataclass, instead got: {old_data}&#34;</td></tr><tr class="noCover"><td class="line"><a name="195">195</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="196">196</a></td><td class="hits">1</td><td class="code">        action &#61; actions.NetdotAction(</td></tr><tr class="noCover"><td class="line"><a name="197">197</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.DELETE,</td></tr><tr class="noCover"><td class="line"><a name="198">198</a></td><td class="hits"></td><td class="code">            id&#61;old_data.id,</td></tr><tr class="noCover"><td class="line"><a name="199">199</a></td><td class="hits"></td><td class="code">            new_data&#61;None,</td></tr><tr class="noCover"><td class="line"><a name="200">200</a></td><td class="hits"></td><td class="code">            old_data&#61;old_data,</td></tr><tr class="noCover"><td class="line"><a name="201">201</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="202">202</a></td><td class="hits"></td><td class="code">        if print_changes:  # pragma: no cover</td></tr><tr class="noCover"><td class="line"><a name="203">203</a></td><td class="hits"></td><td class="code">            max_chars &#61; None</td></tr><tr class="noCover"><td class="line"><a name="204">204</a></td><td class="hits"></td><td class="code">            if one_line:</td></tr><tr class="noCover"><td class="line"><a name="205">205</a></td><td class="hits"></td><td class="code">                max_chars &#61; shutil.get_terminal_size().columns</td></tr><tr class="noCover"><td class="line"><a name="206">206</a></td><td class="hits"></td><td class="code">            print(action.generate_log_for_action(truncate&#61;max_chars))</td></tr><tr class="noCover"><td class="line"><a name="207">207</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="208">208</a></td><td class="hits">1</td><td class="code">        self._actions.append(action)</td></tr><tr class="noCover"><td class="line"><a name="209">209</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="210">210</a></td><td class="hits">1</td><td class="code">    def without_action_types(self, action_types: List[&#34;actions.ActionTypes&#34;]):</td></tr><tr class="noCover"><td class="line"><a name="211">211</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a copy of this Unit of Work with the selected actions removed.</td></tr><tr class="noCover"><td class="line"><a name="212">212</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="213">213</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="214">214</a></td><td class="hits"></td><td class="code">            action_types (List[actions.NetdotAction]): The types of actions to be removed.</td></tr><tr class="noCover"><td class="line"><a name="215">215</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="216">216</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="217">217</a></td><td class="hits">1</td><td class="code">        def is_action_of_interest(action: actions.NetdotAction):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="218">218</a></td><td class="hits">1</td><td class="code">            return action.action_type not in action_types</td></tr><tr class="noCover"><td class="line"><a name="219">219</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="220">220</a></td><td class="hits">1</td><td class="code">        filtered_actions_list &#61; list(filter(is_action_of_interest, self._actions))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="221">221</a></td><td class="hits">1</td><td class="code">        return UnitOfWork.from_action_list(filtered_actions_list)</td></tr><tr class="noCover"><td class="line"><a name="222">222</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="223">223</a></td><td class="hits">1</td><td class="code">    def with_action_types(self, action_types: List[&#34;actions.SiteActionTypes&#34;]):</td></tr><tr class="noCover"><td class="line"><a name="224">224</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a copy of this Unit of Work containing ONLY the selected actions.</td></tr><tr class="noCover"><td class="line"><a name="225">225</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="226">226</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="227">227</a></td><td class="hits"></td><td class="code">            action_types (List[actions.NetdotAction]): The types of actions to keep.</td></tr><tr class="noCover"><td class="line"><a name="228">228</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="229">229</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="230">230</a></td><td class="hits">1</td><td class="code">        def is_action_of_interest(action: actions.NetdotAction):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="231">231</a></td><td class="hits">1</td><td class="code">            return action.action_type in action_types</td></tr><tr class="noCover"><td class="line"><a name="232">232</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="233">233</a></td><td class="hits">1</td><td class="code">        filtered_actions_list &#61; list(filter(is_action_of_interest, self._actions))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="234">234</a></td><td class="hits">1</td><td class="code">        return UnitOfWork.from_action_list(filtered_actions_list)</td></tr><tr class="noCover"><td class="line"><a name="235">235</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="236">236</a></td><td class="hits">1</td><td class="code">    def with_data_type(self, data_type: NetdotAPIDataclass):</td></tr><tr class="noCover"><td class="line"><a name="237">237</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get a copy of this Unit of Work containing actions of ONLY the selected data type.</td></tr><tr class="noCover"><td class="line"><a name="238">238</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="239">239</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="240">240</a></td><td class="hits"></td><td class="code">            data_type (NetdotAPIDataclass): The type of data to keep.</td></tr><tr class="noCover"><td class="line"><a name="241">241</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="242">242</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="243">243</a></td><td class="hits">1</td><td class="code">        def is_action_of_interest(action: actions.NetdotAction):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="244">244</a></td><td class="hits">1</td><td class="code">            return isinstance(action.new_data, data_type) or isinstance(</td></tr><tr class="noCover"><td class="line"><a name="245">245</a></td><td class="hits"></td><td class="code">                action.old_data, data_type</td></tr><tr class="noCover"><td class="line"><a name="246">246</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="noCover"><td class="line"><a name="247">247</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="248">248</a></td><td class="hits">1</td><td class="code">        filtered_actions_list &#61; list(filter(is_action_of_interest, self._actions))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="249">249</a></td><td class="hits">1</td><td class="code">        return UnitOfWork.from_action_list(filtered_actions_list)</td></tr><tr class="noCover"><td class="line"><a name="250">250</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="251">251</a></td><td class="hits">1</td><td class="code">    def failed_action(self, index&#61;-1) -&gt; actions.NetdotAction:</td></tr><tr class="noCover"><td class="line"><a name="252">252</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the action that failed when trying to save changes to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="253">253</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="254">254</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="255">255</a></td><td class="hits"></td><td class="code">            index (int, optional): Index for accessing the list of actions that have failed. Defaults to -1 (latest failed action).</td></tr><tr class="noCover"><td class="line"><a name="256">256</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="257">257</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="258">258</a></td><td class="hits"></td><td class="code">            actions.NetdotAction: The action that failed when trying to save changes to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="259">259</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="260">260</a></td><td class="hits">1</td><td class="code">        if self._failed_actions:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="261">261</a></td><td class="hits">1</td><td class="code">            return self._failed_actions[index]</td></tr><tr class="noCover"><td class="line"><a name="262">262</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="263">263</a></td><td class="hits">1</td><td class="code">    def failed_action_exception(self, index&#61;-1) -&gt; Exception:</td></tr><tr class="noCover"><td class="line"><a name="264">264</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Get the exception that occurred when trying to save changes to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="265">265</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="266">266</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="267">267</a></td><td class="hits"></td><td class="code">            index (int, optional): Index for accessing the list of exceptions that have occurred. Defaults to -1 (latest exception).</td></tr><tr class="noCover"><td class="line"><a name="268">268</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="269">269</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="270">270</a></td><td class="hits"></td><td class="code">            Exception: The exception that occurred when trying to save changes to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="271">271</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="272">272</a></td><td class="hits">1</td><td class="code">        if self._failed_actions_exceptions:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="273">273</a></td><td class="hits">1</td><td class="code">            return self._failed_actions_exceptions[index]</td></tr><tr class="noCover"><td class="line"><a name="274">274</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="275">275</a></td><td class="hits">1</td><td class="code">    def failed_action_msg(self, index&#61;-1) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="276">276</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;If &#39;save_changes&#39; failed on some action, use this to get info about the failed action.</td></tr><tr class="noCover"><td class="line"><a name="277">277</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="278">278</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="279">279</a></td><td class="hits"></td><td class="code">            str: A message indicating what the action would have done, and what exception occurred that prevented it from being completed.</td></tr><tr class="noCover"><td class="line"><a name="280">280</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="281">281</a></td><td class="hits">1</td><td class="code">        if self.failed_action(index):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="282">282</a></td><td class="hits">1</td><td class="code">            return f&#39;&#39;&#39;{self.failed_action(index).generate_log_for_action()}</td></tr><tr class="noCover"><td class="line"><a name="283">283</a></td><td class="hits"></td><td class="code">---&gt; Failed with exception: {self.failed_action_exception(index)}</td></tr><tr class="noCover"><td class="line"><a name="284">284</a></td><td class="hits"></td><td class="code">&#39;&#39;&#39;</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="285">285</a></td><td class="hits">0</td><td class="code">        return None</td></tr><tr class="noCover"><td class="line"><a name="286">286</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="287">287</a></td><td class="hits">1</td><td class="code">    def failed_actions_msgs(self) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="288">288</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Print a message for each action that has failed.</td></tr><tr class="noCover"><td class="line"><a name="289">289</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="290">290</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="291">291</a></td><td class="hits"></td><td class="code">            str: A single long message that includes all failed actions.</td></tr><tr class="noCover"><td class="line"><a name="292">292</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="293">293</a></td><td class="hits">1</td><td class="code">        messages &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="294">294</a></td><td class="hits">1</td><td class="code">        for index in range(len(self._failed_actions)):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="295">295</a></td><td class="hits">1</td><td class="code">            messages.append(f&#39;{index&#43;1}. {self.failed_action_msg(index)}&#39;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="296">296</a></td><td class="hits">1</td><td class="code">        return &#39;\n\n&#39;.join(messages)</td></tr><tr class="noCover"><td class="line"><a name="297">297</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="298">298</a></td><td class="hits">1</td><td class="code">    def status_report(self, one_line&#61;defaults.TERSE):</td></tr><tr class="noCover"><td class="line"><a name="299">299</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Show a report of all actions that have been completed, and all actions that remain to be completed.</td></tr><tr class="noCover"><td class="line"><a name="300">300</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="301">301</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="302">302</a></td><td class="hits"></td><td class="code">            one_line (bool, optional): Whether to truncate each line according to your terminal width. Defaults to defaults.TERSE.</td></tr><tr class="noCover"><td class="line"><a name="303">303</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="304">304</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="305">305</a></td><td class="hits"></td><td class="code">            str: ALL actions as pretty string (including &#39;failed action&#39;)</td></tr><tr class="noCover"><td class="line"><a name="306">306</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="307">307</a></td><td class="hits">1</td><td class="code">        message &#61; f&#39;&#39;&#39;</td></tr><tr class="noCover"><td class="line"><a name="308">308</a></td><td class="hits"></td><td class="code">Completed Actions:</td></tr><tr class="noCover"><td class="line"><a name="309">309</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="310">310</a></td><td class="hits"></td><td class="code">{self.dry_run_of_actions(self._completed_actions, one_line&#61;one_line, completed&#61;True)}</td></tr><tr class="noCover"><td class="line"><a name="311">311</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="312">312</a></td><td class="hits"></td><td class="code">Remaining Actions:</td></tr><tr class="noCover"><td class="line"><a name="313">313</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="314">314</a></td><td class="hits"></td><td class="code">{self.dry_run(one_line&#61;one_line)}</td></tr><tr class="noCover"><td class="line"><a name="315">315</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="316">316</a></td><td class="hits"></td><td class="code">&#39;&#39;&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="317">317</a></td><td class="hits">1</td><td class="code">        if self.failed_action():</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="318">318</a></td><td class="hits">1</td><td class="code">            message &#43;&#61; &#39;Failed Action(s):\n\n&#39;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="319">319</a></td><td class="hits">1</td><td class="code">            message &#43;&#61; self.failed_actions_msgs()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="320">320</a></td><td class="hits">1</td><td class="code">        return message</td></tr><tr class="noCover"><td class="line"><a name="321">321</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="322">322</a></td><td class="hits">1</td><td class="code">    def changes_as_tables(self, terse&#61;defaults.TERSE, select_cols&#61;None) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="323">323</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Return ASCII table(s) representing all of the changes to be made (grouped into tables based on Netdot Data Types).</td></tr><tr class="noCover"><td class="line"><a name="324">324</a></td><td class="hits"></td><td class="code">        </td></tr><tr class="noCover"><td class="line"><a name="325">325</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="326">326</a></td><td class="hits"></td><td class="code">            terse (bool, optional): Whether to truncate data in each column. Defaults to defaults.TERSE</td></tr><tr class="noCover"><td class="line"><a name="327">327</a></td><td class="hits"></td><td class="code">            select_cols (List[str], optional): Which columns to include in the table. Defaults to None (all columns).</td></tr><tr class="noCover"><td class="line"><a name="328">328</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="329">329</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="330">330</a></td><td class="hits"></td><td class="code">            str: The tables as a string.</td></tr><tr class="noCover"><td class="line"><a name="331">331</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="332">332</a></td><td class="hits">1</td><td class="code">        tabulated_results &#61; []</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="333">333</a></td><td class="hits">1</td><td class="code">        for dataclass in sorted(</td></tr><tr class="noCover"><td class="line"><a name="334">334</a></td><td class="hits"></td><td class="code">            NetdotAPIDataclass.__subclasses__(), key&#61;lambda c: c.__name__</td></tr><tr class="noCover"><td class="line"><a name="335">335</a></td><td class="hits"></td><td class="code">        ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="336">336</a></td><td class="hits">1</td><td class="code">            column_width &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="337">337</a></td><td class="hits">1</td><td class="code">            columns &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="338">338</a></td><td class="hits">1</td><td class="code">            if select_cols:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="339">339</a></td><td class="hits">1</td><td class="code">                columns &#61; sorted(list(</td></tr><tr class="noCover"><td class="line"><a name="340">340</a></td><td class="hits"></td><td class="code">                    set([&#34;id&#34;] &#43; select_cols).intersection(dataclass.table_header())</td></tr><tr class="noCover"><td class="line"><a name="341">341</a></td><td class="hits"></td><td class="code">                ))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="342">342</a></td><td class="hits">1</td><td class="code">                columns.insert(0, &#34;id&#34;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="343">343</a></td><td class="hits">1</td><td class="code">                columns.remove(&#34;id&#34;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="344">344</a></td><td class="hits">1</td><td class="code">            if terse:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="345">345</a></td><td class="hits">1</td><td class="code">                column_width &#61; defaults.TERSE_COL_WIDTH</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="346">346</a></td><td class="hits">1</td><td class="code">                if not select_cols:</td></tr><tr class="noCover"><td class="line"><a name="347">347</a></td><td class="hits"></td><td class="code">                    # ! Does NOT dynamically adjust number of columns based on data, only based on terminal width</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="348">348</a></td><td class="hits">1</td><td class="code">                    console_width &#61; shutil.get_terminal_size().columns</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="349">349</a></td><td class="hits">1</td><td class="code">                    terse_col_count_max &#61; console_width // column_width</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="350">350</a></td><td class="hits">1</td><td class="code">                    columns &#61; dataclass.table_header()[:terse_col_count_max]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="351">351</a></td><td class="hits">1</td><td class="code">            data_as_table &#61; self._tabulate_planned_changes(</td></tr><tr class="noCover"><td class="line"><a name="352">352</a></td><td class="hits"></td><td class="code">                dataclass, columns or dataclass.table_header(), column_width</td></tr><tr class="noCover"><td class="line"><a name="353">353</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="354">354</a></td><td class="hits">1</td><td class="code">            if data_as_table:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="355">355</a></td><td class="hits">1</td><td class="code">                tabulated_results.append(</td></tr><tr class="noCover"><td class="line"><a name="356">356</a></td><td class="hits"></td><td class="code">                    f&#34;## {dataclass.__name__} Changes&#34; &#43; &#34;\n\n&#34; &#43; data_as_table</td></tr><tr class="noCover"><td class="line"><a name="357">357</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="358">358</a></td><td class="hits">1</td><td class="code">        return &#34;\n\n\n&#34;.join(tabulated_results)</td></tr><tr class="noCover"><td class="line"><a name="359">359</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="360">360</a></td><td class="hits">1</td><td class="code">    def dry_run(self, one_line&#61;True) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="361">361</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Return a &#39;dry run&#39; of all changes to be made (but don&#39;t actually make the changes).</td></tr><tr class="noCover"><td class="line"><a name="362">362</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="363">363</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="364">364</a></td><td class="hits"></td><td class="code">            one_line (bool, optional): Whether to truncate each line according to your terminal width. Defaults to True.&#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="365">365</a></td><td class="hits">1</td><td class="code">        return self.dry_run_of_actions(self._actions, one_line&#61;one_line)</td></tr><tr class="noCover"><td class="line"><a name="366">366</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="367">367</a></td><td class="hits">1</td><td class="code">    &#64;staticmethod</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="368">368</a></td><td class="hits">1</td><td class="code">    def dry_run_of_actions(actions, one_line&#61;True, completed&#61;False, empty_message&#61;&#39;None, yet...&#39;) -&gt; str:</td></tr><tr class="noCover"><td class="line"><a name="369">369</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Return a &#39;dry run&#39; of some &#39;actions&#39;.</td></tr><tr class="noCover"><td class="line"><a name="370">370</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="371">371</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="372">372</a></td><td class="hits"></td><td class="code">            actions: The actions to be included in the dry run.</td></tr><tr class="noCover"><td class="line"><a name="373">373</a></td><td class="hits"></td><td class="code">            one_line (bool, optional): Whether to truncate each line according to your terminal width. Defaults to True.</td></tr><tr class="noCover"><td class="line"><a name="374">374</a></td><td class="hits"></td><td class="code">            completed (bool, optional): Whether to show actions as &#39;COMPLETED&#39;. Defaults to False.</td></tr><tr class="noCover"><td class="line"><a name="375">375</a></td><td class="hits"></td><td class="code">        </td></tr><tr class="noCover"><td class="line"><a name="376">376</a></td><td class="hits"></td><td class="code">        Returns:</td></tr><tr class="noCover"><td class="line"><a name="377">377</a></td><td class="hits"></td><td class="code">            str: Each action in actions, printed in a nicely enumerated plain english list.</td></tr><tr class="noCover"><td class="line"><a name="378">378</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="379">379</a></td><td class="hits">1</td><td class="code">        if not actions:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="380">380</a></td><td class="hits">1</td><td class="code">            return empty_message</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="381">381</a></td><td class="hits">1</td><td class="code">        indentation &#61; utils.calculate_list_indent(actions)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="382">382</a></td><td class="hits">1</td><td class="code">        max_chars &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="383">383</a></td><td class="hits">1</td><td class="code">        if one_line:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="384">384</a></td><td class="hits">1</td><td class="code">            terminal_width &#61; shutil.get_terminal_size().columns</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="385">385</a></td><td class="hits">1</td><td class="code">            max_chars &#61; terminal_width - indentation - len(&#34;. &#34;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="386">386</a></td><td class="hits">1</td><td class="code">        dry_run_actions &#61; list()</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="387">387</a></td><td class="hits">1</td><td class="code">        for count, action in enumerate(actions):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="388">388</a></td><td class="hits">1</td><td class="code">            msg &#61; action.generate_log_for_action(max_chars, completed)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="389">389</a></td><td class="hits">1</td><td class="code">            dry_run_actions.append(f&#34;{count&#43;1:{indentation}d}. {msg}&#34;)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="390">390</a></td><td class="hits">1</td><td class="code">        return &#34;\n&#34;.join(dry_run_actions)</td></tr><tr class="noCover"><td class="line"><a name="391">391</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="392">392</a></td><td class="hits">1</td><td class="code">    def _tabulate_planned_changes(</td></tr><tr class="noCover"><td class="line"><a name="393">393</a></td><td class="hits"></td><td class="code">        self, dataclass: CSVDataclass, selected_columns, maxcolwidths&#61;16</td></tr><tr class="noCover"><td class="line"><a name="394">394</a></td><td class="hits"></td><td class="code">    ):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="395">395</a></td><td class="hits">1</td><td class="code">        table_data &#61; self.with_data_type(dataclass)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="396">396</a></td><td class="hits">1</td><td class="code">        if not table_data:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="397">397</a></td><td class="hits">1</td><td class="code">            return</td></tr><tr class="noCover"><td class="line"><a name="398">398</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="399">399</a></td><td class="hits">1</td><td class="code">        rows &#61; [row.as_table_row(selected_columns) for row in table_data.as_list()]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="400">400</a></td><td class="hits">1</td><td class="code">        return tabulate(</td></tr><tr class="noCover"><td class="line"><a name="401">401</a></td><td class="hits"></td><td class="code">            rows,</td></tr><tr class="noCover"><td class="line"><a name="402">402</a></td><td class="hits"></td><td class="code">            [&#34;action&#34;] &#43; selected_columns,</td></tr><tr class="noCover"><td class="line"><a name="403">403</a></td><td class="hits"></td><td class="code">            # table_data[0].table_header()[:len([&#39;action&#39;] &#43; selected_columns)],</td></tr><tr class="noCover"><td class="line"><a name="404">404</a></td><td class="hits"></td><td class="code">            maxcolwidths&#61;maxcolwidths,</td></tr><tr class="noCover"><td class="line"><a name="405">405</a></td><td class="hits"></td><td class="code">        )</td></tr><tr class="noCover"><td class="line"><a name="406">406</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="407">407</a></td><td class="hits">1</td><td class="code">    def save_changes(self, netdot_repo: &#34;netdot.Repository&#34;):</td></tr><tr class="noCover"><td class="line"><a name="408">408</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;Save the changes back to Netdot.</td></tr><tr class="noCover"><td class="line"><a name="409">409</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="410">410</a></td><td class="hits"></td><td class="code">        &gt; Important: If an action cannot be completed for some reason, you might want to</td></tr><tr class="noCover"><td class="line"><a name="411">411</a></td><td class="hits"></td><td class="code">            1. The action that failed is available via :func:&#96;failed_action()&#96;</td></tr><tr class="noCover"><td class="line"><a name="412">412</a></td><td class="hits"></td><td class="code">            2. All completed actions are available via :func:&#96;completed_as_list()&#96;</td></tr><tr class="noCover"><td class="line"><a name="413">413</a></td><td class="hits"></td><td class="code">            3. All remaining (incomplete) actions are available via :func:&#96;as_list()&#96;</td></tr><tr class="noCover"><td class="line"><a name="414">414</a></td><td class="hits"></td><td class="code">            this method may have completed some changes but the remaining changes will be skipped.</td></tr><tr class="noCover"><td class="line"><a name="415">415</a></td><td class="hits"></td><td class="code"></td></tr><tr class="noCover"><td class="line"><a name="416">416</a></td><td class="hits"></td><td class="code">        Args:</td></tr><tr class="noCover"><td class="line"><a name="417">417</a></td><td class="hits"></td><td class="code">            netdot_repo (netdot.Repository): The repository to use when saving changes.</td></tr><tr class="noCover"><td class="line"><a name="418">418</a></td><td class="hits"></td><td class="code">        &#34;&#34;&#34;</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="419">419</a></td><td class="hits">1</td><td class="code">        save_functions &#61; {<!-- --></td></tr><tr class="noCover"><td class="line"><a name="420">420</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.UPDATE: lambda action: netdot_repo.update(</td></tr><tr class="noCover"><td class="line"><a name="421">421</a></td><td class="hits"></td><td class="code">                action.new_data,</td></tr><tr class="noCover"><td class="line"><a name="422">422</a></td><td class="hits"></td><td class="code">            ),</td></tr><tr class="noCover"><td class="line"><a name="423">423</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.CREATE: lambda action: netdot_repo.create_new(</td></tr><tr class="noCover"><td class="line"><a name="424">424</a></td><td class="hits"></td><td class="code">                action.new_data</td></tr><tr class="noCover"><td class="line"><a name="425">425</a></td><td class="hits"></td><td class="code">            ),</td></tr><tr class="noCover"><td class="line"><a name="426">426</a></td><td class="hits"></td><td class="code">            actions.ActionTypes.DELETE: lambda action: netdot_repo.delete(</td></tr><tr class="noCover"><td class="line"><a name="427">427</a></td><td class="hits"></td><td class="code">                action.old_data, confirm&#61;False, ignore_404&#61;False</td></tr><tr class="noCover"><td class="line"><a name="428">428</a></td><td class="hits"></td><td class="code">            ),</td></tr><tr class="noCover"><td class="line"><a name="429">429</a></td><td class="hits"></td><td class="code">        }</td></tr><tr class="noCover"><td class="line"><a name="430">430</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="431">431</a></td><td class="hits">1</td><td class="code">        def save_change(action: &#34;actions.NetdotAction&#34;, one_line&#61;True):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="432">432</a></td><td class="hits">1</td><td class="code">            max_chars &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="433">433</a></td><td class="hits">1</td><td class="code">            if one_line:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="434">434</a></td><td class="hits">1</td><td class="code">                max_chars &#61; shutil.get_terminal_size().columns</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="435">435</a></td><td class="hits">1</td><td class="code">            save_function &#61; save_functions[action.action_type]</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="436">436</a></td><td class="hits">1</td><td class="code">            logger.info(action.generate_log_for_action(truncate&#61;max_chars))</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="437">437</a></td><td class="hits">1</td><td class="code">            result &#61; save_function(action)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="438">438</a></td><td class="hits">1</td><td class="code">            logger.info(</td></tr><tr class="noCover"><td class="line"><a name="439">439</a></td><td class="hits"></td><td class="code">                action.generate_log_for_action(truncate&#61;max_chars, completed&#61;True)</td></tr><tr class="noCover"><td class="line"><a name="440">440</a></td><td class="hits"></td><td class="code">            )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="441">441</a></td><td class="hits">1</td><td class="code">            return result</td></tr><tr class="noCover"><td class="line"><a name="442">442</a></td><td class="hits"></td><td class="code"></td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="443">443</a></td><td class="hits">1</td><td class="code">        if self._lock.acquire(blocking&#61;False):</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="444">444</a></td><td class="hits">1</td><td class="code">            try:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="445">445</a></td><td class="hits">1</td><td class="code">                for action in tqdm(list(self._actions)):</td></tr><tr class="noCover"><td class="line"><a name="446">446</a></td><td class="hits"></td><td class="code">                    # Remove action before performing it.</td></tr><tr class="noCover"><td class="line"><a name="447">447</a></td><td class="hits"></td><td class="code">                    # ! Why? Ensure that action will not be performed twice.</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="448">448</a></td><td class="hits">1</td><td class="code">                    self._actions.remove(action)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="449">449</a></td><td class="hits">1</td><td class="code">                    self._action_in_progress &#61; action</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="450">450</a></td><td class="hits">1</td><td class="code">                    response &#61; save_change(action)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="451">451</a></td><td class="hits">1</td><td class="code">                    self._action_in_progress &#61; None</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="452">452</a></td><td class="hits">1</td><td class="code">                    self._completed_actions.append(action)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="453">453</a></td><td class="hits">1</td><td class="code">                    self._responses.append(response)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="454">454</a></td><td class="hits">1</td><td class="code">            except Exception as e:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="455">455</a></td><td class="hits">1</td><td class="code">                self._failed_actions.append(self._action_in_progress)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="456">456</a></td><td class="hits">1</td><td class="code">                self._failed_actions_exceptions.append(e)</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="457">457</a></td><td class="hits">1</td><td class="code">                logger.exception(</td></tr><tr class="noCover"><td class="line"><a name="458">458</a></td><td class="hits"></td><td class="code">                    f&#34;&#34;&#34;Failed to save changes to Netdot. Summary: {len(self._completed_actions)} completed actions, {len(self._actions)&#43;1} remaining actions, including failed action: {self._action_in_progress}</td></tr><tr class="noCover"><td class="line"><a name="459">459</a></td><td class="hits"></td><td class="code">To learn more, use the &#39;status_report()&#39; method.</td></tr><tr class="noCover"><td class="line"><a name="460">460</a></td><td class="hits"></td><td class="code">&#34;&#34;&#34;</td></tr><tr class="noCover"><td class="line"><a name="461">461</a></td><td class="hits"></td><td class="code">                )</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="462">462</a></td><td class="hits">1</td><td class="code">                raise e</td></tr><tr class="noCover"><td class="line"><a name="463">463</a></td><td class="hits"></td><td class="code">            finally:</td></tr><tr class="coverFull" data-html-tooltip="Covered at least once"><td class="line"><a name="464">464</a></td><td class="hits">1</td><td class="code">                self._lock.release()</td></tr><tr class="noCover"><td class="line"><a name="465">465</a></td><td class="hits"></td><td class="code">        else:</td></tr><tr class="coverNone" data-html-tooltip="Not covered"><td class="line"><a name="466">466</a></td><td class="hits">0</td><td class="code">            raise RuntimeError(&#34;Unable to acquire lock for save_changes()&#34;)</td></tr>